<?php
 /**
      Funções auxiliares para a publicação de IPs
      Data : 07/08/2013
	  Atualizado em: 14/09/2019
      Autor: Alexandre P. Trindade
	  Versão 2.0

      Script para publicação de IP do sistem 100ip.com.br
      Funções de apoio.
	  
	  A Versão 2.0 não utiliza a API do CPanel
  */

uses("o_xml");
// $DOMINIO = "https://galileu.unsvr.com:2087";
// $DOMINIO = "https://kepler.unsvr.com:2087";
$DOMINIO = "https://newton.unsvr.com:2087";



/**
 * confere no banco de dados se a senha confere e se o ip precisa ser realmente alterado
 *
 * @global type $connexObj
 * @global type $IP_CALLER
 * @param string $dn Nome do dominio
 * @param string $pw Senha do usuário
 * @return boolean
 * Retorna true se o domínio estiver cadastrado, a senha estiver ok e o IP for diferente do cadastrado
 */
function needUpdate($dn,$pw){
   global $connexObj;
   global $IP_CALLER;
   global $LAST_ERROR;
   $result = false;

   $Q = new uMySQLQuery();
   $Q->conexao = $connexObj->conn;
   $Q->SQLAdd("SELECT * FROM dns_lista");
   $Q->SQLAdd(" WHERE dns_nome='$dn' and dns_chave='$pw'");

   $r = $Q->Open();
   if ($r && $Q->RecordCount() > 0){
      $ip_atual = $Q->FieldValue('dns_ip');
      $result = ($Q->FieldValue('dns_ip') != $IP_CALLER);
   }else if (!$r){
      // Erro de sql
      $LAST_ERROR = $Q->lastError;
   }else{
      // Domínio não encontrado - não esta cadastrado ou a senha esta errada
      $LAST_ERROR = 'Domínio não cadastrado ou senha inválida.';
   }
   $Q->Close();

   return $result;
}

/**
 * Atualiza o IP no banco de dados
 *
 * @global type $connexObj
 * @global type $IP_CALLER
 * @param string $dn nome do dominio para atualização de IP
 */
function updateDB($dn, $ip){
   global $connexObj;
   global $LAST_ERROR;
   $result = false;

   $sql  = "UPDATE dns_lista SET
              dns_ip='$ip',
              dns_dtatualiz = CURRENT_TIMESTAMP
            WHERE dns_nome='$dn' LIMIT 1";

   $r = mysql_query($sql, $connexObj->conn);
   if ($r){
     $result = true;
   }else{
     $LAST_ERROR = mysql_error();
   }

   return $result;
}

/**
 * Grava solicitação de alteração do registro de DNS do subdomínio.
 * O registro será atualizado pelo serviço semipedit no servidor newton.unsvr.com
 * @param string $name Nome completo do subdomínio
 * @param string $IP novo IP atribuido
*/
function atualizaZonaDNS($name, $IP){
    global $LAST_ERROR;
    $LAST_ERROR = "";
    
    $a = explode(".", $name);
    if (is_array($a) && isset($a[0])){
        $fhand = fopen("../.cmd/_cmdin_/$name", "w");
            if ($fhand !== false){
                $data=$a[0]."|".$IP;
                fwrite($fhand, $data, strlen($data));
                fclose($fhand);
                return true;
            }else{
                $LAST_ERROR = "Erro  fopen: $name";
                return false;
            }
    }else{
        $LAST_ERROR = "Erro  atualizaZonaDNS(): Dominio inválido $name";
        return false;
    }
}


/**
 * Chamada padrão para API do WHM - Obsoleto
 *
 * @global string $LAST_ERROR
 * @global string $DOMINIO
 * @return string Retorna um trokem para acesso a API do WHM
 *
function WHM_API($api){
   global $LAST_ERROR;
   global $DOMINIO;

   $whmusername = "uniware";
   $whmpassword =  "2ABlb(8{X!Fi"; //"098hjkl*";

   $query =  "$DOMINIO/$api"; 

   $curl = curl_init($query);
   // verificar a validade do certificado ?
   curl_setopt($curl, CURLOPT_SSL_VERIFYPEER,0);

   //  verifica se a identidade do servidor bate com aquela informada no certificado
   curl_setopt($curl, CURLOPT_SSL_VERIFYHOST,0); // 2

   // Allow certs that do not match the hostname
   curl_setopt($curl, CURLOPT_HEADER,0);

   // Do not include header in output
   curl_setopt($curl, CURLOPT_RETURNTRANSFER,1);

   // Return contents of transfer on curl_exec
   $header[0] = "Authorization: Basic " . base64_encode($whmusername.":".$whmpassword) . "\n\r";

   curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
   // set the username and password
   curl_setopt($curl, CURLOPT_URL, $query);

   // execute the query
   $result = curl_exec($curl);
   if ($result == false) {
      $LAST_ERROR = "curl_exec threw error \"" . curl_error($curl) . "\" for $query";
   }
   curl_close($curl);

   return $result;
}
*/


// exemplo chamada:
// https://216.180.232.42:2087/cpsess5173500320/xml-api/dumpzone?domain=100ip.com.br

/**
 *  retorna um xml a lista de zonas DNS (subdomínios)
 *  - (Versão CPanel API - Obsoleta)
function getListZones($token=""){
   global $DOMINIO;

   $result = WHM_API("xml-api/dumpzone?domain=100ip.com.br");

   // testa se o resultado é um xml
   if (!empty($result) && strpos($result,'<?xml') === false){
      if (strpos($result,'<dumpzone>')===false){
         $result = false;
      }else{
         $result = "<?xml version=\"1.0\"  encoding=\"UTF-8\" ?>\r\n$result";
      }
   }

   return $result;
}
*/

/** verifica qual é o número da linha que contem o registro
 * da zona solicitada - (Versão CPanel API - Obsoleta)
 *
 * @param string $token Buffer para receber o token da conexão
 * @param string $dn
 *
 * @return int
 * Número da linha correspondente ao registro da zona (nome)
 * solicitado ou false em caso de falha
 *

function getNameLine($dn){
  $resul = false;
  $xmlStr =  getListZones();

  // DEBUG
  save_log("DEBUG getNameLine(1)  'xmlStr'", $xmlStr);

  $XML = new uXML();
  $XML->loadFromString($xmlStr);

  $nodeLista = $XML->xmlDoc->itemByName("result");
  if ($nodeLista !== false){
     $i = 0;
     while (!$result && $i < $nodeLista->count()){
        $record = $nodeLista->childs[$i];
        $nome = $record->itemValue("name","[vazio]");
        $tipo = $record->itemValue("type","[vazio]");
        if ($nome == "$dn." && $tipo=="A"){
           $result = $record->itemValue("Line",false);
        }
        $i +=1;
     }
  }
  return $result;
}
*/

/**
 * Atualiza Zona DNS  (Versão CPanel API - Obsoleta)
 *
 * @param string $token Token da conexão
 * @param int $line Número da linha (índice de registro) a ser alterada
 * @param string $addr Novo IP
 * @return boolean
 *
function atualizaZonaDNS($line,$addr,&$outMsg){
   global $DOMINIO;
   $result = false;
   $api = "xml-api/editzonerecord?domain=100ip.com.br&line=$line&&address=$addr&type=A&ttl=5";
   $result = WHM_API($api);

  // DEBUG
  save_log("DEBUG atualizaZonaDNS(2)  'xmlStr'", $result );

  $XML = new uXML();
  $XML->loadFromString($result);

  $res = $XML->xmlDoc->itemByName("result");
  if ($res !== false){
     $result = (1 == $res->itemValue("status","-1"));
     $outMsg = $res->itemValue("statusmsg","");
  }

  return $result;
}
*/

/**
 *  Grava Log para depuração
 */
 
 function save_log($logId,$logData){
	 // $fhand = fopen("./debug_data.log","a");
	 $text = $logId."\r\n================================================================\r\n";
	 echo $text;
	 $text = $logData."\r\n";
	 echo $text;
	 
	 /*
	 if ($fhand !== false){
		if (fwrite(fhand, $logId."\r\n================================================================\r\n") !== false){
			fwrite(fhand,$logData."\r\n"); 
		} 
		
		fclose($fhand);
	 }
	 */
 }
 
 
 
 
