<?php
/**
 * Autor: Alexandre P. Trindade
 * Data.: 12/06/2013
 *
 * Clases bsicas de uso geral
 */

/**
 * Fornece informaes da URL usada para chamar o script
 */
class xUrl{
   /**
    * Restorna o protocolo em uso
    * @var string protocol
    */
   public $protocol;
   /**
    * Retorna o host/domnio
    * @var string
    */
   public $host;
   /**
    * Caminho relativo para o script
    * @var string
    */
   public $script;
   /**
    * parametros passados por get na url
    * @var string
    */
   public $parameters;

   function xUrl(){
       $this->protocol = (strpos(strtolower($_SERVER['SERVER_PROTOCOL']), 'https') === false) ? 'http' : 'https';
       $this->host = $_SERVER['HTTP_HOST'];
       $this->script = $_SERVER['SCRIPT_NAME'];
       $this->parameters = $_SERVER['QUERY_STRING'];
   }

   /**
    * Retorna a Url simples
    * @return string
    */
   public function singleURL(){
      return $this->protocol."://".$this->host.$this->script;
   }

   /**
    * Retorna a Url completa com os parametros passados
    * @return string
    */
   public function fullURL(){
      if (!empty($this->parameters)){
        return $this->protocol."://".$this->host.$this->script."?".$this->parameters;
      }else{
        return $this->protocol."://".$this->host.$this->script;
      }
   }

   /**
    * Indica se existe ou no parmetros na URL de chamada
    * @return boolean
    */
   public function hasParam(){
      return (!empty($this->parameters));
   }
}

global $xURL;

$xURL = new xUrl();
?>