<?php
/*
 * Programa    : ODBC
 * Objetivo    : Conexo com o ODBC - similar ao java
 * Programador : Joo Gustavo Ferreira Farias 
 * Data Incio : 23 de junho de 2003 - segunda-feira
 * Data Trmino: 23 de junho de 2003 - segunda-feira
 */
 
class  ODBCConnection {
	var $conn       = null;
	var $msg	= "";
	
	function ODBCConnection($user, $pass, $dsn) {
		$this->conn = @odbc_connect($dsn, $user, $pass) or die("ODBC-Erro na conexo com o banco: " . odbc_error());
	}

	function getConnection() {
		return $this->conn;
	}
	
	function executeQuery($sql) {
		$stmt = odbc_exec( $this->conn, $sql) or die("ODBC-Erro no Query [$sql]");
        $rs  = new ODBCResultSet($stmt);
		return $rs;
	}
	
	function executeUpdate($sql) {
		$nr = odbc_exec($sql, $this->conn) or die("ODBC-Erro no Update [$sql]");
		return odbc_num_rows($nr);
	}
	
	function execute($sql) {
	}

	function commit() {
	    odbc_commit($this->conn);
	}
	
	function rollback() {
	    odbc_rollback($this->conn);
	}

}

class ODBCResultSet {
	var $rs;

	function ODBCResultSet($rs) {
		$this->rs = $rs;
	}
	
	function next() {
        return odbc_fetch_row($this->rs);
	}
	
	function getResult($name) {
		$value = odbc_result($this->rs,$name);
        return $value;
	}
	
	function getFetchSize() {
		return odbc_num_rows($this->rs);
	}
	
	
	function getNumCols() {
		return odbc_num_fields($this->rs);
	}
	
	function getResultSet() {
	}
	
	function getArraySet($table="") {
		$arr = array();
       while (odbc_fetch_row($this->rs)) {
             $row = array();
             for ($x=1; $x<= odbc_num_fields($this->rs); $x++) {
                  $row[odbc_field_name($this->rs,$x)] = odbc_result($this->rs,$x);
             }
             array_push($arr, $row);
       }
		return $arr;
	}

}


?>
