<?php
/*
 * Programa      : Oracle 8
 * Objetivo      : Conexo com o Oracle - similar ao java
 * Programador   : Joo Gustavo Ferreira Farias
 * Data Incio   : 23 de agosto de 2002 - sexta-feira
 * Data Trmino  : 23 de agosto de 2002 - sexta-feira
 * Data Alterao: junho 2003
 *               : includo a funo execute() para executar store procedures/functions
 * Data Alterao: 19 de julho de 2003 - sbado
 *               : colocando mensagens e tratamento de erro
 */
 
class Connection {
	var $conn       = null;
	var $error;
	
	function Connection($host, $user, $pass) { //r:constructor
		$this->conn = OCIPLogon($user, $pass, $host) or
                die ("Erro na conexo! Por favor, entre em contato com o Administrador - 1122.");
	}

	function getConnection() {
		return $this->conn;
	}
	
	function executeQuery($sql) {
		$stmt = @OCIParse($this->conn,$sql) or die("Erro no Query.");
		OCIExecute($stmt, OCI_DEFAULT) or die("Erro na execuo do Query. $sql");
		$rs = new ResultSet($stmt);
		return $rs;
	}
	
	function executeUpdate($sql) {
		$stmt        = @OCIParse($this->conn,$sql) or die ("Erro no Update.");
		$resultado   = @OCIExecute($stmt, OCI_DEFAULT);
		$this->error = @OCIError($stmt);
		if ($resultado) {
           return OCIRowCount($stmt);
        }
		return 0;
	}
	
	function execute($sql) {
        $num_args = func_num_args();
        $arg_list = func_get_args();
        $stmt = OCIParse($this->conn,$sql);
		for ($i = 1; $i < $num_args; $i++) {
            $value = $arg_list[$i];
            global $$value;
            OCIBindByName($stmt, ":".$value, $$value, 30);
        }
		$nr   = @OCIExecute($stmt,OCI_DEFAULT);
		return $nr;
	}

    function getError() {
        if (!isset($this->error['code'])) {return "";}
        preg_match("/\.(.*)\)/", $this->error['message'],$matches);
        if (isset($matches[1])) {
            $constraint = $matches[1];

            $sql = "select * from user_cons_columns where constraint_name='$constraint'";
            $rs  = $this->executeQuery($sql);
            $campos = "";
            $count = 0;
            while ($rs->next()) {
                 $campos .= $rs->getResult('COLUMN_NAME').", "; $count++;
            }
            $campos      = substr($campos,0, strlen($campos)-2);
        }
        switch ($this->error['code']) {
            case 0001 :
                        if ($count >1)
                            return "ATENO!<br> Registro no pode ser inserido!  Os valores dos campos $campos j esto sendo utilizados.";
                        else
                            return "ATENO!<br> Registro no pode ser inserido!  O valor) do campo $campos j est sendo utilizado.";
                        break;
            case 2292 :
                        if ($count >1)
                            return "ATENO!<br> Este registro no pode ser removido!  Os campos $campos deste registros esto sendo utilizados por outra tabela.";
                        else
                            return "ATENO!<br> Este registro no pode ser removido!  O campo $campos deste registro est sendo utilizado por outra tabela.";
                        break;
            default:
                       return  $this->error['message'];
                       break;
        }
    }

	function commit() {
		OCICommit($this->conn);
	}
	
	function rollback() {
		OCIRollback($this->conn);
	}

}

class ResultSet {
	var $rs;
	var $nc = 0;

	function ResultSet(&$rs) {
		$this->rs = $rs;
		$this->nc = OCINumCols($rs);
	}
	
	function next() {
		return OCIFetch($this->rs);
	}
	
	function getResult($name) {
		$value = OCIResult($this->rs, strtoupper($name));
        return $value;
		
	}
	
	function getFetchSize() {
		return OCIRowCount($this->rs);
	}
	
	
	function getNumCols() {
		return $this->nc;
		//r:return OCINumCols($this->rs);
	}
	
	function getResultSet() {
		return $this->rs;
	}
	
	function getArraySet($table="") {
		$arr = array();
	 	ocifetchstatement($this->rs, $arr, 0, -1, OCI_FETCHSTATEMENT_BY_ROW);
		return $arr;
	}
	

	function getArraySetNavigator($step=100, $pg_atual=1) {
		$arr  = array();
        $cont = 0;
        
        $pg_atual = $pg_atual == "" ? 1 : $pg_atual;
        $ini  = ($pg_atual-1)*$step;

        ocisetprefetch($this->rs, 10000);
        $fetch = ocifetchstatement($this->rs, $arr, $ini, $step, OCI_FETCHSTATEMENT_BY_ROW);

        $GLOBALS['PREVIUS_PAGE'] = ($pg_atual > 1)     ?  $pg_atual-1 : 0;
        $GLOBALS['NEXT_PAGE']    = ($fetch < $step)    ?  0: $pg_atual+1 ;
		return $arr;
	}

	function free() {
        ocifreestatement($this->rs);
	}

}


?>
