<?php
/*
   Funes para manipulaao de data.
   Autor.: Alexandre P. Trindade
   Inicio: 15/09/2004 
   Copyright Uniware Informtica
*/

  //r: Valida uma string de data no formato Timestamp ("YYYYMMDDhhmmss")
  function TS_VaidDate($ts_data){
	if (strlen($ts_data) == 14){
	   $hora = substr($ts_data,8,2);
	   $min  = substr($ts_data,10,2);
	   $seg  = substr($ts_data,12,2);
	   $dia  = substr($ts_data,6,2);
	   $mes  = substr($ts_data,4,2);
	   $ano  = substr($ts_data,0,4);

		$dr = date("YmdHis", mktime($hora,$min,$seg,$mes,$dia,$ano));
		return ($dr == $ts_data);
	}else{
	    return false;
	}
  }

  //r: Valida string Data BR  (formato "dd-mm-yyyy")
  function BR_ValidDate($br_data){
	if (strlen($br_data) == 10){
	   $sep  = substr($br_data,2,1);
	   $dia  = substr($br_data,0,2);
	   $mes  = substr($br_data,3,2);
	   $ano  = substr($br_data,6,4);

		$dr = date("d".$sep."m".$sep."Y", mktime(0,0,0,$mes,$dia,$ano) );
		return ($dr == $br_data);
	}else{
	    return false;
	}
  }

  //r: Valida string Data BR  (formato "mm-dd-yyyy")
  function US_ValidDate($us_data){
	if (strlen($ts_data) == 10){
	   $sep  = substr($us_data,2,1);
	   $mes  = substr($us_data,0,2);
	   $dia  = substr($us_data,3,2);
	   $ano  = substr($us_data,6,4);

		$dr = date("d".$sep."m".$sep."Y", mktime(0,0,0,$mes,$dia,$ano) );
		return ($dr == $us_data);
	}else{
	    return false;
	}
  }

  function EncodeDate($ano,$mes,$dia=0,$hora=0,$min=0,$seg=0){
     return  mktime($hora,$min,$seg,$mes,$dia,$ano,-1); 
  }

  //r: Converte uma string de data BR ("dd-mm-yyyy" ou "dd-mm-yyyy hh:mm:ss") para Data (timestamp Unix)
  function IncDateTimeBR($br_data,$incval,$inc_op){
	   $ret  = -1;
	   $inc_op = strtoupper($inc_op);

	   $dia  = substr($br_data,0,2);
	   $mes  = substr($br_data,3,2);
	   $ano  = substr($br_data,6,4);

	   $hora = (substr($br_data,11,2) !== false) ? substr($br_data,11,2):0;
	   $min  = (substr($br_data,14,2) !== false) ? substr($br_data,14,2):0;
	   $seg  = (substr($br_data,17,2) !== false) ? substr($br_data,17,2):0;
      
       if (strlen($br_data == 10)) {
	      $ret_formato = "d/m/Y";
	   }else{
	      $ret_formato = "d/m/Y H:i:s";
	   }

	   switch ($inc_op) {
	      case "ANO"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia,$ano + $incval,-1);
		      break;
	      case "MES"  :
			  $ret =  mktime($hora,$min,$seg,$mes + $incval,$dia,$ano,-1);
		      break;
	      case "DIA"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia + $incval,$ano,-1);
		      break;
	      case "HORA"  :
			  $ret =  mktime($hora + $incval,$min,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "MIN"  :
			  $ret =  mktime($hora,$min + $incval,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "SEG"  :
			  $ret =  mktime($hora,$min,$seg,$mes + $incval,$dia,$ano,-1);
		      break;
	   }

	   return $ret;
  }

  //r: Decrementa uma string de data e hora BR ("dd-mm-yyyy hh:mm:ss") para Data (timestamp Unix)
  function DecDateTimeBR($br_data,$decval,$dec_op){
	   $ret  = -1;
	   $dec_op = strtoupper($dec_op);

	   $dia  = substr($br_data,0,2);
	   $mes  = substr($br_data,3,2);
	   $ano  = substr($br_data,6,4);

	   $hora = (substr($br_data,11,2) !== false) ? substr($br_data,11,2):0;
	   $min  = (substr($br_data,14,2) !== false) ? substr($br_data,14,2):0;
	   $seg  = (substr($br_data,17,2) !== false) ? substr($br_data,17,2):0;

       if (strlen($br_data == 10)) {
	      $ret_formato = "d/m/Y";
	   }else{
	      $ret_formato = "d/m/Y H:i:s";
	   }

	   switch ($dec_op) {
	      case "ANO"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia,$ano - $decval,-1);
		      break;
	      case "MES"  :
			  $ret =  mktime($hora,$min,$seg,$mes - $decval,$dia,$ano,-1);
		      break;
	      case "DIA"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia - $decval,$ano,-1);
		      break;
	      case "HORA"  :
			  $ret =  mktime($hora - $decval,$min,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "MIN"  :
			  $ret =  mktime($hora,$min - $decval,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "SEG"  :
			  $ret =  mktime($hora,$min,$seg - $decval,$mes,$dia,$ano,-1);
		      break;
	   }

	   return $ret;
  }

  function DaySecs(){ return 86400; }  //r: retorna o numero de segundos corrempondente a um dia.

  //r: Subtrai data2 de data1 retiornando o numero de dias de diferena entra as datas
  function SubDates($data1,$data2){
    $result = $data1 - $data2;
	$result = floor($result / DaySecs());
    return $result;
  }


  //r: Converte uma string de data BR ("dd-mm-yyyy") para Data (timestamp Unix)
  function StrToDateBR($br_data){
	if (strlen($br_data) == 10){
	   $dia  = substr($br_data,0,2);
	   $mes  = substr($br_data,3,2);
	   $ano  = substr($br_data,6,4);

	   return  mktime(0,0,0,$mes,$dia,$ano);
	}else{
	    return false;
	}
  }

  //r: Converte a string de data do MySQL (YYYY-MM-DD) para formato data.
  function MySQLDateToDate($sqlDate){
	if (strlen($sqlDate) == 10){
	   $dia  = substr($sqlDate,8,2);
	   $mes  = substr($sqlDate,5,2);
	   $ano  = substr($sqlDate,0,4);
	   return  mktime(0,0,0,$mes,$dia,$ano);
	}else{
	   return false;
	}
  }

  //r: Converte uma string de data ("dd-mm-aaaa" ou "DD-MM-AAAA hh:mm:ss") para uma string de data timestamp do MySQL ("AAAAMMDDhhmmss")
  function StrDateBrToMyTimestamp($br_data,$ins_hora="00:00:00"){
	if (strlen($br_data) == 10){
	   $dia  = substr($br_data,0,2);
	   $mes  = substr($br_data,3,2);
	   $ano  = substr($br_data,6,4);

       $hora = substr($ins_hora,0,2);
	   $min  = substr($ins_hora,3,2);
	   $seg  = substr($ins_hora,6,2);

	   return  $ano.$mes.$dia.$hora.$min.$seg;
	}else if (strlen($br_data) == 19){
	   $dia  = substr($br_data,0,2);
	   $mes  = substr($br_data,3,2);
	   $ano  = substr($br_data,6,4);

       $hora = substr($br_data,11,2);
	   $min  = substr($br_data,14,2);
	   $seg  = substr($br_data,17,2);

	   return  $ano.$mes.$dia.$hora.$min.$seg;
	}else{
	    return "";
	}
  }


  //r: Convete uma string Date Time BR ("dd-mm-yyyy hh:mm:ss") para data (timestamp Unix)
  function StrToDateTimeBR($br_date){
	if (strlen($ts_data) == 19){
	   $hora = substr($be_data,8,2);
	   $min  = substr($br_data,10,2);
	   $seg  = substr($br_data,12,2);
	   $dia  = substr($br_data,6,2);
	   $mes  = substr($br_data,4,2);
	   $ano  = substr($br_data,0,4);

		return  mktime($hora,$min,$seg,$mes,$dia,$ano,-1);
	}else{
	    return false;
	}
  }

  //r: Retorna o nmero correspondente ao ultimo dia do mes solicitado
  function LastDayMonth($mes,$ano){
     return date("d", mktime(0,0,0,$mes+1,0,$ano));
  }

  //r: Retorna a data e hora atual
  function now() {
     return date("Y-m-d H:i:s");
  }

  function MySQLDate(){
     return date("Y-m-d");
  }

  //r: Data e hora corrente no formato timestamp do MySQL
  function TS_CurrentDateTime(){
      return date("YmdHis");
  }

  function DateToMySQLTimestamp($pdata){
      return date("YmdHis",$pdata);
  }

  function MySqlTimestampToBrDateTime($tsdata){
	 if (strlen($tsdata) == 14){
        return  substr($tsdata,6,2) . "/" . substr($tsdata,4,2) . "/" . substr($tsdata,0,4) . " " . 
			    substr($tsdata,8,2) . ":" . substr($tsdata,10,2) . ":" . substr($tsdata,12,2);
	 }else{
		return false;
	 }
  }

  function now_br() {
     return date("d\/m\/Y H:i:s");
  }

  function date_br(){
     return date("d\/m\/Y");
  }

  function SQLDateFormat($SQLDate){
	if (empty($SQLDate) || $SQLDate == "NULL"){
	   $SQLDate = "1970-01-01";
	}
    list($ano,$mes,$dia) = explode("-",$SQLDate);
    return "$dia/$mes/$ano";
  }

  function DateBrToMySQLDate($DateBR){
    list ($dia, $mes, $ano, $hora) = split('[/-]', $DateBR, 4);
    return "$ano-$mes-$dia";
  }
/*
  Retorna o nome do mes.
  Parmetros:
     $nMes     - Nmero do ms solicitado. (1 a 12)
	 $lAbrev   - Flag de abreviao do nome.
	             valores:  
				     0 ou n"ao informado -> Nome completo
					 1 -> Nome abreviado.
*/  
 function NomeMes($nMes,$lAbrev) {
   $AMesL = array("Janeiro","Fevereiro","Maro","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro");
   $AMesC = array("Jan","Fev","Mar","Abr","Mai","Jun","Jul","Ago","Set","Out","Nov","Dez");
   if (($nMes > 0) && ($nMes < 13)) {
      $nMes--;
	  return ($lAbrev === 1)? $AMesC[$nMes]:$AMesL[$nMes];
   }else{
     return "Ms fora da faixa $nMes.";
   }
 }


/*
  Retorna o nome do dia da semana.
  Parmetros:
     $nDia     - Nmero do Dia da semana solicitado (0 a 6).
	 $lAbrev   - Flag de abreviao do nome.
	             valores:  
				     0 ou n"ao informado -> Nome completo
					 1 -> Nome abreviado.
*/
 function NomeDia($nDia,$lAbrev) {
   $ADiaL = array("domingo","segunda-feira","tera-feira","quarta-feira","quinta-feira","sexta-feira","sabado"); 
   $ADiaC = array("dom","seg","ter","quar","qui","sex","sab"); 
   if (($nDia >= 0) && ($nDia < 7)) {
	  return ($lAbrev === 1)? $ADiaC[$nDia]:$ADiaL[$nDia];
   }else{
     return "Dia da semana fora da faixa $nDia.";
   }
   
 }
 
 /*
     Formata data.
	 Parmetros ($StrFmt,$data):
	      $StrFmt     - String de formato (obrigatrio)
		  $data       - Data (no formato Timestamp) para formatao.
		                se $data no for informado ser utilizado a data e 
						hora corrente (hora local do servidor).
	Requer: 
	     NomeMes() -> Neste
		 NomeDia() -> neste
						
	Strings de formato vlidas para o parmetro $StrFmt:
	   "!yyyy"   - Ano com 4 digitos
	   "!y"      - Ano com 2 Digitos
	   "!mmmm"   - Nome (longo) do mes
	   "!mmm"    - Nome (abreviado) do mes
	   "!mm"     - Nmero do ms (01 a 12)
	   "!m"      - Nmero do Mes (1 a 12)
	   "!dddd"   - Nome (longo) do dia da semana
	   "!ddd"	 - Nome (abraviado) do dia da semana
	   "!dd"     - Dia do Ms (01 a 31)
	   "!d"      - Dia do Ms (1 a 31)
	   "!HH"     - Hora no formato (00 a 23)
	   "!H"      - Hora no formato (0 a 23)
	   "!hh"     - Hora no formato (00 a 12)
	   "!h"      - Hora no formato (0 a 12)
	   "!MM"     - Minutos (00 a 59) 
	   "!M"      - Minutos (0 a 59)
	   "!SS"     - Segundos (01 a 59)
	   "!S"      - Segundos (1 a 59)
 */
  function Format_Date() { //r:($StrFmt,$data)
	 $numargs = func_num_args();
     if ($numargs == 1) {
		$StrFmt = func_get_arg(0);
	    $dt     = time();
	 }else if ($numargs == 2){
		$StrFmt = func_get_arg(0);
	   $dt     = func_get_arg(1);
	 }else if ($numargs == 3){
	 
	 }else{
		$StrFmt = "";
	 }
    if ((!isset($StrFmt)) || (empty($StrFmt))) {
	    return "";
	 }else{
	    $StrFmt = str_replace("!yyyy",date("Y",$dt),$StrFmt); 
	    $StrFmt = str_replace("!yy",date("y",$dt),$StrFmt); 
	    $StrFmt = str_replace("!mmmm",NomeMes(date("n",$dt),0),$StrFmt); 
	    $StrFmt = str_replace("!mmm",NomeMes(date("n",$dt),1),$StrFmt); 
	    $StrFmt = str_replace("!mm",date("m",$dt),$StrFmt); 
	    $StrFmt = str_replace("!m",date("n",$dt),$StrFmt); 
	    $StrFmt = str_replace("!dddd",NomeDia(date("w",$dt),0),$StrFmt); 
	    $StrFmt = str_replace("!ddd",NomeDia(date("w",$dt),1),$StrFmt); 
	    $StrFmt = str_replace("!dd",date("d",$dt),$StrFmt); 
	    $StrFmt = str_replace("!d",date("j",$dt),$StrFmt);
	    $StrFmt = str_replace("!HH",date("H",$dt),$StrFmt);
	    $StrFmt = str_replace("!H",date("G",$dt),$StrFmt);
	    $StrFmt = str_replace("!hh",date("h",$dt),$StrFmt);
	    $StrFmt = str_replace("!h",date("g",$dt),$StrFmt);
	    $StrFmt = str_replace("!MM",date("i",$dt),$StrFmt);
	    $StrFmt = str_replace("!M",(date("i",$dt)+1-1),$StrFmt);
	    $StrFmt = str_replace("!SS",date("s",$dt),$StrFmt);
	    $StrFmt = str_replace("!S",(date("s",$dt)+1-1),$StrFmt);
		
		return $StrFmt;
	 }
  }


?>
