<?php
  /*
     Funes de controle de data e hora.
	 Este mdulo tem como finalidade substituir o modulo lib_date.php

	 Programador: Alexandre P. Trindade
	 Data: 19/01/2006

  */

  /**************************************************************
   * Claculos com data 
   **************************************************************/

  //r: Decrementa data (formato dataUnix)
  function DecDateTime($date,$decval,$dec_op){
	   $ret  = -1;
	   $dec_op = strtoupper($dec_op);

	   $dia  = date("d",$date);
	   $mes  = date("m",$date);
	   $ano  = date("Y",$date);

	   $hora = date("H",$date);
	   $min  = date("i",$date);
	   $seg  = date("s",$date);

	   switch ($dec_op) {
	      case "ANO"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia,$ano - $decval,-1);
		      break;
	      case "MES"  :
			  $ret =  mktime($hora,$min,$seg,$mes - $decval,$dia,$ano,-1);
		      break;
	      case "DIA"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia - $decval,$ano,-1);
		      break;
	      case "HORA"  :
			  $ret =  mktime($hora - $decval,$min,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "MIN"  :
			  $ret =  mktime($hora,$min - $decval,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "SEG"  :
			  $ret =  mktime($hora,$min,$seg - $decval,$mes,$dia,$ano,-1);
		      break;
	   }

	   return $ret;
  }

  //r: incrementa data (formato dataUnix)
  function IncDateTime($date,$decval,$dec_op){
	   $ret  = -1;
	   $dec_op = strtoupper($dec_op);

	   $dia  = date("d",$date);
	   $mes  = date("m",$date);
	   $ano  = date("Y",$date);

	   $hora = date("H",$date);
	   $min  = date("i",$date);
	   $seg  = date("s",$date);

	   switch ($dec_op) {
	      case "ANO"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia,$ano + $decval,-1);
		      break;
	      case "MES"  :
			  $ret =  mktime($hora,$min,$seg,$mes + $decval,$dia,$ano,-1);
		      break;
	      case "DIA"  :
			  $ret =  mktime($hora,$min,$seg,$mes,$dia + $decval,$ano,-1);
		      break;
	      case "HORA"  :
			  $ret =  mktime($hora + $decval,$min,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "MIN"  :
			  $ret =  mktime($hora,$min + $decval,$seg,$mes,$dia,$ano,-1);
		      break;
	      case "SEG"  :
			  $ret =  mktime($hora,$min,$seg + $decval,$mes,$dia,$ano,-1);
		      break;
	   }
	   return $ret;
  }

  function DaySecs($n = 1){ return 86400 * $n; }  //r: retorna o numero de segundos corrempondente a um dia.

  //r: Subtrai data2 de data1 retiornando o numero de dias de diferena entra as datas
  function SubDates($data1,$data2){
    $result = $data1 - $data2;
	$result = floor($result / DaySecs());
    return $result;
  }

  /**************************************************************
  *   Montagem de data e hora
  **************************************************************/
  function MakeDate($ano,$mes,$dia=0){
     return  mktime(0,0,0,$mes,$dia,$ano,-1); 
  }
  function MakeTime($hora=0,$min=0,$seg=0){
     return  mktime($hora,$min,$seg,0,0,0,-1); 
  }
  function MakeDateTime($ano,$mes,$dia=0,$hora=0,$min=0,$seg=0){
     return  mktime($hora,$min,$seg,$mes,$dia,$ano,-1); 
  }
  
  /**************************************************************
  *   Converses
  **************************************************************/

  /* Converte uma string de data para Data (timestamp Unix)
     *fmt indica o formato no qual a string informada est
	 e pode ser:
	   "dtdb"      =  yyyy-mm-dd           * Data do banco de dados (MySQL)
	   "dtbr"      =  dd-mm-yyyy           * Data no formato brasileiro
	   "dten"      =  mm-dd-yyyy           * Data no formato americano
	   "tsbr"      =  dd-mm-yyyy hh:mm:ss  * Data e hora formato brasileiro
       "tsdb"      =  yyyymmddhhmmss       * Timestamp de banco de dados
  */
  function StrToDate($str_data,$fmt = "dtdb"){
	$a_pos = array();
	switch ($fmt){
	   case "dtdb" :
	           $a_pos = array("dia" => array(8,2),"mes" => array(5,2),"ano" => array(0,4),"hora"  => array(0,0),"min"  => array(0,0),"seg"  => array(0,0));
	           break;
	   case "dtbr" :
	           $a_pos = array("dia" => array(0,2),"mes" => array(3,2),"ano" => array(6,4),"hora"  => array(0,0),"min"  => array(0,0),"seg"  => array(0,0));
	           break;
	   case "dten" :
	           $a_pos = array("dia" => array(3,2),"mes" => array(0,2),"ano" => array(6,4),"hora"  => array(0,0),"min"  => array(0,0),"seg"  => array(0,0));
	           break;
	   case "tsbr" :
	           $a_pos = array("dia" => array(0,2),"mes" => array(4,2),"ano" => array(6,4),"hora"  => array(11,2),"min"  => array(14,2),"seg"  => array(17,2));
	           break;
	   case "tsdb" :
	           $a_pos = array("dia" => array(6,2),"mes" => array(4,2),"ano" => array(0,4),"hora"  => array(8,2),"min"  => array(10,2),"seg"  => array(12,2));
	           break;
	}
	if (count($a_pos) > 0){
	   $dia  = substr($str_data, $a_pos["dia"][0],$a_pos["dia"][1]);
	   $mes  = substr($str_data, $a_pos["mes"][0],$a_pos["mes"][1]);
	   $ano  = substr($str_data, $a_pos["ano"][0],$a_pos["ano"][1]);

       $hora = substr($str_data, $a_pos["hora"][0],$a_pos["hora"][1]);
	   $min  = substr($str_data, $a_pos["min"][0],$a_pos["min"][1]);
	   $seg  = substr($str_data, $a_pos["seg"][0],$a_pos["seg"][1]);

	   return  mktime(0,0,0,$mes,$dia,$ano);
	}else{
	    return false;
	}
  }

  /*
     Diversas
  */

  //r: Retorna o nmero correspondente ao ultimo dia do mes solicitado
  function LastDayMonth($mes,$ano){
     return date("d", mktime(0,0,0,$mes+1,0,$ano));
  }

  /*
   Retorna o nome do mes.
   Parmetros:
     $nMes     - Nmero do ms solicitado. (1 a 12)
	 $lAbrev   - Flag de abreviao do nome.
	             valores:  
				     0 ou n"ao informado -> Nome completo
					 1 -> Nome abreviado.
  */  
  function NomeMes($nMes,$lAbrev) {
    $AMesL = array("Janeiro","Fevereiro","Maro","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro");
    $AMesC = array("Jan","Fev","Mar","Abr","Mai","Jun","Jul","Ago","Set","Out","Nov","Dez");
    if (($nMes > 0) && ($nMes < 13)) {
       $nMes--;
	   return ($lAbrev === 1)? $AMesC[$nMes]:$AMesL[$nMes];
    }else{
      return "Ms fora da faixa $nMes.";
    }
  }

  /*
    Retorna o nome do dia da semana.
    Parmetros:
     $nDia     - Nmero do Dia da semana solicitado (0 a 6).
	 $lAbrev   - Flag de abreviao do nome.
	             valores:  
				     0 ou n"ao informado -> Nome completo
					 1 -> Nome abreviado.
  */
  function NomeDia($nDia,$lAbrev) {
    $ADiaL = array("domingo","segunda-feira","tera-feira","quarta-feira","quinta-feira","sexta-feira","sabado"); 
    $ADiaC = array("dom","seg","ter","quar","qui","sex","sab"); 
    if (($nDia >= 0) && ($nDia < 7)) {
	   return ($lAbrev === 1)? $ADiaC[$nDia]:$ADiaL[$nDia];
    }else{
      return "Dia da semana fora da faixa $nDia.";
    }
  }

  /*
     Formata data.
	 Parmetros ($StrFmt,$data):
	      $StrFmt     - String de formato (obrigatrio)
		  $data       - Data (no formato Timestamp) para formatao.
		                se $data no for informado ser utilizado a data e 
						hora corrente (hora local do servidor).
	Requer: 
	     NomeMes() -> Neste
		 NomeDia() -> neste
						
	Strings de formato vlidas para o parmetro $StrFmt:
	   "!yyyy"   - Ano com 4 digitos
	   "!y"      - Ano com 2 Digitos
	   "!mmmm"   - Nome (longo) do mes
	   "!mmm"    - Nome (abreviado) do mes
	   "!mm"     - Nmero do ms (01 a 12)
	   "!m"      - Nmero do Mes (1 a 12)
	   "!dddd"   - Nome (longo) do dia da semana
	   "!ddd"	 - Nome (abraviado) do dia da semana
	   "!dd"     - Dia do Ms (01 a 31)
	   "!d"      - Dia do Ms (1 a 31)
	   "!HH"     - Hora no formato (00 a 23)
	   "!H"      - Hora no formato (0 a 23)
	   "!hh"     - Hora no formato (00 a 12)
	   "!h"      - Hora no formato (0 a 12)
	   "!MM"     - Minutos (00 a 59) 
	   "!M"      - Minutos (0 a 59)
	   "!SS"     - Segundos (01 a 59)
	   "!S"      - Segundos (1 a 59)
  */
  function Format_Date() { //r:($StrFmt,$data)
	 $numargs = func_num_args();
    if ($numargs == 1) {
	    $StrFmt = func_get_arg(0);
	    $dt     = time();
	 }else if ($numargs == 2){
		 $StrFmt = func_get_arg(0);
	    $dt     = func_get_arg(1);
	 }else{
		 $StrFmt = "";
	 }
    if ((!isset($StrFmt)) || (empty($StrFmt))) {
	    return "";
	 }else{
	    $StrFmt = str_replace("!yyyy",date("Y",$dt),$StrFmt); 
	    $StrFmt = str_replace("!yy",date("y",$dt),$StrFmt); 
	    $StrFmt = str_replace("!mmmm",NomeMes(date("n",$dt),0),$StrFmt); 
	    $StrFmt = str_replace("!mmm",NomeMes(date("n",$dt),1),$StrFmt); 
	    $StrFmt = str_replace("!mm",date("m",$dt),$StrFmt); 
	    $StrFmt = str_replace("!m",date("n",$dt),$StrFmt); 
	    $StrFmt = str_replace("!dddd",NomeDia(date("w",$dt),0),$StrFmt); 
	    $StrFmt = str_replace("!ddd",NomeDia(date("w",$dt),1),$StrFmt); 
	    $StrFmt = str_replace("!dd",date("d",$dt),$StrFmt); 
	    $StrFmt = str_replace("!d",date("j",$dt),$StrFmt);
	    $StrFmt = str_replace("!HH",date("H",$dt),$StrFmt);
	    $StrFmt = str_replace("!H",date("G",$dt),$StrFmt);
	    $StrFmt = str_replace("!hh",date("h",$dt),$StrFmt);
	    $StrFmt = str_replace("!h",date("g",$dt),$StrFmt);
	    $StrFmt = str_replace("!MM",date("i",$dt),$StrFmt);
	    $StrFmt = str_replace("!M",(date("i",$dt)+1-1),$StrFmt);
	    $StrFmt = str_replace("!SS",date("s",$dt),$StrFmt);
	    $StrFmt = str_replace("!S",(date("s",$dt)+1-1),$StrFmt);
		
		return $StrFmt;
	 }
  }
?>
