<?php
/*
   Funes diversas 
   Autor.: Alexandre P. Trindade
   Inicio: 15/09/2004 
   Copyright Uniware Informtica
*/

/*
  Funoes auxiliares para a funcao Extenso.
     Centena()
	 Dezena()
	 Unidade()
*/

function Centena($sCt, $sDzUn) {
  $result = "";
  if ($sCt != "0") {
	 if (($sCt == "1") && ($sDzUn != "00")) {
	    $result = 'CENTO E ';
	 }else{
		 $Aux = array(" ","CEM","DUZENTOS","TREZENTOS","QUATROCENTOS","QUINHENTOS",
			          "SEISCENTOS","SETECENTOS","OITOCENTOS","NOVECENTOS");
         if (($sCt >= 1) && ($sCt <= 9)) {
            $result = $Aux[((int) $sCt)];
		 }
		 if ($sDzUn != '00') {
			$result = $result . " E ";
		 }
     }
  }
  return $result;
}

function Dezena($sDz, $sUn ){

   $result = "";
   if (($sDz.$sUn != '00') && ($sDz != "0")) {
	   if (($sDz == "1") && ($sUn != "0")) {
		   $Aux = array("","ONZE","DOZE","TREZE","QUATORZE","QUINZE","DEZESEIS",
						"DEZESETE","DEZOITO","DEZENOVE");
		   $result = $Aux[(int) $sUn];
	   }else{
		   $Aux = array("","DEZ","VINTE","TRINTA","QUARENTA","CINQUENTA",
						"SESSENTA","SETENTA","OITENTA","NOVENTA");
		   $result = $Aux[(int) $sDz];
 		   if ($sUn != "0") {
			  $result = $result . " E ";
		   }
	  }
   }
   return $result;
}

function Unidade($sDz, $sUn ){
   $result = "";
   if (($sDz != '1') && ($sUn != '0')) {
	   $Aux = array("","UM","DOIS","TRS","QUATRO","CINCO","SEIS","SETE","OITO","NOVE");
	   if (($sUn > 0) && ($sUn < 10)) {
           $result = $Aux[(int) $sUn];
	   }
   }
   return $result;
}

/* =========================================================================
  Retorna o extenso de nmeros e valores.
  Parmetros:
     $valor   : Valor cujo extenso ser retornado.
	 $moeda   : Flag indicativo da moeda ou referncia 
	            que dever ser informado no extenso.
		Valores Possiveis para $moeda:
		   0   - Nenuma expecificao. Retorna apenas o extenso de um nmero inteiro.
		   1   - Decimal  (nmeros simples com uma casa decimal)
		   2   - Centesimal (numeros simples com duas casas decimais)
		   3   - Real  (valores em real)

  Requer:
     Centena()  - neste
	 Dezena()   - neste
	 Unidade()  - neste
     fillchar() - str_lib.php
  ========================================================================= */
 function Extenso($valor,$moeda,$currency_names = false) {
  if ($currency_names === false || count($currency_names) == 0){
     $currency_names = array("nsing" => "REAL","nplur" => "REAIS","csing" => "CENTAVO", "cplur" => "CENTAVOS");
  }
  
  $NDEC   = 0;
  $DECSEP = "";
  if ($valor < 0) {
	 $valor = $valor * (-1);
	 $negativo = true;
  }else{
     $negativo = false;
  }
  if (($valor === 0) || (!$valor)) {
     return "ZERO";
  }else if ($valor > 999999999){
     return "Valor acima da faixa !";
  }else{
     //r: Define o padro de nomes para o valor
	 switch ($moeda) {
		case 1 : 
			$Nome = array("nsing" => "","nplur" => "","csing" => "DCIMO", "cplur" => "DCIMOS");
            $NDEC   = 1;
            $DECSEP = ".";
		    break;
		case 2 : 
			$Nome = array("nsing" => "","nplur" => "","csing" => "CENTSIMO", "cplur" => "CENTSIMOS");
            $NDEC   = 2;
            $DECSEP = ".";
		    break;
		case 3 : 
			// $Nome = array("nsing" => "REAL","nplur" => "REAIS","csing" => "CCENTAVO", "cplur" => "CENTAVOS");
			$Nome =  $currency_names;
            $NDEC   = 2;
            $DECSEP = ".";
		    break;
		default:
  	       $Nome = array("nsing" => "","nplur" => "","csing" => "", "cplur" => ""); //r: Default $moeda = 0
	 }
	 
	 $NumStr = number_format($valor, 2, '.', '');
     $NumStr = fillchar($NumStr,12,"0",0);

	 //r: Desmembra a string
     //r: Centavos
	 if ($NDEC == 0) {
        $CtvU  = "0";
        $CtvD  = "0";
	 }elseif ($NDEC == 1) {
        $CtvD  = "0";
        $CtvU  = substr( $NumStr, 10, 1);
	 }elseif ($NDEC == 2) {
        $CtvU  = substr( $NumStr, 11, 1);
        $CtvD  = substr( $NumStr, 10, 1);
     }

	 //r:Centena
     $Un    = substr( $NumStr, 8, 1);
     $Dz    = substr( $NumStr, 7, 1);
     $Ct    = substr( $NumStr, 6, 1);
     //r: Milhar
     $Un1   = substr( $NumStr, 5, 1);
     $Dz1   = substr( $NumStr, 4, 1);
     $Ct1   = substr( $NumStr, 3, 1);
     //r:Milhes
     $Un2   = substr( $NumStr, 2, 1);
     $Dz2   = substr( $NumStr, 1, 1);
     $Ct2   = substr( $NumStr, 0, 1);
     $result = "";

     //r: Converte Milhes
     if ($Ct2.$Dz2.$Un2 != "000") {
        $result = $result . Centena( $Ct2, $Dz2.$Un2 ) .
                            Dezena( $Dz2, $Un2 ) .
                            Unidade( $Dz2, $Un2 );

        $Aux = $Ct2 . $Dz2 . $Un2;
  	    if ($Aux == '001') {
		   $result = $result . " MILHAO";
		}else{
		   $result = $result . " MILHOES";
		}

		$Aux = $Ct1.$Dz1.$Un1.$Ct.$Dz.$Un;
		if ($Aux == '000000') {
			if ($Nome["nplur"] != "") {
			   $result = $result . " DE " . $Nome["nplur"];
		    }
		}else if (($Aux <= 99) || 
			(($Ct1 > 0) && ($Dz1.$Un1.$Ct.$Dz.$Un == "00000")) ||
			(($Ct1.$Dz1.$Un1 == "000") && ($Aux > 99))) {
			$result = $result . " E ";
		}else{
			$result = $result . ", ";
		}
	 } //r: if milhes

	 //r: Converte Milhares
	 if ($Ct1.$Dz1.$Un1 != "000") {
		 $result = $result . Centena( $Ct1, $Dz1.$Un1 ) .
							 Dezena( $Dz1, $Un1 ) .
							 Unidade( $Dz1, $Un1 );

         $Aux = $Ct.$Dz.$Un;
         if ($Aux == "000") {
            $result = $result . " MIL " . $Nome["nplur"];
		 }else if(($Aux <= 99) || (($Ct >= 1) && ($Dz.$Un == "00"))) {
            $result = $result . " MIL E ";
         }else{
           $result = $result . " MIL ";
		 }
	 } //r: if milhares
    
	 //r: Converte Centenas
	 if ($Ct.$Dz.$Un != "000") {
		 $result = $result . Centena( $Ct, $Dz.$Un ) .
							 Dezena( $Dz, $Un ) .
							 Unidade( $Dz, $Un );

		 $Aux = $Ct2.$Dz2.$Un2.$Ct1.$Dz1.$Un1.$Ct.$Dz.$Un;
		 if ($Aux == 1) {
			$result = $result . " " . $Nome["nsing"];
		 }else if ($Aux > 1) {
			$result = $result . " " . $Nome["nplur"];
		 }
	 } //r: if centenas

	 //r: Coloca H para nmeros comeados em Um
	 if (strlen($result) >= 2) {
		 $Aux = substr($result,0,2);
		 if ($Aux == 'UM') {
			$result = 'H' . $result;
		 }
     }

	 //r: Converte Centavos}
	 If ($CtvD.$CtvU != '00') {
		 If (strlen($result) >= 2) {
			 $result = $result . " E ";
		 }
		 $result = $result . Dezena( $CtvD, $CtvU ) .
							 Unidade( $CtvD, $CtvU );

         $Aux = $CtvD.$CtvU;
		 if ( $Aux == 1) {
			$result = $result . " " . $Nome["csing"];
		 }else{
			$result = $result . " " . $Nome["cplur"];
		 }
	 }

     if($negativo == true) {
        $result = $result . ' NEGATIVO';
	 }
     return $result;
  }
 }
?>
