<?php
  /*
     Funes diversas
     Autor.: Alexandre P. Trindade
     Inicio: 15/09/2004 
     Copyright Uniware Informtica
  */
  
  //r: Atalho - Encripta string no formato padro de comunicao Uniware
  function hex_encode($text){
     return strtoupper(trim( str_to_hex(SoftEncode($text)) ));
  }

  //r: Atalho - Decodifica criptografia padro uniware
  function hex_decode($text){
	 $tmp = hex_to_str($text);
	 $tmp = SoftEncode($tmp, true);
     return $tmp;
  }

  /*
     O procedimento SoftEncode tem como finalidade a criptografia leve de dados
	 que nececitem ser mantidos no formato string por qualquer motivo.
	 Este cdigo  compativel o o cdigo do mesmo procedimento escrito em Delphi
	 e utilizado pelo Adiministrador de licenas.

	 Obs.: No alterar este cdigo sem que a mesma alterao seja feita no cdigo Delphi.

	      *** No usar esta funo para instrues SQL, para SQL usar Password() (ver abaixo)
  */
  function SoftEncode($str,$decode = false){
     $result = "";
	 if (empty($str)) {
	    return "";
	 }else{
	   if ($decode === true) {
		  //r: Decodificar
          $Key2   = 'IJKL=ABCDEFGHMNOPQRSTUVW\XYZabcdefghijklmnopqr/stuvxz1234567890.';
          $Key1   = 'S/TUVWXYZabuvxz1=234ABCDEFGHIJKLMN890.OPQRc\defghijklmnopqrst567';
	   }else{
		  //r: Codificar
          $Key1   = 'IJKL=ABCDEFGHMNOPQRSTUVW\XYZabcdefghijklmnopqr/stuvxz1234567890.';
          $Key2   = 'S/TUVWXYZabuvxz1=234ABCDEFGHIJKLMN890.OPQRc\defghijklmnopqrst567';
	   }

	   for ($i = 0;$i < strlen($str);$i++) {
		 $j = strpos($Key1, $str{$i} );
		 if ($j !== false) {
		    if (empty($result)){
		       if ($Key2{$j} != "0"){
			      $result = $Key2{$j};
               }else{
                  $result = '~0';
               }
		    }else{
			   $result .= $Key2{$j};
		    }
		 }else{
		   $result .= $str{$i};
		 }
	   }

     }
     if (strlen($result) > 0 && $result{0} == '~'){
        $result = substr($result,1);
     }
     return $result;
  }

  //r: Identico a soft encode, porem nao possui o caracter de escape "\". Para uso em instrues SQL
  function Password($str,$decode = false){
     $result = "";
	 if (empty($str)) {
	    return "";
	 }else{
	   if ($decode === true) {
		    //r: Decodificar
          $Key2   = 'IJKL=ABCDEFGHMNOPQRSTUVW XYZabcdefghijklmnopqr/stuvxz1234567890.';
          $Key1   = 'S/TUVWXYZabuvxz1=234ABCDEFGHIJKLMN890.OPQRc defghijklmnopqrst567';
	   }else{
		    //r: Codificar
          $Key1   = 'IJKL=ABCDEFGHMNOPQRSTUVW XYZabcdefghijklmnopqr/stuvxz1234567890.';
          $Key2   = 'S/TUVWXYZabuvxz1=234ABCDEFGHIJKLMN890.OPQRc defghijklmnopqrst567';
	   }
	   
	   for ($i = 0;$i < strlen($str);$i++) {
		 $j = strpos($Key1, $str{$i} );
		 if ($j !== false) {
		    if (empty($result)){
		       if ($Key2{$j} != "0"){
			      $result = $Key2{$j};
               }else{
                  $result = '~0';
               }
		    }else{
			   $result .= $Key2{$j};
		    }
		 }else{
		   $result .= $str{$i};
		 }
	   }

     }
     if (strlen($result) > 0 && $result{0} == '~'){
        $result = substr($result,1);
     }
     return $result;
  }

  function _hex($val,$len) { return str_pad(dechex($val),$len,"0",STR_PAD_LEFT); }

  //r: Converte texto para string hexa
  function str_to_hex($str) {
	  $i = 0;
	  $r = "";
	  while ($i < strlen($str)) {
       $r = $r . _hex(Ord(substr($str,$i,1)), 2);
	    $i = $i + 1;
	  }
	  return strtoupper($r);
  }

  //r: converte string hexa para texto
  function hex_to_str($strhex) {
	  $i = 0;
	  $r = "s"; //r: fora que o resultado seja uma string
	  while ($i < strlen($strhex)) {
        $r .= chr(hexdec(substr($strhex,$i,2)));
	    $i += 2;
	  }
	  if (strlen($r)>1){
         $r = substr($r,1,strlen($r)-1);
      }else{
         $r = "";
      }
	  //r: return (string) substr($r,1); //r: descarta o "s"
	  return $r;
  }

function valida_cnpj($cnpj) {
    $cnpj = NoMaskNum($cnpj);
    if (strlen($cnpj) < 14){
       return false;
    }
	$v_pd = 11 - ((substr($cnpj,0,1)*5 + substr($cnpj,1,1)*4 +
                   substr($cnpj,2,1)*3 + substr($cnpj,3,1)*2 +
                   substr($cnpj,4,1)*9 + substr($cnpj,5,1)*8 +
                   substr($cnpj,6,1)*7 + substr($cnpj,7,1)*6 +
                   substr($cnpj,8,1)*5 + substr($cnpj,9,1)*4 +
                   substr($cnpj,10,1)*3 + substr($cnpj,11,1)*2) % 11);
	if ($v_pd >9)
	$v_pd = 0;

	$v_sd = 11 - ((substr($cnpj,0,1)*6 + substr($cnpj,1,1)*5 +
                   substr($cnpj,2,1)*4 + substr($cnpj,3,1)*3 +
                   substr($cnpj,4,1)*2 + substr($cnpj,5,1)*9 +
                   substr($cnpj,6,1)*8 + substr($cnpj,7,1)*7 +
                   substr($cnpj,8,1)*6 + substr($cnpj,9,1)*5 +
                   substr($cnpj,10,1)*4 + substr($cnpj,11,1)*3 + $v_pd*2) % 11);

	if ($v_sd >9)
	$v_sd = 0;


	if (substr($cnpj,12,2) == ($v_pd*10)+$v_sd) {
   		return true;
	} else {
   		return false;
	}
}

function valida_cpf($cpf) {
    if ($cpf != "") {
        $cpf  = zerosl($cpf,11);
        if ($cpf == "00000000000" ||
            $cpf == "22222222222" ||
            $cpf == "33333333333" ||
            $cpf == "44444444444" ||
            $cpf == "55555555555" ||
            $cpf == "66666666666" ||
            $cpf == "77777777777" ||
            $cpf == "88888888888" ||
            $cpf == "99999999999") {
            return false;
        }

        $cpf2  = substr($cpf, 0,9);
        $total = 0;
        for ($i=2;$i<11;$i++) {
            $valor = (substr($cpf2, -1*($i-1),1) * $i);
            $total = $total + $valor;
        }
        $d1 = (($total*10) % 11)% 10;
        $cpf2 = $cpf2.$d1;
        $total = 0;
        for ($i=2;$i<12;$i++) {
            $valor = (substr($cpf2, -1*($i-1),1) * $i);
            $total = $total + $valor;
        }
        $d2 = (($total*10)%11)%10;
        $num = $cpf2.$d2;
        return $num == $cpf;
    } else
        return false;
}

function valida_email($email) {
    return preg_match("/^\\w+([\\.-]?\\w+)*@\\w+([\\.-]?\w+)*(\\.[a-z]{2,4})+$/", $email);
}


function NoMaskNum($numstr){
  $result = "";
  for($i = 0;$i < strlen($numstr);$i++){
    $ch = substr($numstr,$i,1);
    if (strpos("0123456789",$ch) !== false) {
       $result .= $ch;
	 }
  }
  return $result;
}

function FormatCnpj($cnpj){
   $cnpj = NoMaskNum($cnpj);
   return substr($cnpj,0,2) . "." .substr($cnpj,2,3) . "." .substr($cnpj,5,3) . "/" .substr($cnpj,8,4) . "-" .substr($cnpj,12,2);
}


function IsCnpj($Cnpj){
  $i=0; $cnum=""; $cdv=""; $dvc="";
  $Amult = array(6,5,4,3,2,9,8,7,6,5,4,3,2);
  $vn = "0123456789"; $cm = 0; $tot = 0;
  
  if ($Cnpj == "") {
	 return false;
  }else{  
    $i = 0;
    while ($i < strlen($Cnpj)) {
	  $ch = substr($Cnpj,$i,1);
      if (strpos($vn,$ch) !== false) {
		 $cnum .= $ch;
	  }  $i = $i + 1;
	}
	if (strlen($cnum) != 14) {
	   return false;
	}else{
	  $cdv  = substr($cnum,-2);
	  $cnum = substr($cnum,0,12);
	  for ($i=0; $i< strlen($cnum);$i++){
		 $cm =  substr($cnum,$i,1);
		 $tot = $tot + ($cm * $Amult[$i+1]);
	  }
	  if ((11 - ($tot % 11)) > 9) {
		  $dvc = '0';
	  }else{
		  $ch = (11 - ($tot % 11));
		  $dvc = "$ch";
	  }
	  $cnum = $cnum . $dvc; $tot = 0;
	  for ($i=0; $i< strlen($cnum);$i++){
		 $cm =  substr($cnum,$i,1);
		 $tot = $tot + ($cm * $Amult[$i]);
	  }

	  if ((11 - ($tot % 11)) > 9) {
		  $dvc = $dvc . '0';
	  }else{
		  $ch = (11 - ($tot % 11));
		  $dvc = $dvc . "$ch";
	  }

	  return ($dvc == $cdv);
	}
  }
}

  function TreeDump($array,$ident){
     if (is_array($array)){
	    foreach($array as $k => $v){
		   if (!is_array($v)){
		      echo "$ident [$k] = $v","<br>";
		   }else{
		      echo "$ident [$k] = Array(",count($v),")","<br>";
			  TreeDump($v,$ident."&nbsp;&nbsp;&nbsp;");
		   }
		}
	 }
  }

  /*
    Verifica se a string &value esta contido em $a_grupos.
	Cada elemento de $a_grupos pode conter um valor ou um array definindo uma faixa
	Exemplo verifica se o valor de $var  "1","3","8","!" ou se  um caracter na faixa "A~Z": 
	if (strIN($var,array("1","3","8","!",array("A","Z")))){ .. }

  */
  function strIN($value,$a_grupo){
	 if (!is_array($a_grupo)){ return false; }
     if (in_array($value,$a_grupo)){
	    return true;
	 }

	 $result = false;
     foreach($a_grupo as $k => $v){
	   if (is_array($v) && count($v) == 2){
		  if (ord($value) >= ord($v[0]) && ord($value) <= ord($v[1])){
			  $result = true;
		  }
	   }
	 }
	 return $result;
  }

  /*
     Verifica se &value esta contido em $a_grupos. 
	 idem a strIN porem para valores numricos
  */
  function numIN($value,$a_grupo){
	 if (!is_array($a_grupo)){ return false; }
     if (@in_array($value,$a_grupo)){
	    return true;
	 }

	 $result = false;
     foreach($a_grupo as $k => $v){
	   if (is_array($v) && count($v) == 2){
		  if ($value >= $v[0] && $value <= $v[1]){
			  $result = true;
		  }
	   }
	 }
	 return $result;
  }

  //r: monta um arra. Equivale a  Array()
  function MA(){
     return func_get_args();
  }
?>
