<?php
   /*
      ULib
      Autor: Alexandre P. Trindade
      Data.: 07/06/2011

      Funes de segurana pra uso genrico
   */

   define("UM_DIA",(24*3600));  // Valor tempo referente ao periodo de 1 dia

   // Desabilita scripts na string
   function disableScripts($text){
      $aBusca = array('/<[Ss][Cc][Rr][Ii][Pp][Tt]/','/<\/[Ss][Cc][Rr][Ii][Pp][Tt]>/');
      $aTroca = array('<bloqueado','</bloqueado>');
      return preg_replace($aBusca,$aTroca,$text);
   }

   // Remove scripts da string
   function removeScript($text){
      return preg_replace("'<[Ss][Cc][Rr][Ii][Pp][Tt][^>]*?>.*?</[Ss][Cc][Rr][Ii][Pp][Tt]>'si","",$text);
   }

   // Desabilita tags HTMLs
   function disableHtmlTags($text){
      $aBusca = array("<",">");
      $aTroca = array("&lt;","&gt;");
      return str_replace($aBusca,$aTroca,$text);
   }

   // Revert resultado de disableHtmlTags()
   function enableHtmlTags($text){
      $aBusca = array("&lt;","&gt;");
      $aTroca = array("<",">");
      return str_replace($aBusca,$aTroca,$text);
   }

   // Previne SQL ingect
   function slqProtect($text){
     if (!get_magic_quotes_gpc()){
        $result =  mysql_escape_string($text);
     }else{
       $aBusca = array("'",'"',"\x00");
       $atroca = array("",'"',"\\x00");

       $result = str_replace($aBusca,$atroca,$text);
     }
     return $result;
   }

   function valueBetween($value,$min,$max){
       return ($value >= $min && $value <= $max);
   }


   /**
    * function dataValida($strData,$formato="d/m/a");
    *
    * Valida uma string contendo uma data.
    * A data pode estar em qualquer formato desde que
    * o formato seja especificado.
    *
    * @param string $strData String contendo a data no formato de origem.
    * @param string $formato Formato de saida para a data.<br>
    *                        Formatos validos:
    *                         "d/m/a"  - dia/mes/ano - Default  (ex.: "20/10/2011")
    *                         "a/m/d"  - ano/mes/dia
    *                         "m/d/a"  - mes/dia/ano
    *
    *                         os formatos acima podem ser extendidos para data_hora/timestamp
    *                         como por exemplo:
    *                          "d/m/a h:i:s"  - Data e hora BR (ex.: "20/10/2011 14:25:38")
    *
    * @return boolean
    * Retorna true para data vlida e false para invlida
    */
   function dataValida($strData,$formato="d/m/a"){
       $strData = str_replace(array("/",":","."," "),"-",$strData);
       $formato = str_replace(array("/",":","."," "),"-",strtolower($formato));
       $eld = split("-",$strData);
       $elf = split("-",$formato);

       if (!is_array($elf) || !is_array($eld) || count($elf) < count($eld) || count($eld) < 3){
          return false;
       }
       $aTime = array("a"=>0, "m"=>0,"d"=>0,"h"=>0,"i"=>0,"s"=>0);
       $i = 0;
       while ($i < count($eld)){
         if ($i < count($elf)){
            $aTime[$elf[$i]] = $eld[$i];
         }

         $i+=1;
       }
       $result = checkdate ($aTime["m"],$aTime["d"],$aTime["a"]);
       $result = ($result && valueBetween($aTime["h"],0,24));
       $result = ($result && valueBetween($aTime["i"],0,59));
       $result = ($result && valueBetween($aTime["s"],0,59));
       return $result;
   }

   /**
    *  function convertData($strData,$fmtOrig="d/m/a h:i:s",$fmtDest="a-m-d h:i:s")
    *  Converte data para formatos diferentes
    *
    *  $strData - String contendo a data a ser convertida
    *  $fmtOrig - Formato no qual se encontra a data ($strData)
    *  $fmtDest - Formato para o qual a data ser convertida
    *
    *  Retorna false se falhar
    */
   function convertData($strData,$fmtOrig="d/m/a h:i:s",$fmtDest="a-m-d h:i:s"){
       $strData = str_replace(array("/",":","."," "),"-",$strData);
       $fmtOrig = str_replace(array("/",":","."," "),"-",strtolower($fmtOrig));

       $eld  = @split("-",$strData);
       $elf  = @split("-",$fmtOrig);

       if (!is_array($elf) || !is_array($eld) || count($elf) < count($eld) || count($eld) < 3){
          return false;
       }

       $aTime = array("a"=>"0000", "m"=>"00","d"=>"00","h"=>"00","i"=>"00","s"=>"00");
       $i = 0;
       while ($i < count($eld)){
         if ($i < count($elf)){
            $aTime[$elf[$i]] = $eld[$i];
         }

         $i+=1;
       }
       $busca = array("d","m","a","h","i","s");
       $troca = array($aTime["d"],$aTime["m"],$aTime["a"],$aTime["h"],$aTime["i"],$aTime["s"]);
       return str_replace($busca,$troca,$fmtDest);
   }

  // Converte data BR para Timestamp Unix
  function stringToDate($data){
      // Valida a data
      if (!dataValida($data)){
         return false;
      }
      //Converte para Timestamp Unix
      $data = str_replace(':','-',$data);
      $a = split('[/.-]',$data);
      $result = false;
      switch (count($a)){
         case 3:
                 $result = mktime(0,0,0,$a[1],$a[0],$a[2]);
                 break;
         case 4:
                 $result = mktime($a[3],0,0,$a[1],$a[0],$a[2]);
                 break;
         case 5:
                 $result = mktime($a[3],$a[4],0,$a[1],$a[0],$a[2]);
                 break;
         case 6:
                 $result = mktime($a[3],$a[4],$a[5],$a[1],$a[0],$a[2]);
                 break;
      }
      return $result;
  }

  function decodeDateBR($data){
      if (!dataValida($data)){
         return false;
      }
      $result = array("dia"=>0,"mes"=>0,"ano"=>0,"hora"=>0,"min"=>0,"seg"=>0);
      $idx    = array(0 => "dia",1 => "mes",2 => "ano", 3 => "hora",4 => "min", 5 => "seg");

      //Converte para Timestamp Unix
      $data = str_replace(':','-',$data);
      $a = split('[/.-]',$data);

      $i = 0;
      while ($i < count($a)){
        $result[$idx[$i]] = $a[$i];
        $i += 1;
      }

      return $result;
  }

  function inc_dateBR($data,$nDias=1){
      if (!dataValida($data)){
         return false;
      }

     $t1 = stringToDate($data);
     $t2 = (UM_DIA * $nDias);
     $tempo =  $t1 + $t2;
     return date("d/m/Y", $tempo);
  }

?>
