<?php
  /*
   Funes basicas de usao genrico.
   Autor.: Alexandre P. Trindade
   Inicio: 15/09/2004 
   Copyright Uniware Informtica
  */

  define("SORT_ASC","AZ");
  define("SORT_DESC","ZA");

  /* Checa se um valor qualquer est contido em uma lista
     Exemplo: verificar se a varivel $a   igual a um dos seguintes valores: 1,2,3,38,"casa",false
     
	 if _in($a, 1,2,3,38,"casa",false) {
		 echo "$a esta na lista !";
	 }
  */ 
  function _in(){
     $args = func_num_args();
     $elf  = $args[0];
	 $args[0] = "";
	 return in_array($elf,$args);
  }

  function iif($exp,$pa,$pb){
    if ($exp===true){
	   return $pa;
	}else{
	   return $pb;  
	}
  }

  function remove_mask_num($pval) {
     if ($pval != "") {
	    $result = "";
		$i = 0;
		while ($i < strlen($pval)) {
		  $ch = substr($pval,$i,1);
		  if (strpos("0123456789",$ch)) {
		    $result = $result . substr($pval,$i,1);
		  }
		  $i++;
		}
		return $result;
	 }else{
	   return "";
	 }
  }

  /**
   * Insere um elemento de forma ordenada em um array multi dimencional
   *
   * @param <array> $arrayBase    - array nmo qual o novo elemento ser inserido
   * @param <array> $newElement   - elemento array a ser inserido
   * @param <int>   $indexCompare - indice do array elemento usado para a comparao
   * @param <const> $sortMode     - modo de ordenao: SORT_ASC para ascendente e
   *                                SORT_DESC para descendente
   *
   * Retorna: array  - array resultante da insero do novo elemento no ocnjunto
   *                   de elementos de arrayBase na forma ordenada indicada por
   *                   $sortMode
  */
  function put_sorted($arrayBase,$newElement,$indexCompare,$sortMode=SORT_ASC){
      $result = array();
      if (count($arrayBase) < 1){
         array_push($result,$newElement);
         return $result;
      }

      $i = 0; $put = false;
      while ($i < count($arrayBase)){
         $v = $arrayBase[$i];

         if ($sortMode==SORT_ASC){
             if ($v[$indexCompare] <= $newElement[$indexCompare]){
                 array_push($result,$v);
             }else{
                 if (!$put){
                    $put = true;
                    array_push($result,$newElement);
                 }
                 array_push($result,$v);
             }
          }else{
             if ($v[$indexCompare] >= $newElement[$indexCompare]){
                 array_push($result,$v);
             }else{
                 if (!$put){
                    $put = true;
                    array_push($result,$newElement);
                 }
                 array_push($result,$v);
             }
          }
          $i+=1;
      }
      if (count($result) <= count($arrayBase)){
         array_push($result,$newElement);
      }
      return $result;
  }

  /**
   * Ordena um array multi-dimencional
   *
   * @param <array> $arrayBase    - array a ser ordenado
   * @param <int>   $sortIndex    - indice do array elemento usado para a comparao
   * @param <const> $sortMode     - modo de ordenao: SORT_ASC para ascendente e
   *                                SORT_DESC para descendente
   *
   * Retorna: array  - uma cpia ordenada de arrayBase na forma indicada por
   *                   $sortMode
  */
  function sort_array($array,$sortIndex,$sortMode=SORT_ASC){
     $result = array();
     $i = 0;
     while ($i < count($array)){
        $k = $array[$i];
        $result = put_sorted($result, $k, $sortIndex,$sortMode);
        $i+=1;
     }
     return $result;
  }

  /* Formata numero decimal de acordo com a mascara informada */
  function FormatFloat($value,$mask="#.##0,00"){
     if (empty($mask)){
        return $value;
     }else{
        $ms = strpos($mask,".");
        $ds = strpos($mask,",");
        if ($ms === false && $ds === false){
           //r: sem separadores - mascara invalida
           $result = (string) ((int) $value);
           $result = str_pad($result, strlen($mask), "0", STR_PAD_LEFT);
        }else if ($ms === false && $ds !== false){
           //r: com separador de decimal apenas
           list($m1,$m2) = split(",",$mask,2);
           if (empty($m2)){ $m2 = "0";}

           $result = number_format($value,strlen($m2),',','');
        }else if ($ms !== false && $ds !== false){
           //r: separadores de milhar e decimal
           list($m1,$m2,$m3) = split("[\.,]",$mask,3);
           if (empty($m3)){ $m3 = "0";}
           $result = number_format($value,strlen($m3),',','.');
        }else{
          die("FormatFloat() erro: Mascara de saida invlida '$mask'.");
        }
        return $result;
     }
  }

  /*
   *  Converte numeros decimais do padrao br para en ou limpa string contendo numeros
   *  decimais. Retorna sempre o numero encontrado no padrao en.
   *
   *  @param <string> $value   - string contendo mum numero decimal no formato br ou en,
   *                           com ou sem lixo
   *
   *  @param <string> $decSep  - Caracter separador de decimal defalt ','.
   *                             indica o caracter a ser considerado ocmo separador decimal
   *                             na string ($value) passada. se o numero estiver no padrao
   *                             en informar '.' (ponto).
   *
  */
  function decimal($value,$decSep=","){
      $val = "";
      for ($i=0;$i<strlen($value);$i++){
        $v = (string) $value{$i};
        if (preg_match("/[0-9]/",$value{$i}) || ($value{$i} == $decSep && strpos($val,".")===false)){
           if ($value{$i} == $decSep){
             $val .= '.';
           }else{
             $val .= $value{$i};
           }
        }
      }

      return $val;
  }

?>
