<?php
/*
   Procedimentos para manipulao de strings.
   Autor.: Alexandre P. Trindade
   Inicio: 15/09/2004 
   Copyright Uniware Informtica
*/

/*
  Preenche uma string com caracteres a direita,esquerda ou ambos.
  Parmetros:
       $texto    - Texto a ser formatado
	   $len      - Comprimento da string retornada
	   $char     - Caracter de preenchimento
	   $direction- Direo do preenchimento.
	               Valores possiveis:
				     0 - Preenche com carcteres a esquerda
					 1 - Preenche com caracteres a direita e a esquerda (efeito centraliza)
					 2 - Preenche com caracteres a Direita.
*/  
   function fillchar($texto,$len,$char="0",$direction=0) {
	  switch ($direction) {
         case 0 : return str_pad($texto,$len,$char,STR_PAD_LEFT); 
		 case 1 : return str_pad($texto,$len,$char,STR_PAD_BOTH); //r: ambos, centraliza
		 default : return str_pad($texto,$len,$char,STR_PAD_RIGHT); //r:  > 2
	  }
   }

  /* procura um ou mais termos dentro de um array retorna true se o termo pesquisado for encontrado
     ou se um dos teromos da lista for encontrado (no caso de $aFind ser um array).
     retorna false se nenhuma ocorrencia for encontrada

     Parametros:
	     $aFind   - um valor ou uma lista de valores a serem pesquisados no array $aSource
		 $aSource - Array cujo contedo ser pesquisado.
  */

  function IsOnArray($aFind,$aSource){
	 if (is_array($aSource)){
		 if (!is_array($aFind)){
			return  in_array( $aFind, $aSource );
		 }else{
			$ret  = false;
			foreach($aFind as $k => $v){
			   if ( in_array( $v, $aSource ) ){
				   $ret = true;
				   break;
			   }
			}
			return $ret;
		 }
	 }else{
	   return false;
	 }
  }


  //:r Retorna um poro do texto ($ptext) de no mximo $maxlen usando a sequencia $pch como ponto de corte
  function left_max_text($ptext,$maxlen,$pch) {
    if (((!isset($ptext)) || (empty($ptext))) || 
		((!isset($maxlen))  || ($maxlen==0)) ||
		((!isset($pch))   || ($pch ==""))) {
		$result = "";
	}else{
		$result = substr($ptext,0,$maxlen-1);
		if (!(strrpos($result,$pch) === false)) {
           $result = substr($result,0,strrpos($result,$pch)+strlen($pch)); 
		}
	
	}
    return $result;
  }

  function Apostrofos($texto){
     return str_replace("'","",$texto);
  }

  function NAP($texto){
     $texto = str_replace("'","",$texto);
     $texto = str_replace('"',"`",$texto);
     return $texto;
  }

  /* Este aperfeioamento da funo NAP
     Foi feito em uma nova funo devido ao fato de que
     em muitos scripts antigos a funo NAP original esta
     combinada com addslashes() o que causaria problemas
     duplicao de escape.
  */
  function NAP2($texto){
     if (!get_magic_quotes_gpc()){
        $texto =  mysql_escape_string($texto);
     }else{
       $texto = str_replace("'","",$texto);
       $texto = str_replace('"',"`",$texto);
     }
     return $texto;
  }

  function NoHtmlTag($texto){
     $texto = str_replace("<","&lt;",$texto);
     $texto = str_replace(">"," &gt;",$texto);
	 return $texto;
  }

  function special_code($texto){
     $texto = str_replace("","&Ccedil;",$texto);
     $texto = str_replace("","&ccedil;",$texto);

     $texto = str_replace("","&Aacute;",$texto);
     $texto = str_replace("","&Agrave;",$texto);
     $texto = str_replace("","&Auml;",$texto);
     $texto = str_replace("","&Acirc;",$texto);
     $texto = str_replace("","&Atilde;",$texto);

     $texto = str_replace("","&aacute;",$texto);
     $texto = str_replace("","&agrave;",$texto);
     $texto = str_replace("","&auml;",$texto);
     $texto = str_replace("","&acirc;",$texto);
     $texto = str_replace("","&atilde;",$texto);

     $texto = str_replace("","&Eacute;",$texto);
     $texto = str_replace("","&Egrave;",$texto);
     $texto = str_replace("","&Ecirc;",$texto);
     $texto = str_replace("","&Euml;",$texto);

     $texto = str_replace("","&eacute;",$texto);
     $texto = str_replace("","&egrave;",$texto);
     $texto = str_replace("","&ecirc;",$texto);
     $texto = str_replace("","&euml;",$texto);

     $texto = str_replace("","&Iacute;",$texto);
     $texto = str_replace("","&Igrave;",$texto);
     $texto = str_replace("","&Icirc;",$texto);
     $texto = str_replace("","&Iuml;",$texto);

     $texto = str_replace("","&iacute;",$texto);
     $texto = str_replace("","&igrave;",$texto);
     $texto = str_replace("","&icirc;",$texto);
     $texto = str_replace("","&iuml;",$texto);

     $texto = str_replace("","&Oacute;",$texto);
     $texto = str_replace("","&Ograve;",$texto);
     $texto = str_replace("","&Ocirc;",$texto);
     $texto = str_replace("","&Otilde;",$texto);
     $texto = str_replace("","&Ouml;",$texto);

     $texto = str_replace("","&oacute;",$texto);
     $texto = str_replace("","&ograve;",$texto);
     $texto = str_replace("","&ocirc;",$texto);
     $texto = str_replace("","&otilde;",$texto);
     $texto = str_replace("","&ouml;",$texto);

     $texto = str_replace("","&Uacute;",$texto);
     $texto = str_replace("","&Ugrave;",$texto);
     $texto = str_replace("","&Ucirc;",$texto);
     $texto = str_replace("","&Uuml;",$texto);
  
     $texto = str_replace("","&uacute;",$texto);
     $texto = str_replace("","&ugrave;",$texto);
     $texto = str_replace("","&ucirc;",$texto);
     $texto = str_replace("","&uuml;",$texto);

     $texto = str_replace("","&ordm;",$texto);
     $texto = str_replace("","&ordf;",$texto);
     $texto = str_replace("","&sect;",$texto);
  
     return $texto;
  }

  function TextToHTML($texto){
     $cr_lf  = chr(13).chr(10);
	 $cr     = chr(13);
	 $lf     = chr(10);
	 $tab    = chr(9);
	 //r:$texto  = htmlentities($texto);
	 $texto  = special_code($texto);

     $texto  = str_replace($cr_lf, "<br>", $texto);
     $texto  = str_replace($cr, "<br>", $texto);
     $texto  = str_replace($lf, "<br>", $texto);
     $texto  = str_replace($tab, "&nbsp;&nbsp;&nbsp;&nbsp;", $texto);
     $texto  = str_replace("  ", "&nbsp;&nbsp;",$texto);
     return $texto;
  }

  //r: Retorna texto para taransmisso segura para formulrios flash
  function SafeFlashText($texto){
      return str_replace("&","|~|",$texto);
  }

  //r: retorn o texto passado em linhas de no mximo $len caracteres
  function TextLines($texto,$len){  //r: build #112  v. 2.7.02
     $result = array();
	 $s = ""; $linha = "";
	 $aux    = array(); $aux = split(" ",$texto);

	 foreach($aux as $k => $v){
	   $s = trim($v);
	   if (!empty($s)){ 
		  if (strlen("$linha $s") <= $len){
		     $linha = (empty($linha))? $s:" $s";
		  }else{
		     $result[] = $linha; $linha = $s;
		  }
	   }
	 }

	 if (!empty($linha)){ $result[] = $linha; }
  
     return $result;
  }
?>
