<?php
  /**
   *  Controle de Zonas de Tempo
   *  Autor: Alexandre P. Trindade
   *  Data.: 16/02/2012
   */

   define("UTC_NORONHA",-2);
   define("UTC_BRASILIA",-3);
   define("UTC_CUIABA",-4);

   /**
    *  Fuso horario do servidor
    */
   global $FUSO_SERVIDOR;
   $FUSO_SERVIDOR = "PR";

  /**
   *  Controle de horarios para sites
   *  Estabelece o fuso horrio a ser utilizado pela aplicao (site)
   *
   *  Fusos vlidos para o Brasil:
   *     -2 Horas  : Fernando de Noronha
   *     -3 Horas  : Brasilia
   *     -4 Horas  : Cuiab
   *
   *  Informaoes adicionais sobre fusos no Brasil e Horario de vero
   *    Horario de vero Brasil: http://www.guiageo-mapas.com/fusos-brasil.htm
   *    Mapa Horario de vero..: http://pcdsh01.on.br/FusoBR_HVCorrente.htm
   *
   *  Estados que adotam horrio de vero:
   *   - Bahia
   *   - Distrito Federal
   *   - Esprito Santo
   *   - Gois
   *   - Mato Grosso
   *   - Mato Grosso do Sul
   *   - Minas Gerais
   *   - Paran
   *   - Rio de Janeiro
   *   - Rio Grande do Sul
   *   - Santa Catarina
   *   - So Paulo
   */
  function brasil_time($fuso = -3){
      $brasil = array("Noronha"=>"Atlantic/Cape_Verde","Brasilia"=>"America/Sao_paulo","Cuiaba"=> "America/Cuiaba","HVBR"=>"America/Halifax");
      switch ($fuso){
         case -2:
            date_default_timezone_set($brasil["Noronha"]);
            break;
         case -3:
            date_default_timezone_set($brasil["Brasilia"]);
            break;
         case -4:
            date_default_timezone_set($brasil["Cuiaba"]);
            break;
         case -5:
            // usado para compensao do horaro de vero quando o 3 fuso tem -2 horas em relao ao horrio de Braslia
            // Nota para a posteridade: se no for assim no funciona
            date_default_timezone_set($brasil["HVBR"]);
            break;
      }
      return time();
  }

  function time_zone($uf){
     global $FUSO_SERVIDOR;

     $fusom3 = "AP,PA,MA,TO,DF,GO,PI,CE,RN,PB,PE,AL,SE,BA,MG,ES,RJ,SP,PR,SC,RS,";
     $fusom4 = "RR,AM,AC,RO,MT,MS";
     $hverao = "BH,DF,ES,GO,MT,MS,MG,PR,RJ,RS,SC,SP";
     $uf = strtoupper($uf);

     // se  a UF for a mesma do servidor, retorna a zona padro
     // independente de estar ou no no horario de vero
     if ($uf == $FUSO_SERVIDOR){
        if (strpos($fusom3,$uf) !== false){
           return brasil_time(-3);
        }if (strpos($fusom4,$uf) !== false){
           return brasil_time(-4);
        }if ($ud == "FN"){
           return brasil_time(-2);
        }
        return false;
     }
     $a_hora = localtime(time(), true);

     $it = 0;
     if ($a_hora["tm_isdst"]){
        // Horario de vero
        if (strpos($hverao,$uf) !== false){
           $it = 0; // se a UF indicada tambem esta no horario de vero tudo certo
        }else{
           $it = ($uf=="FN")? 0:-1; // se no esta descontar 1 hora exeto se for Fernando de Noronha e arquipelagos
        }
     }
     $fuso = -3;
     if (strpos($fusom3,$uf) !== false){
        $fuso = -3;
     }if (strpos($fusom4,$uf) !== false){
        $fuso = -4;
     }if ($ud == "FN"){
        $fuso = -2;
     }
     return brasil_time($fuso + $it);
  }

?>
