<?php
  /*
   *  Acesso ao banco de dados via cgi "cgi-mysql".
   *  Autor.: Alexandre P. Trindade
   *  Data..: 14/06/2010
   *
   *  Acesso multiplo ao banco de dados remoto
   *  A classe uHttpCgiDb2 permite enviar uma lista de SQLs
   *  ao banco e receber os diversos resultsets na mesma
   *  chamada.
   *  No faz paginao,  especfica para consultas combinadas
   *
  */

  define("CGI_START_BLOCK","CGI-MYSQL-RESULTSET-U201006");
  define("CGI_START_BLOCK_SIZE",strlen(CGI_START_BLOCK)+2);
  define("CGI_END_BLOCK","::CGI-MYSQL-END>>");
  define("CGI_END_BLOCK_SIZE",strlen(CGI_END_BLOCK));

  class uHttpCgiDb2{
     var $url;
     var $form;
     var $fLastError;
     var $fIoResult;
     var $fRecordCount;
     var $trimData;
     var $OnLoadRec;
     var $porta;
     var $aResults;
     var $textHtml;
     var $blobText;

     function uHttpCgiDb2(){
        $this->url = "";
        $this->form = array();
        $this->form["UHTTPFILEDCTRL"] = "CZ1";
        $this->form["COMANDO1"]       = "OPEN";
        $this->form["COUNT"]          = 1;
        $this->form["TRIM1"]          = "FALSE";
        $this->form["RSQL1"]          = "";
        
        $this->fLastError    = array("S1"=>"");
        $this->fRecordCount  = array("S1"=>0);
        $this->fIoResult     = array("S1"=>0);
        $this->trimData      = array("S1"=>"FALSE");
        $this->OnLoadRec     = array("S1"=>"");
        $this->porta         = 80;
        $this->aResult       = array();
        $this->textHtml      = false;
        $this->blobText      = false;
     }

     /* Obtem status de erro referente a instruo executada se houver
      * @visiblidade Public
      *
      * @param $index    ndice de resultado para a consulta.
      *                  se o valor -1 for utilizado ser retornado
      *                  o erro da conexo.
      *
      * @return    Retorna Zero se nenhum erro ocorreu ou 1 para erro
      *
      */
     function IoResult($index=-1){
        $result = 0;
        if ($index == -1){
            foreach($this->fIoResult as $k => $v){
               if ($v == 1){
                  $result = 1;
               }
            }
        }else{
           if ($this->fIoResult["S$index"] == 1){
               $result = 1;
           }
        }
        return $result;
     }
     
     /* Obtem mensagem de erro referente a instruo executada se houver
      * @visiblidade Public
      *
      * @param $index    ndice de resultado para a consulta.
      *                  se o valor -1 for utilizado ser retornado
      *                  o erro da conexo.
      *
      * @return    Retorna mensagem de erro
      *
      */
     function LastError($index=-1){
        $result = "";
        if ($index == -1){
           foreach($this->fLastError as $k => $v){
              if (!empty($v)){
                 $result = $v;
              }
           }
        }else{
           $result = $this->fLastError["S$index"];
        }

     }
     
     /*  Acesso aos resultados das instrues.
      *  @visibilidade Public
      *  Remove um resultado da lista
      *
      *  @param $index   nidice correspondente ao resultado desejado
      *                  o ndice tem base 1 e deve corresponder ao
      *                  ndice da instruo SQL.
      */
     function popResult($index){
        $index -= 1;
        if ($index < count($this->aResult)){
           $r = $this->aResult[$index];
           $this->aResult[$index] = array();
           return $r;
        }else{
           return false;
        }
     }
     
     /*  Adiciona SQL a lista
      *  @visibilidade Public
      *  @param $index      Posio da instruo SQL na lista
      *  @param $psql       Instruo SQL que ser executada
      *  @param $cmd        Comando OPEN ou EXEC
      *  @param $trimData   Flag indica se o recordset para esta SQL dever
      *                     ser retornado sem espaos a direita
      */
     function pushSQL($index, $psql,$cmd="OPEN",$trimData=false){
        $this->form["RSQL$index"]    = $psql;
        $this->form["COMANDO$index"] = $this->iif(strtoupper($cmd)=="OPEN","OPEN","EXEC");
        $this->form["TRIM$index"]    = $this->iif($trimData,"TRUE","FALSE");
        if ($index > $this->form["COUNT"]){
           $this->form["COUNT"] = $index;
        }
     }
     
     function setCommandCount($value){
       if ($value > 1){
          $this->form["COUNT"] = $value;
       }else{
          $this->form["COUNT"] = 1;
       }
     }
     
     /*  Conecta ao banco remoto e excuta as instrues da lista */
     function Execute(){
        $this->query();
        return ($this->fIoResult["S0"] == 0);
     }
  
     /*  Processa resultado extraido.
      *  @visibilidade Private
      *
      *
      */
     function processResult(&$a_result,$index){
        $this->fRecordCount["S$index"] = count($a_result);
        
        if ($this->fRecordCount["S$index"] == 1){
           $a = $a_result[0];

           if ($a["result"] == "1"){
              $this->fIoResult["S$index"]  = 1;
              $this->fLastError["S$index"] = $a["erro"];
           }else{
              $this->fIoResult["S$index"] = 0;
           }
        }
     }
     
     /* Nmero de registros retornado para uma determinada
      * instruo. Use RecordCount() para obter o nmero
      * de registros retornado para a instruo antes de
      * retirar o resultado da pilha.
      *
      * @visiblidade Public
      *
      * @param $index    ndice de resultado para a consulta.
      *
      * @return    Retorna nmero de registros retornado para a
      *            instruo da posio $index
      *
      */
     function RecordCount($index){
        return $this->fRecordCount["S$index"];
     }
     

     /* Envia e recebe dados. postData conecta a url definda, envia as instrues
      * e devolve o resultado bruto disposto em uma lista (array)
      *
      * @visiblidade Private
      *
      * @param $query   pacote (formulrio HTML) contendo a lista de instrues
      * @param $others  Informaes adicionais de Reader
      *
      * @return    Array contendo a lista de resultados (pacotes no processados).
      */
     function postData($query,$others=''){
       $RESULT = array();
       $host = $this->url;
       $path =explode('/',$host);
       $host =$path[0];
       unset($path[0]);
       $path='/'.(implode('/',$path));
       $post="POST $path HTTP/1.1\r\nHost: $host\r\nContent-type: application/x-www-form-urlencoded\r\n${others}User-Agent: Mozilla 4.0\r\nContent-length: ".strlen($query)."\r\nConnection: close\r\n\r\n$query";

       $h = fsockopen($host,$this->porta,$iErr,$erMsg,5);
       if ($h !== false){
           fwrite($h,$post);

           $r = "";
           while (!feof($h)) {
             $r .= fgets($h, 128);
           }
           fclose($h);
           while (!empty($r)){
               $i = strpos($r,CGI_START_BLOCK);
               if ($i !== false){
                  $r = substr($r,$i+CGI_START_BLOCK_SIZE);
               }

               $i = strpos($r,CGI_END_BLOCK);
               $RL = "";
               if ($i !== false){
                  $RL = substr($r,0,$i-2);
               }else{
                  $RL = $r;
               }
               array_push($RESULT,$RL);
               // Ultimo bloco de dados ?
               $i = strpos($r,CGI_START_BLOCK);
               if ($i === false){
                  $r = "";
               }
            }
            return $RESULT;
      }else{
         $this->fIoResult["S0"]  = $iErr;
         $this->fLastError["S0"] = $erMsg;
         return false;
      }
     }
     
     /* Prepara o formulrio HTML para postagem.
      *
      * @visibilidade Private
      *
      * @return Lista de pacotes (no processados) retornados pelo server
      */
     function postForm(){
       $qry = "";
       if (is_array($this->form)){
          foreach($this->form as $k => $v){
            $qry .= $this->iif(empty($qry),"?$k=","&$k=");
            $qry .= urlencode($v);
          }
          return $this->postData($qry);
       }else{
         $this->fIoResult["S0"] = 1;
         $this->fLastError["S0"] = "uCgiDbQuery.postForm() erro: Formulario no definido.";
         return false;
       }
     }

     /* Dispara a solicitao para o server e processa os resultados obtidos.
      *
      * @visibilidade Private
      *
      * @return void
      */
     function query(){
        $this->aResult = array();
        $CrLf = $this->iif($this->textHtml,"<br>\r\n","\r\n");
        $dsm = $this->postForm();
        if ( $dsm !== false && is_array($dsm)){
            $rIndex = 1;
            foreach($dsm as $k => $ds){
                $alinhas = explode("\r\n",$ds);
                $a_bloco = array();
                if ( count($alinhas) > 1 ){
                   $arc = explode("=",$alinhas[0]);
                   $this->allRecord = $arc[1];
                   $a_result = array();
                   $aFields = explode(chr(3),$alinhas[1]); $alinhas[1] = "";
                   $i = 2;
                   while ($i<count($alinhas)){
                      $l = explode(chr(3),$alinhas[$i]); $alinhas[$i] = ""; $rec = array();
                      $j = 0;
                      while ($j < count($l)){
                         if ($this->blobText){
                            $rec[$aFields[$j]] = str_replace(chr(2),$CrLf, $l[$j]);
                         }else{
                            $rec[$aFields[$j]] = $l[$j];
                         }
                         $j += 1;
                      }
                      array_push($a_bloco,$rec);
                      $i += 1;
                   }
                }
                $this->processResult($a_bloco,$rIndex);
                array_push($this->aResult,$a_bloco);
                $rIndex += 1;
           }
        }
    }
         
    function iif($e,$p1,$p2){
       if ($e){
          return $p1;
       }else{
          return $p2;
       }
    }

  }
?>
