<?php
   /*
       Classe  uDetailForm
               Auxiliar de uForm para gerenciamento de cadastro Mestre-Detalhe
               
       Autor........: Alexandre P. Trindade
       Data.........: 27/07/2011
       Atualizado em: 27/07/2011
       Verso 0.1
   */

   uses("o_forms");

   global $REC_No_FIELDNAME;
   $REC_No_FIELDNAME = "_recno_";
   
   function detailResultSetMount(&$sender){
      global $index_rec_count;
      global $REC_No_FIELDNAME;
      
      $index_rec_count += 1;
      $sender->fBuffer[$REC_No_FIELDNAME] = $index_rec_count;
   }
   
   function detailStartMount(){
       global $index_rec_count;
       // Nota: esse cara tem que ser -1 por que ser incrementado para 0 na abertura da query
       $index_rec_count = -1;
   }
   
   class uDetailForm extends uForm{
       // ArrayForms - Controls Tabela detalhe
       var $detCounter;  // Campos contador, que informa o nmero de registros postados
       var $detStruct;   // array contendo a estrutura dos campos formato ("NomeCampo"=>"ValorDefault")
       var $detPost;     // Armazena um array associativo da postagem
       
       var $rKeyName;        // Chave primaria do registro
       var $mainKeyName;     // Chave de relacionamento tabela mestre
       var $outRCount;       // Varivel de saida para total de registros retornados em uma leitura  para edio
                             // usado para controle no html

       var $SQL;             // Sql de pesquisa (usar parametro ':fkVal' para idenfificar o valor de comparao da chave estrangeira)
       var $delSQL;          // Sql excluso geral (quando o mestre  excluido, usar ':fkVal')
       
       public function uDetailForm(&$conexao){

           $this->detCounter = 0;
           $this->detPost    = array();
           
           $this->outRCount = "det_rc";

           $this->rKeyName    = "";
           $this->mainKeyName = "";
           
           $this->SQL = "";
           $this->delSQL;
           parent::uForm(&$conexao);
           
       }
       
       public function loadDetail($fkValue){
          $sql = str_replace(":fkVal",$fkValue,$this->SQL);
          
          detailStartMount();
          $qr = new uMySQLQuery();
          $qr->conexao = $this->conexao->conn;
          $qr->OnLoadRec = "detailResultSetMount";
          $qr->date_br = true;
          $qr->formatFloat = true;
          $qr->SQLAdd($sql);
          
          $res = array();
          $o = $qr->Open();
          $rc = $qr->RecordCount();
          if ($o && $rc>0){
             $res = $qr->ArrayResult();
          }else{
             if (!$o){
                $this->doSqlErro("loadDetail()",$qr->lastError,$qr->fSQLo);
             }
          }
          $this->_setVar($this->outRCount,$rc);
          $this->_persistFields($res);
          $this->_setResultSet($res);
       }
       
       /*
          L e processa postagem dos detalhes
          @param  $mainKeyValue  <string>     Valor/cdigo chave estrageira (id da dependncia)
          @param  $deleteAll     <bool>       Registro mestre excluido, todos os detalhes devem ser deletados
       */
       public function readPost($mainKeyValue,$deleteAll=false){
           if (empty($this->rKeyName) || empty($this->mainKeyName)){
              $p = (empty($this->rKeyName))? "rKeyName":"kainKeyName";
              $this->_halt("uDetailForm.readPost() propriedade '$p' no informada");
              return false;
           }

           if ($deleteAll){
              $this->_deleteAll($mainKeyValue);
              return true;
           }

           $detStruct = $this->_getDetStruct();

           $detPost = array();
           if ($this->detCounter != "" && count($detStruct) > 0){
              // verifica se o Html postou uma lista
              $postCount = $this->_request($this->detCounter,0,"post");

              if ($postCount > 0){
                 $i = 1;
                 while ($i<=$postCount){
                    // obtem cada registro da lista postada pelo html
                    reset($detStruct); $newRec = array();
                    foreach($detStruct as $k=>$v){
                        $newRec[$k] = $this->_request($k.$i,$v,"post");
                    }
                    
                    // Seta chave estrangeira do registro
                    $newRec[$this->mainKeyName] = $mainKeyValue;
                    array_push($detPost,$newRec);
                    $i +=1;
                 }

                 // Processar e gravar todos os registros

                 reset($detPost);
                 foreach($detPost as $rec){
                    // varre os registros postados para obter a ao a ser realizada para cada um
                    // da seguinte forma:
                    // pk = 0  - Incluir novo registro
                    // pk > 0  - Alterar o registro
                    // pk < 0  - Excluir o registro (Id = pk*(-1))
                    if ($rec[$this->rKeyName] == 0){
                       // Insert
                       $this->_gravaDetalhe($this->actionList["INSERT"], $rec);
                    }else if ($rec[$this->rKeyName] > 0){
                       // Update
                       $this->_gravaDetalhe($this->actionList["UPDATE"], $rec);
                    }else{
                       // Delete
                       $rec[$this->rKeyName] = $rec[$this->rKeyName] * (-1);
                       $this->_saveData($this->actionList["DELPOST"],$rec,true);
                    }
                    
                 }
              }
           }
           return count($aPost);
       }
       
       /*
          Grava cada registro detalhe individualmente
          @param $act <string> Ao (INSERT/UPDATE) conforme lista de aces vlidas
          @parem $rec <array>  Registro para gravao
       */
       private function  _gravaDetalhe($act,$rec){
           $result = false;
           
           $this->validaDetailFormClasse();
           $this->_buildAlias();

           // valida post
           $accept = true; $erroMsg = "";
           $validado = false;
           if (!empty($this->OnValidate)){
              $cmd = $this->OnValidate;
              $accept = $cmd($this,$act,$rec,$erroMsg,$validado);
              $validado = !$validado;
           }

            // grava registro
            if ($accept){
                 // se gravou, retorna true
                 if ($this->_saveData($act,$rec,$validado)){
                    $result = true;
                 }
            }else{
                 // envia mensagem de erro ao usurio se houver alguma
                 $this->doOutErro( $erroMsg );
            }
            return $result;
       }
       
       
       private function validaDetailFormClasse(){
           if (empty($this->tableName)){
               $this->_halt("tableName detalhe no especificada.");
            }
            
           if (empty($this->SQL)){
               $this->_halt("SQL no especificada.");
           }

           if (empty($this->delSQL)){
              $this->_halt("delSQL no especificada.");
           }

       }
       
       /*
         Estrutura bsica
       */
       private function _getDetStruct(){
          $result = array();
          reset($this->dbFieldList);
          foreach($this->dbFieldList as $fldName => $fld){
             $result[$fld["htmlField"]] = $fld["defaultValue"];
          }
          return $result;
       }
       
       private function _deleteAll($mainKey){
          $sql = str_replace(":fkVal",$mainKey,$this->delSQL);
          $q = new uMySQLSql();
          $q->conexao = $this->conexao->conn;
          if (!$q->ExecSQL($sql)){
             $this->doSqlErro("_deleteAll()",$q->lastError,$q->sqlCheck);
          }
       }
   }
?>
