<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004 
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/objects.php"); 
  /*{$NC-}*/
  /*{$CB+}
  uses("objects");
  {$CB-}*/

  class uFile extends uObject {
	  //r: Propriedades
      var $fileName;
	  var $openMode;
	  var $type;
	  //r: Eventos
	  var $onRead;
	  var $onWrite;
	  //r: dados privados
	  var $vHandle;
	  var $vOpen = false;

	  function uFile(){
	      $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uFile";
	      $classPath = (func_num_args() > 1)?  "uFile.".func_get_arg(1):"uFile";

		  $this->uObject($name,$classPath); //r: inherited

		  if ($this->onFree != "") {
		     $this->onFree     .= '($this);$this->uFileDestroy';
		  }else{
	          $this->onFree     = '$this->uFileDestroy';
		  }

	      $this->fileName = ""; 
		  $this->type     = "bin";
		  $this->openMode = "rb";
		  $this->onRead   = "";
		  $this->onWrite  = "";
		  $this->vOpen    = false;
	  }
  
      function Open(){
		 $filename = $this->fileName;
		 $modo     = $this->openMode;
		 if (($this->vOpen === true) || ($filename == "")) {
		    return false;
		 }else{
	       $handle = fopen($filename,$modo);
		   if ($handle !== false) {
		      $this->vHandle = $handle;
			  $this->vOpen   = true;
			  return true;
		   }else{
		     return false;
		   }
	     }
	  }

	  function Close(){
		 if ($this->vOpen === false) {
		    return false;
		 }else{
	       $handle = $this->vHandle;
		   if (fclose($handle)) {
		      $this->vHandle = 0;
			  $this->vOpen   = false;
			  return true;
		   }else{
		      return false;
		   }
	     }
	  }

      function Read($size) {
		 if ($this->vOpen === false) {
		    return false;
		 }else{
	       $handle = $this->vHandle;
		   $dados  = fread($handle,$size);
		   $ev     = $this->onRead; 
		   if ($ev != "") {
			  $ev .= '($this,$dados);';
			  eval($ev);
		   }
		   return $dados;
	     }
	  }

      function ReadLn() {
		 if (func_num_args() > 0) {
			$size = func_get_arg(0);
		 }else{
		    $size = 1024;
		 }
		 if ($this->vOpen === false) {
		    return false;
		 }else{
	       $handle = $this->vHandle;
		   $dados  = fgets($handle,$size);
		   $dados  = str_replace("\r","",$dados); 
		   $dados  = str_replace("\n","",$dados); 

		   $ev     = $this->onRead; 
		   if ($ev != "") {
			  $ev .= '($this,$dados);';
			  eval($ev);
		   }
		   return $dados;
	     }
	  }
	 
      function Write($dados,$size) {
		 if ($this->vOpen === false) {
		    return false;
		 }else{
	       $handle = $this->vHandle;
		   $ev     = $this->onWrite; 
		   if ($ev != "") {
			  $ev .= '($this,$dados,$size);';
			  eval($ev);
		   }
		   return fwrite($handle,$dados,$size);
	     }
	  }

      function WriteLn($dados) {
		 if ($this->vOpen === false) {
		    return false;
		 }else{
	       $handle = $this->vHandle;
		   $ev     = $this->onWrite; 
		   $size   = -1;
		   if ($ev != "") {
			  $ev .= '($this,$dados,$size);';
			  eval($ev);
		   }
		   $dados .= "\r\n";
		   $size  = strlen($dados);
		   return fwrite($handle,$dados,$size)-2;
	     }
	  }

      function Seek($offset,$from) {
		 if ($this->vOpen === false) {
		    return false;
		 }else{
	       $handle = $this->vHandle;
		   return fseek($handle,$offset,$from);
	     }
	  }

	  function CurrentOffset(){
		 if ($this->vOpen === false) {
		    return false;
		 }else{
	       $handle = $this->vHandle;
		   return ftell($handle);
	     }
	  }

      function Size(){
		 $filename = $this->fileName;
		 if ($filename == "") {
	         return false;
		 }else{
		    return filesize($filename);
		 }
	  }

	  function DataHora() {
		 $filename = $this->fileName;
		 if ($filename == "") {
	         return false;
		 }else{
		    return filemtime($filename);
		 }
	  }

	  function Statistc() {
		 $filename = $this->fileName;
		 if ($filename == "") {
	         return false;
		 }else{
		    return stat($filename);
		 }
	  }

      function Eof() {
		 if ($this->vOpen === false) {
		    return true;
		 }else{
		   return feof($this->vHandle);
	     }
	  }

      function Bof() {
		 if ($this->vOpen === false) {
		    return false;
		 }else{
		   return (CurrentOffset() === 0);
	     }
	  }

      function WriteFrom($obj_file,$buff_size = 2048){
	    if (!IsOfClass($obj_file,"uFile")) {
	       return false;		
		}else{
		   $fsize      = $obj_file->Size();
		   $byteswrite = 0;  //r: 2k
		   $buff       = "";
		   $err        = false;
		   while (($byteswrite < $fsize) && (!$obj_file->Eof()) && ($err === false)) {
		      $buff = $obj_file->Read($buff_size);
			  $bw = $this->Write($buff,strlen($buff));

			  if ($bw === false){
			    $err = true;
			  }else{
                 $byteswrite  += $bw;			  
			  }
		   }
		}
	  }

	  function uFileDestroy(){
		$tmp = $this->vOpen;
		if ($tmp === true ) {
		   $this->Close();
		}
	  }
  }


  //r: Le um arquivo texto e retorna todo o contedo em uma string
  function GetFileContent($filename){
    $OFile = new uFile();
	$OFile->fileName = $filename;
	$OFile->openMode = "rb";
	$result = "";

    if ($OFile->Open()){
	   $result = $OFile->Read($OFile->Size());
	   $OFile->Close();
	}
    $OFile->Free($OFile);
	return $result;
  }
?>