<?php
   /*
    *  Classe uForm
    *  Autor.: Alexandre P. Trindade
    *  Data Inicio..: 19/06/2011
    *  Atualizado em: 19/06/2011
    *
    *
    *
      Nota  actionList Formato:
         array("NEW"=>"show-insert",       // Exibir form para Incluir novo registro
               "SHOW"=>"show-edit",        // editar o registro indicado na url
               "SHOWDEL"=>"show-delete",   // exibir para excluir
               "INSERT"=>"save-insert",    // Salvar um novo registro
               "UPDATE"=>"save-edit",      // Salvar um registro alterado
               "DELETE"=>"delete",         // excluir o registro indicado na url
               )
    
       Nota OnValidate Parametros
          &$sender    - o objeto
          $opr        - operacao a ser realizada insert|update|delete
          $record     - im array associativo contendo o registro a ser validado
          &$outErro   - Mensagem de erro a ser retornada
          
          return true|false  - retornar true para aceitar o registro ou false para reciusar
          
       Nota OnPost Parametros:
          &$sender  - o objeto
          $opr      - operao  "insert|update|delete"
          $pkList   - lista de campos e valores que identificam o registro (lista na ordem da pk ou
                      o atribuido na propriedade keyField)
    */
   
    define("fld_noPk",0); define("fld_pk1",1); define("fld_pk2",2); define("fld_pk3",3); define("fld_pk4",4);define("fld_pk5",5);
    define("fld_autoinc_Y",true); define("fld_autoinc_N",false);
    define("fld_required_Y",true); define("fld_required_N",false);
    define("fld_virtual_Y",true); define("fld_virtual_N",false);
    define("fld_unique_Y",true); define("fld_unique_N",false);
    define("fld_safePost_Y",true); define("fld_safePost_N",false);

    uses("lib_str","lib_std","lib_seg","jc_padrao","jc_mysql","o_mysqlsql","o_mysqlquery");

    function debug($msg){
       echo $msg,"<br>\r\n";
    }

    function line(){
      debug("<hr>");
    }

    class uForm{
       // public
       var $debug;
       var $urlIdFields;     //r: nome do campo get quer recebe achave de localizao do registro (chaves multiplas,separar valores com pipe. pex: id=1|255)
       var $urlAction;       //r: Nome do campo passado por get que define ao
       var $urlActionList;   //r: array contendo lista personalizada para a aes via url (utilizar numeros inteiros para indice das aes)
       
       var $insertRedir;     //r: script para o qual deve ser redirecionado apos um insert bem sussedido
       var $updateRedir;     //r: script para o qual deve ser redirecionado apos um update bem sussedido
       var $deleteRedir;     //r: script para o qual deve ser redirecionado apos um delete bem sussedido
       var $cancelRedir;     //r: script para o qual deve ser redirecionado apos cancelar

       var $actionField;     //r: Nome do campo postado que define a ao
       var $actionList;      //r: array contendo lista personalizada para a aes via post
       var $defaultAction;   //r: acao default se nenhuma outra for informada
       var $lastAction;      //r: utima ao porcessada por Execute()
       var $nomeCadastro;    //r: Nome que identifica o cadastro para o usurio, usado para compor o ttulo do cadastro

       var $enabledDelGet;   //r: Habilita comando de excluso pela url (get), defalt = false;
       var $deleteEnabled;   //r: Habilita/desabilita excluso no cadastro defalt = true (habilitado)
       
       var $disabledFuncs;        //r: Array contendo lista de opes (insert/edit/delete/show) que no estaro disponveis no

       var $resultSet;       //r: nome do array correspondete a tag <execute> do arquivo html
       var $tableName;       //r: Nome da tabela no banco de dados para inserts e updates
       var $keyField;        //r: campo ou campos para busca (se vazio localiza pela pk)
       var $lastID;          //r: retorna id de registro inserido

       var $ajax;

       // eventos
       var $OnValidate;      //r: evento, disparado antes de um insert/update/delete para validao do registro:  function(&$sender,$opr,$record,&$outErro,&$performDefaultValidatio):boolean
       var $OnPost;          //r: evento disparado apos uma gravao bem sussedida: function(&$sender,$opr,$pkList)
       var $OnOutError;      //r: evento chamado para dar saida as mensagems de erros ao usurio: function ($sender,$erMsg)
       var $OnSqlErro;       //r: evento disparado para notificao de erro da aplicao (SQL,execuo, etc) destinados ao programador
       var $BeforePost;      //r: evento disparado antes da gravao e apos validado o registro
       var $AfterPost;       //r: evento disparado apos uma gravao bem sussedida: function($sender,$act,$rec)
       var $OnShow;          //r: evento chamado sempre que o formulrio de cadastro for devouvido ao browser (um gancho para modificar a saida)
       
       //Private
       var $conexao;         //r: conexo
       var $record;          //r: Copia do registro que sera mostrada|gravada|excluida
       var $dbFieldList;     //r: array contendo a lista com a definio dos campos
                             //r: formato: ("fieldName"=>"","fieldType"=>"","fieldSize"=>0,"pk"=>0,"autoinc"=>false,"required"=>false,"htmlField"=>"","defaultValue"=>"","safeMode"=>true)

       var $fomNames;        //r: array nomes dos forms em cada ao (INSERT/UPDATE/DELETE)
       var $confFields;      //r: array contendo a lista de campos de confirmao (um campo real e um virtual cujos valiores devem ser identicos e a mensagem de erro,ex: senhas,e-mails,etc)
       var $joinList;        //r: array contendo os parametros para Joins, ver Join()
       var $tableAlias;      //r: array contendo a lista de tabelas e alias para sql de busca: array("tableName"=>"alias")
       var $fieldAlias;      //r: array contendo uma lista dos campos e os rtespectivos alias: array("fieldName"=>alias)
       var $looUpFields;     //r: array contendo as especificaes para campos LookUp (lista relacionada)
       var $radioField;      //r: array descritivo para campos radiobutton: array("fieldname",array("value"=>"varOut",...))
       var $fieldConversosr; //r: array contendo lista de conversores para campos : array("fieldName"=>"funcName");
       var $detailForms;     //r: array Permite a relao com um ou mais tabelas de detalhe (para forms mestre-detalhe)
       var $className;       //r: nome da classe
       
       function uForm(&$conexao){
          global $confirm_action_value;
          global $cancel_action_value;
       
          $debug = false;
          
          $className = get_class($this);
          $this->conexao = $conexao;
          
          $this->ajax = false;
          $this->urlIdFields   = "id";
          $this->defaultAction = "show-insert";
          // acoes admitidas via post
          $this->actionList = array("NEW"=>"show-insert",
                                   "SHOW"=>"show-edit",
                                   "SHOWDEL"=>"show-delete",
                                   "INSERT"=>"save-insert",
                                   "UPDATE"=>"save-edit",
                                   "DELPOST"=>"delete-post",
                                   "DELETE"=>"delete-get",
                                   "CANCEL"=>"cancel"
                                  );
          $confirm_action_value = "cancel";
          $cancel_action_value  = "cancel";
          
          $this->disabledFuncs = array("insert"=>false,"update"=>false,"delete"=>false,"show"=>false);
          
          // acoes admitidas via get
          $this->urlActionList = array("NEW"=>1,
                                      "SHOW"=>2,
                                      "SHOWDEL"=>3,
                                      "DELETE"=>99
                                     );

          $this->fomNames        = array("INSERT"=>"add_form",
                                         "UPDATE"=>"edit_form",
                                         "DELETE"=>"delete_form"
                                        );
                                         
          $this->htmlActionField = "acao";
          $this->urlAction       = "act";
          $this->lastAction      = "";
          
          $this->enabledDelGet   = false;
          $this->deleteEnabled   = true;
          
          $this->insertRedir = "";
          $this->updateRedir = "";
          $this->deleteRedir = "";
          $this->cancelRedir = "";
       
          $this->nomeCadastro = "";
          
          $this->resultSet  = "";
          $this->tableName  = "";
          $this->keyField   = "";    // nao implementado ainda
          $this->OnValidate = "";
          $this->OnPost     = "";
          $this->OnOutError = "";
          $this->OnSqlErro  = "";
          $this->OnShow     = "";
          $this->AfterPost  = "";
          $this->BeforePost = "";
          $this->lastID     = -1;
          
          $this->dbFieldList = array();
          $this->confFields  = array();
          $this->joinList    = array();
          $this->tableAlias  = array();
          $this->fieldAlias  = array();
          $this->looUpFields = array();
          $this->radioField  = array();
          
          $this->detailForms = array();
       }
       
       function fDebug($msg){
          if ($this->debug == true){
             echo $msg,"<br>\r\n";
          }
       }

       function fLine($show=true){
          $this->fDebug("<hr>");
       }

       function _validaClasse(){
           if (empty($this->tableName)){
               $this->_halt("tableName no especificada.");
            }
            
            if (empty($this->urlIdFields)){
               $this->_halt("urlIdFields no especificado.");
            }

            if (empty($this->defaultAction)){
               $this->_halt("defaultAction no especificado.");
            }

            if (empty($this->actionList)){
               $this->_halt("actionList no especificado.");
            }

            if (empty($this->urlActionList)){
               $this->_halt("urlActionList no especificado.");
            }

            if (empty($this->htmlActionField)){
               $this->_halt("htmlActionField no especificado.");
            }

            if (empty($this->urlAction)){
               $this->_halt("urlAction no especificado.");
            }

            if (empty($this->insertRedir)){
               $this->_halt("insertRedir no especificado.");
            }

            if (empty($this->updateRedir)){
               $this->_halt("updateRedir no especificado.");
            }

            if (empty($this->deleteRedir)){
               $this->_halt("deleteRedir no especificado.");
            }

            if (empty($this->cancelRedir)){
               $this->_halt("cancelRedir no especificado.");
            }

            if (empty($this->nomeCadastro)){
               $this->_halt("nomeCadastro no especificado.");
            }

            if (empty($this->resultSet)){
               $this->_halt("resultSet no especificado.");
            }
       }
       
       /** Chama manipulador do evento BeforePost **/
       function doBeforePost($act,&$rec){
          if (!empty($this->BeforePost)){
             $cmd = $this->BeforePost;
             $cmd($this,$act,$rec);
          }
       }
       
       function doOnPost($act,$rec){
          if (!empty($this->OnPost)){
             $cmd = $this->OnPost;
             $cmd($this,$act,$rec);
          }
       }
       
       function doAfterPost($act,$rec,$newId=0){
         $this->doDetailPost($act,$rec,$newId);
         
         if (!empty($this->AfterPost)){
            $cmd = $this->AfterPost;
            $cmd($this,$act,$rec,$newId);
         }
       }
       
       function doOnShow($act,$rec){
          if (!empty($this->OnShow)){
             $cmd = $this->OnShow;
             $cmd($this,$act,$rec);
          }
       }
       
       function doSqlErro($funcName,$errorMsg,$sqlExec){
          if (!empty($this->OnSqlErro)){
             $cmd = $this->OnSqlErro;
             $cmd($funcName,$errorMsg,$sqlExec);
          }
       }
       
       function doDetailLoad($reg){
          $pkList = $this->_getPkList();
          if (count($pkList) > 0 && count($this->detailForms) >0){
              $fk = $reg[ $pkList[0] ];
              reset($this->detailForms);
              foreach($this->detailForms as $dForm){
                  $dForm->loadDetail($fk);
              }
          }else if (count($this->detailForms) > 0){
             // halt errro
             $this->_halt("doDetailLoad() Pk no informada.");
          }
       }
       
       
       function doDetailPost($act,$reg,$newId=0){
          $pkList = $this->_getPkList();
          if (count($pkList) > 0 && count($this->detailForms) >0){
              // se for um insert passa a nova ID cadastrada
              $fk = ($newId==0)? $reg[ $pkList[0] ]:$newId;
              reset($this->detailForms);
              foreach($this->detailForms as $dForm){
                  $dForm->readPost($fk,($this->_deleting($act)));
              }
          }else if (count($this->detailForms) > 0){
             // halt errro
             $this->_halt("doDetailPost() Pk no informada.");
          }
       }
       
       /* Desabilita funes do formulrio */
       function disableFunctions(){
          $params = func_get_args();
          foreach($params as $k => $v){
             $v = strtolower($v);
             if (in_array($v, $this->disabledFuncs)){
                $this->disabledFuncs[$v] = true;
             }
          }
       }
       
       function _deleting($act){
          return ($act == $this->actionList["DELETE"] || $act == $this->actionList["DELPOST"]);
       }
       
       /** aborta com erro grava **/
       function _halt($msg){
          $n = get_class($this);
          die("<b>$n erro: $msg</b>");
       }
       
       /*
        * Retorna um campo da requisio (get/post)
        */
       function _request($paramName,$defaultValue,$orig="globals",$len=0,$safe=true){
         $result = "";
         if ($safe) {
            $result = NAP2(RParams::get_t($paramName,$defaultValue,$orig));
         }else{
            $result = RParams::get_t($paramName,$defaultValue,$orig);
         }

         if ($len > 0){
            return substr($result,0,$len);
         }else{
           return $result;
         }
       }

       /** gera um registro vazio para formulrios de incluso **/
       function _emptyRecord(){
          $r = array();
          reset($this->dbFieldList);
          foreach($this->dbFieldList as $k => $v){
             $r[$k] = $v["defaultValue"];
          }
          return $r;
       }
       
       /**
        * obtem o id do registro passado por get
        * retornando um array associativo no formato "nomeDoCampo"=>valorObtido
        * lembrando que ids compostas devem ter os valores separados por pipe na ordem da PK
        */
       function _getUrlId(){
          $result = array();
          $id =  $this->_request($this->urlIdFields,"","get");
          if (!empty($id)){
             if (strpos($id,"|") !== false){
                $aValues = split('|',$id);
             }else{
                $aValues = array($id);
             }
             $pkList = $this->_getPkList();
             $i=0;
             while ($i < count($aValues)){
                $result[$pkList[$i]] = $aValues[$i];
                $i+=1;
             }
          }
          return $result;
       }
       
       
       // obtem o id do registro passado por post
       // retornando um array associativo no formato "nomeDoCampo"=>valorObtido
       // localiza os ids pela sequencia pk especificada na lista de campos
       function _getPostIds($recPost){
          $result = array();
          $pkList = $this->_getPkList();
          $i = 0;
          while ($i < count($pkList)){
             $result[$pkList[$i]] = $recPost[$pkList[$i]];
             $i+=1;
          }
          return $result;
       }
       
      /** teste se um item do array dbFieldList  um campo da tabela **/
      function _isField($fDef){
         if (strpos($fDef["fieldName"],"act:")!==false){
            $result = false;
         }else{
            $result = ($fDef["virtual"] == false);
         }
         return $result;
      }

      /** verifica na lista de campos se algum  unique **/
      function  _haveUnique(){
         $result = false;
         reset($this->dbFieldList);
         foreach($this->dbFieldList as $k => $v){
            if ($v["unique"]==true){
               $result = true;
            }
         }
         return $result;
      }

      /** retorna a lista dos campos unic **/
      function _getUniqueList(){
         $result = array();
         reset($this->dbFieldList);
         foreach($this->dbFieldList as $k => $v){
            if ($v["unique"]==true){
               $result[] = $k;
            }
         }
         return $result;
      }

      /** retorna a lista dos campos unic **/
      function _getUniqueDisplays($type=1){
         if ($type=3){
            $result = "";
         }else{
            $result = array();
         }
         reset($this->dbFieldList);
         foreach($this->dbFieldList as $k => $v){
            if ($v["unique"]==true){
               if ($type==1){
                  $result[$k] = $v["display"];
               }else if ($type == 3){
                  $result .= (empty($result))? $v["display"]:"$result, $v[display]";
               }
            }
         }
         return $result;
      }

      /** Verifica campos unicos **/
      function _checaUniques($rs,&$erMsg){
          $result = true;
          $q = new uMySQLSql();
          $q->conexao = $this->conexao->conn;
          
          $qr = new uMySQLQuery();
          $qr->conexao = $this->conexao->conn;
          
          $aUniques = $this->_getUniqueList();
          $flds     = $this->_getSelectFields();
          $pks      = $this->_getPostIds($rs);
          $where    = $this->_getWhereTo($pks,false);
          if (count($aUniques) > 0 && !empty($where)){
             foreach($aUniques as $k => $v){
                $a = $this->fieldAlias[$v];
                $where .= " AND $a.$v=";
                $where .= $q->_GetSQLValStr($v,$rs[$v], $this->dbFieldList[$v]["fieldType"]) ."\r\n";
             }
             $qr->SQLAdd("SELECT $flds FROM " . $this->tableName." a");
             if (count($this->joinList)>0){
                 $j =$this->_getJoinSql();
                 $qr->SQLAdd("  $j");
             }
             $qr->SQLAdd($where);
             if ($qr->Open()){
                $result = ($qr->RecordCount() == 0);
                if (!$result){
                   if (count($aUniques) > 1){
                      $erMsg = "Os valores especificados para os campos " . $this->_getUniqueDisplays(3) . " no esto disponveis.";
                   }else{
                      $erMsg = "O valor especificado no campo " . $this->_getUniqueDisplays(3) . " no est disponvel.";
                   }
                }
                $qr->Close();
             }else{
               $result = false;
               $this->doSqlErro("_checaUniques()",$qr->lastError,$qr->fSQLo);
             }

          }if (empty($where)){
             $result = false;
             $this->doSqlErro("_checaUniques()","Erro Chaves de busca no especificada.",$wrere);
          }
          return $result;
      }
      
      /** valida o registro antes da postagem **/
      function _validaRecord($act,$rs,&$erMsg){
          $result = true;
          if (count($this->dbFieldList) < 1){
             $this->_halt("$this->className.validaRecord() Erro: Nenhum campo definido para a tabela ".$this->tableName);
          }
          $erMsg = "";
          if (count($this->confFields)>0){
             $i = 0;
             while ($i < count($this->confFields)){
               $v = $this->confFields[$i];
               if ($rs[$v[0]] != $rs[$v[1]]){
                  $result = false;
                  $erMsg = $v[2]."<br>\r\n";
               }
               $i+=1;
             }
             if (!$result){
                return false;
             }
          }

          if ($this->_haveUnique()){
             if (!$this->_checaUniques($rs,$erMsg)){
                return false;
             }
          }

          reset($this->dbFieldList);
          foreach($this->dbFieldList as $k => $v){
             if ($this->_isField($v)){
                if (empty($rs[$v["fieldName"]])){
                   if ($v["required"]){
                      $erMsg .= " O campo '".$v["display"]."' deve ser preenchido.<br>\r\n";
                      $result = false;
                   }
                }else{
                   if (!$this->_validaTipo($v["firldName"],$rs[$v["fieldName"]], $v["fieldType"])){
                      $result = false;
                      $erMsg .= " O valor informado para o campo '".$v["display"]."'  invlido.<br>\r\n";
                   }
                }
             }
          }

          return $result;
      }
       
      // sava os dados no banco
      function _saveData($act,$rs,$validado){
          $result = false;
          if (!$validado){
             $erMsg = "";
             if (!$this->_validaRecord($act,$rs,$erMsg)){
                $this->doOutErro($erMsg);
                return false;
             }
          }
          $q = new uMySQLSql();
          $q->conexao = $this->conexao->conn;
          if (count($this->dateMasks) > 0){
             $q->dateMasks = $this->dateMasks;
          }
          // rec  a copia do que  gravado
          $rec = $rs;
          if ($act == $this->actionList["INSERT"]){
              // gravar o insert
              $this->doBeforePost($act,$rs);

              $q->table    = $this->tableName;
              $q->command  = "INSERT";
              
              reset($this->dbFieldList);
              $ok = false;
              foreach($this->dbFieldList as $k => $v){
                // se o campo  auto_inc ou virtual nao relaciona na inclusao
                // campos 'act:...' so de controle do form html
                $readOnly = strpos( $v["kind"], "readonly" ) !== false;
                $valExp = "";
                if (!$readOnly){
                   $add = strpos( $v["kind"], "insert" ) !== false;
                   if ($add){
                      $valExp = getKindFixedValue("insert",$v["kind"]);
                   }
                }else{
                   $add = false;
                }

                if ($v["autoinc"] == false && $v["virtual"]==false && strpos($v["fieldName"],"act:")===false && $add){
                   $ok = true; // adicionou pelomenos 1 campo
                   $valorCampo = $rs[$v["fieldName"]];
                   if (count($this->fieldConversosr)>0 && isset($this->fieldConversosr[$k])){
                      $cmd = $this->fieldConversosr[$k];
                      $rec[$k] = $valorCampo = $cmd($valorCampo);
                   }
                   
                   if (strtolower($v["fieldType"]) == "exp" && !empty($valExp)){
                      // campo especial com valor expresso fixo
                      // Esse tipo de campo tem seu valor exibido no form, mas o usurio no pode altera-lo
                      $q->AddFieldVal($v["fieldName"],$v["fieldType"],$valExp);
                   }else{
                      $q->AddFieldVal($v["fieldName"],$v["fieldType"],$valorCampo);
                   }
                }

              }

              if ($q->Execute()){
                 $this->lastID = $q->lastID;
                 $this->doAfterPost($act,$rec,$q->lastID);
                 $result = true;
              }else{
                  $this->doSqlErro("_saveData()",$q->lastError,$q->sqlCheck);
              }
              
          }else if ($act == $this->actionList["UPDATE"]){
              // gravar o UPDATE
              $this->doBeforePost($act,$rs);

              $q->table    = $this->tableName;
              $q->command  = "UPDATE";

              $pks   = $this->_getPostIds($rs);
              $where = $this->_getWhereTo($pks,true,false);
              
              if (!empty($where)){
                 $where = str_replace(" WHERE","",$where);
                 $q->where = $where;
                 
                 reset($this->dbFieldList);
                 $ok = false;
                 foreach($this->dbFieldList as $k => $v){
                   // se o campo  auto_inc ou virtual nao relaciona na inclusao
                   // campos 'act:...' so de controle do form html
                   
                    $readOnly = strpos( $v["kind"], "readonly" ) !== false;
                    $valExp = "";
                    if (!$readOnly){
                       $add = strpos( $v["kind"], "update" ) !== false;
                       $valExp = getKindFixedValue("update",$v["kind"]);
                    }else{
                       $add = false;
                    }

                   if ($v["pk"] < 1 && $v["virtual"]==false && strpos($v["fieldName"],"act:")===false && $add){
                      $ok = true; // adicionou pelomenos 1 campo
                      $valorCampo = $rs[$v["fieldName"]];
                      if (count($this->fieldConversosr)>0 && isset($this->fieldConversosr[$k])){
                         $cmd = $this->fieldConversosr[$k];
                         $rec[$k] = $valorCampo = $cmd($valorCampo);
                      }

                      if (strtolower($v["fieldType"]) == "exp" && !empty($valExp)){
                         // campo especial com valor expresso fixo
                         // Esse tipo de campo tem seu valor exibido no form, mas o usurio no pode altera-lo
                         $q->AddFieldVal($v["fieldName"],$v["fieldType"],$valExp);
                      }else{
                         $q->AddFieldVal($v["fieldName"],$v["fieldType"],$valorCampo);
                      }

                   }
                 }
                 if ($q->Execute()){
                     $this->doAfterPost($act,$rec);
                     $result = true;
                 }else{
                     $this->doSqlErro("_saveData()",$q->lastError,$q->sqlCheck);
                 }
              }else{
                  $result = false;
              }

          }else if (($act == $this->actionList["DELETE"] || $act == $this->actionList["DELPOST"]) ){
              // executa delete
              $this->doBeforePost($act,$rs);

              $q->table    = $this->tableName;
              $q->command  = "DELETE";

              if ($act == $this->actionList["DELPOST"]){
                  $pks   = $this->_getPostIds($rs);
              }else{
                 $pks   = $this->_getUrlId($rs);
              }
              $where = $this->_getWhereTo($pks,true,false);

              if (!empty($where)){
                 $where = str_replace(" WHERE","",$where);
                 $q->where = $where;

                 if ($q->Execute()){
                     $this->doAfterPost($act,$rec);
                     $result = true;
                 }else{
                     $this->doSqlErro("_saveData()",$q->lastError,$q->sqlCheck);
                 }
              }else{
                  $result = false;
              }
          }else{
              $this->doSqlErro("_saveData()","Comando act invlido.",$act);
          }
          
          if ($result === true){
             $this->doOnPost($act,$rs);
          }
          return $result;
      }

      /**
       * monta condio de busca para UPDATE/DELETE/SELECT
       *
       * @param <array> $aIds      - Lista de capos para busca
       * @param <bool>  $igual     - flag de comparao indica se busca por valor igual ou diferente
       *                             como por exemplo para validar um campo unique
       * @param <bool>  $select    - indica se deve ou no montar a lista com alias
       *                             (somente na excluso de registros o alias deve ser ignorado)
       *
       */
      function _getWhereTo($aIds,$igual=true,$select=true){
          $result = "";
          $aNumbers = array("long","int","integer","currency","double","real","real_br","exp");
          foreach($aIds as $k=> $v){
             if ($select){
                 // Select - Usar alias
                 $a = $this->fieldAlias[$k];
                 if ($igual){
                    $exp = ($select)? "$a.$k=":"$k=";  // busca para sim (localiza registro para UPDATE/DELETE)
                 }else{
                    $exp = ($select)? "$a.$k<>":"$k<>"; // busca para no (valida uniques)
                 }
             }else{
                 // Update delete - Nao usar alias
                 if ($igual){
                    $exp = ($select)? "$k=":"$k=";  // busca para sim (localiza registro para UPDATE/DELETE)
                 }else{
                    $exp = ($select)? "$k<>":"$k<>"; // busca para no (valida uniques)
                 }
             }
             
             $field = $this->dbFieldList[$k];
             if (in_array($field["fieldType"],$aNumbers)){
                 $exp .= $v;
             }else{
                 $exp .= "'$v'";
             }

             $result .= (empty($result))? " WHERE $exp\r\n":" AND $exp\r\n";
          }
          
          if (empty($result)){
             $this->_halt("_getWhereTo() Condio de busca inexistente.");
          }
          return $result;
      }

      /** seta o array de saida para o formulrio html **/
      function _setResultSet($aResult){
         $n = $this->resultSet;
         $vlinha  = 'global $'.$n.'; ';
         $vlinha .= '$'.$n.'=$aResult;';
         eval($vlinha);
      }

      function _setVar($varNome,$value){
         $vlinha  = 'global $'.$varNome.'; ';
         $vlinha .= '$'.$varNome.'=$value;';
         eval($vlinha);
      }

      /* carrega valores para campos de persistencia */
      function _persistFields(&$aResult){
          reset($this->dbFieldList);
          foreach($this->dbFieldList as $k => $v){
             if (!empty($v["persitField"])){
                $aResult[0][$k] = $aResult[0][$v["persitField"]];
             }
          }
          return;
      }

       /** carrega o registro do banco de dados **/
       function _loadFromDb(){
            $idSeek = $this->_getUrlId();

            if (count($idSeek) < 1){
               $this->_halt("No foi informado o id do registro solicitado.");
            }
            
            $tab    = $this->tableName." a";
            $flds   = $this->_getSelectFields();
            $where  = $this->_getWhereTo($idSeek);

            $qry = new uMySQLQuery($idSeek);
            $qry->conexao = $this->conexao->conn;
            $qry->date_br = true;
            $qry->formatFloat = true;
            $qry->SQLAdd("SELECT $flds");
            $qry->SQLAdd("  FROM $tab");
            
            if (count($this->joinList)>0){
               $j =$this->_getJoinSql();
               $qry->SQLAdd("  $j");
            }
            
            $qry->SQLAdd($where);
            $qry->SQLAdd("limit 1");
            
            $rs = array(1);
            $o = $qry->Open();

            if ($o && $qry->RecordCount()>0){
               $rs = $qry->ArrayResult();
            }else{
               if (!$o){
                  $this->doSqlErro("_loadFromDb()",$qry->lastError,$qry->fSQLo);
               }
            }
            
            $this->_persistFields($rs);
            
            $this->_setResultSet($rs);
            return $rs;
       }
       
       
       /**
        * retorna um array associativo dos campos (db) com os valres postados correspondentes
        */
       function _getPost($safe=true){
          $result = array();
          
          //1 - carregar os campos postados
          reset($this->dbFieldList);
          foreach($this->dbFieldList as $k => $v){
             $valor = $this->_request($v["htmlField"],$v[""],"post",$k["fieldSize"],$safe);
             if ($this->ajax > 0){
                $valor = utf8_decode($valor);
             }
             $result[$v["fieldName"]] = $valor;
          }
          
          //2 - carrega a ao do form
          $act = $this->_request($this->actionField,false,"post");
          if ($act!==false){
              $result["act:confirma"] = $act;
          }
          $result["act:cancel"] = $this->actionList["CANCEL"];
          
          return $result;
       }
       
       /** Retorna o action da chamada **/
       function _getAction(){
          //tenta post
          $result = $this->_request($this->htmlActionField,false,"post");
          $a = (!$result)? "False":"True";

          if ($result==false){
             $result = $this->_request($this->urlAction,false,"get");
             
             if ($result == false){
                // se nao encontrol nenhuma action, checa se uma id foi passada na url
                $id =  $this->_request($this->urlIdFields,false,"get");
                if ($id == false){
                   //r: se nao passou nenhum id  um novo registro
                   $result = $this->actionList["NEW"];
                }
             }else{
                // se encontrou uma action por get, converte para action padrao
                $aconv = array($this->urlActionList["NEW"]=>$this->actionList["NEW"],
                               $this->urlActionList["SHOW"]=>$this->actionList["SHOW"],
                               $this->urlActionList["SHOWDEL"]=>$this->actionList["SHOWDEL"],
                               $this->urlActionList["DELETE"]=>$this->actionList["DELETE"]);
                $result = $aconv[ (int) $result ];

                if (empty($result)){ $result=false; }
             }
          }
          
          if ($result === false){
             $this->_halt("Ao indefinida ou invlida para a chamada.");
          }
          return $result;
       }
      
       /**
        *  Adiciona campos ao formulrio
        *
        * 1 @param <string> $fieldName: Nome do campo na tabela do banco de ddaos
        * 2 @param <string> $fieldType: Tipo do campo conforme classe uMySqlSql
        * 3 @param <int>    $fieldSize: Comprimento mximo do campo (zero para no  limitar)
        * 4 @param <int>    $pk:        Indicador de membro da PK, um numero maior que zero indica a ordem do campo na PK
        * 5 @param <bool>   $autoinc:   Campo AutoIncremental.
        * 6 @param <bool>   $required:  Flag de campo obrigatrio
        * 7 @param <bool>   $htmlField: Nome do campo correspondente no formulrio HTML
        * 8 @param <mix>    $defaultValue: Valor default para o campo
        * 9 @param <bool>   $virtual:   Indica um campo que no deve ser gravado no banco, mas existe no form html
        *10 @param <bool>   $unique:    Indica se o valor do campo deve ser nico na tabela
        *11 @param <bool>   $safePost:  Tratar o valor de entrada deste campo no get/post
        *12 @param <str>    $display:   Label amigavel do campo utilizado para mensagens de erro
        *13 @param <str>    $percistField Campo cujo valor sera retirdo para comparao futura (apos a gravao inclusive)
        *14 @param <str>    $kind       Especificaoes adicionais de ao (insert = usado em incluses, update = usado em alteraes, readonly/vazio = somente leitura)
        */
       function AddField($fieldName,$fieldType,$fieldSize,$pk,$autoinc,$required,$htmlField,$defaultValue,$virtual=false,
                         $unique=false,$safePost=true,$display="",$percistField="",$kind="insert,update"){
          $kind = (empty($kind))? "readonly":$kind;
          
          $this->dbFieldList[$fieldName] = array( "fieldName"=> $fieldName,
                                                  "fieldType"=> $fieldType,
                                                  "fieldSize"=> $fieldSize,
                                                  "pk"=> $pk,
                                                  "autoinc"=> $autoinc,
                                                  "required"=> $required,
                                                  "htmlField"=> $htmlField,
                                                  "defaultValue" => $defaultValue,
                                                  "virtual"=>$virtual,
                                                  "unique"=>$unique,
                                                  "safeMode"=>$safePost,
                                                  "display"=>$display,
                                                  "persitField"=>$percistField,
                                                  "kind" => $kind);
       }
       
       /*
        *  Adiciona definio para campo LookUp
        *
        *  @param <array> $lookUpDef:    Array contendo a definio de um campo lookUp com a seguinte
        *                                estrutura:
        *
        *                                array( "resultFieldName",           - campo na tabela principal no qual sera gravado o valor da seleo
        *                                       "lookUpTable",               - tabela que dever fornecer a lista de valores e opes
        *                                       "lookUpFieldValue",          - campo na tabela lookUp que faz a ligao com a tabela principal (valor da opo no combo html)
        *                                       "lookUpDisplay",             - campo na tabela lookUp que ser exibido como opo ao usurio na combo html.
        *                                       "lookUpDisplayOrder",        - campo que determina a ordenao da lista apresentada na combo html.
        *                                       "arrayOut")                  - nome do array usado na tag ex.: <exec name=makeSelect arr=arrayOut></exec>
       */
       function AddLookUp($lookUpDef){
          if (count($lookUpDef) < 6){
             $this->_halt("AddLookUp() A definio do campo lookUp '".$lookUpDef[0]."' esta incompleta.");
          }
          array_push($this->looUpFields,$lookUpDef);
       }


       /**
        *  Adiciona um array descrevendo um par de campos de confirmao.
        *  os valores postados em ambos os campos devem ser iguais para que sejam aceitos
        *
        *  @param <array> $aFieldConf:    formato array("nomeCampoReal","nomeCampoVirtual","Mensagem de erro")
        */
       function AddFieldConf($aFieldConf){
          $this->confFields[] = $aFieldConf;
       }
       
       /* adiciona funes de converso especiais para campos */
       function AddConversor($filedName,$funcName){
          $this->fieldConversosr[$filedName] = $funcName;
       }
       
       /**
        *   Adiciona Campo tipo radiobutton
        *   $aRbFieldDef = array("fieldname",array("value"=>"varOut",...))
       */
       function AddRadioField($aRbFieldDef){
           array_push($this->radioField,$aRbFieldDef);

       }
       
       /** retorna o nome da varivel para o valor do campo radiobutton **/
       function _getRadioFieldVar($index,$value){
            $result = false;
            $a = $this->radioField[$index];
            $va = $a[1];
            foreach($va as $k=> $v){
               if ($value == $k){
                  $result = '$'.$v; $ck = 'checked="checked"';
                  $cmd = 'global '.$result.'; '.$result."='".$ck."';";
                  eval($cmd);
               }
            }
            return $result;
       }
       
       /** seta as variveis para campos radiobuttom */
       function _setRadioFields(&$rec){
           $i=0;
           while ($i < count($this->radioField)){
               $v = $this->radioField[$i];
               $fieldName = $v[0];
               $vr = $this->_getRadioFieldVar($i, $rec[$fieldName]);
               if ($vr !== false){
                  $rec[$vr] ='checked="checked"';
               }
               $i+=1;
           }
       }
       
       /**
        *  Adiciona parametros para join
        *
        *  @param <array> $joinDef  - Parametros de especificao de juno
        *                             formato do array: array( <int> joinNivel,
        *                                                      array("leftTableName","leftFieldKey 1","leftFieldKey 2",...),
        *                                                      array("rightTableName","rightFieldKey 1","rightFieldKey 2",...),
        *                                                      array("joinedField1","joinedField2"...))
        *    Decrio dos elementos:
        *    joinNivel
        *          - Nivel de ligao com a tabela principal, Zero para relacionamento direto,
        *            1 se for ligado a uma tabela intermediria, 2 para duas tabelas e assim por diante
        *
        *    leftTableName
        *          - nome da tabela de ligao ( esquerda).
        *
        *    leftFieldKey 1..leftFieldKey n
        *          - Lista dos campos campos de ligao (na ordem correta) na tabela da esquerda
        *
        *    rightTableName
        *          - Nome da tabela a ser ligada
        *
        *    rightFieldKey 1..rightFieldKey n
        *          - Lista dos campos de ligao (na ordem correta) na tabela a ser ligada
        *
        *    joinedField1..joinedFieldn
        *          - Lista dos campos que incluidos da tabela relacoionada
        *
       */
       function Join($joinDef){
          // insere o novo join ordenado pelo nivel
          $this->joinList = put_sorted( $this->joinList, $joinDef, 0);
       }
       
       /**
        * monta a lista das tabelas utilizadas no select com os respectivos alias.
        * monta a lista de campos com os alias respectivos
        *
       */
       function _buildAlias(){
          $this->tableAlias = array(); $this->fieldAlias  = array();
          $this->tableAlias[$this->tableName] = "a";
          
          $i=0; $c = ord("a")+1;
          while ($i < count($this->joinList)){
             $v = $this->joinList[$i]; $i+=1;
             $tb1 = $v[1][0]; $tb2 = $v[2][0];
             if (!array_key_exists($tb1,$this->tableAlias)){
                $this->tableAlias[$tb1] = chr($c); $c+=1;
             }
             if (!array_key_exists($tb2,$this->tableAlias)){
                $this->tableAlias[$tb2] = chr($c); $c+=1;
             }
             $f = $v[3];
             // relaciona os campos juntados (join) e as alias das respectivas tabelas
             foreach($f as $k => $fn){
               // checa se o campo ja no esta na lista
               if (!array_key_exists($fn,$this->fieldAlias)){
                  $this->fieldAlias[$fn] = $this->tableAlias[$tb2];
               }
             }
          }
          
          // por fim analiza a lista de campos para ver quem
          // ainda nao esta relacionado definindo todos os que sobraram com o alias
          // da tabela principal
          reset($this->dbFieldList);
          foreach($this->dbFieldList as $k => $v){
             if (!$v["virtual"] && !array_key_exists($k,$this->fieldAlias)){
                $this->fieldAlias[$k] = "a";
             }
          }
          
       }

       /**
        *  Monta as listas para campos LookUp
        *
       */
       function _makeLookUps($rec){
          if (count($this->looUpFields) < 1){
             return false;
          }
          
          $qr = new uMySQLQuery();
          $qr->conexao = $this->conexao->conn;
          $qr->date_br = true;
          $qr->formatFloat = true;
          
          $i=0;
          while ($i < count($this->looUpFields)){
             $v = $this->looUpFields[$i];
             
             $qr->Close();
             $qr->SQLClear();
             
             $val  = $v[2]; $opt  = $v[3]; $comp = $v[0];
             $flds = $v[2].",".$v[3]; $tb = $v[1]; $ordem = $v[4]; $arr=$v[5];
             
             $qr->SQLAdd("SELECT $flds ");
             $qr->SQLAdd("  FROM $tb ");
             if (!empty($ordem)){
                $qr->SQLAdd("ORDER BY $ordem");
             }

             if ($qr->Open()){
                $lista = $qr->getArraySelect( $opt, $val, $val, $rec[$comp]);
                $cmd = 'global $'.$arr.'; $'.$arr.'=$lista;';
                eval($cmd);
             }else{
                $this->doSqlErro("_makeLookUps()",$qr->lastError,$qr->GetCommand());
             }
             $i+=1;
          }
          return true;
       }

       /** monta a lista de campos do select */
       function _getSelectFields(){
          $result = "";
          reset($this->dbFieldList);
          foreach($this->dbFieldList as $k => $v){
             $alias = $this->fieldAlias[$k];
             if ($v["virtual"] && !empty($alias)){
                $result .= (empty($result))? "$alias.$k":",$alias.$k";
             }else if (!$v["virtual"]){
                $result .= (empty($result))? "$alias.$k":",$alias.$k";
             }
          }
          return $result;
       }
       
       
       /** auxiliar, monta join individual **/
       function _joinTo($i){
          $joinDef = $this->joinList[$i];
          $jl = $joinDef[1];
          $jr = $joinDef[2];
          
          $result = "   LEFT JOIN ".$jr[0]." ".$this->tableAlias[$jr[0]]." ON \r\n";
          $i = 1;
          while ($i < count($jr)){
             $a = $this->tableAlias[$jr[0]].".".$jr[$i];
             $b = $this->tableAlias[$jl[0]].".".$jl[$i];
             // $a = $this->fieldAlias[$jr[$i]] .".".$jr[$i];
             // $b = $this->fieldAlias[$jl[$i]] .".".$jl[$i];
             $result .= ($i==1)? "$a=$b ":"AND $a=$b "; $i+=1;
          }
          return "$result\r\n";
       }
       
       /** monta a lista de Joins da SQL **/
       function _getJoinSql(){
          $result = "";$i=0;
          while($i < count($this->joinList)){
             $result .= $this->_joinTo($i);
             $i+=1;
          }
          return $result;
       }
       
       /** Retorna a lista de campos ordenada da PK **/
       function _getPkList(){
          $result = array();
          reset($this->dbFieldList);
          foreach($this->dbFieldList as $k => $v){
             if ($v["pk"] > 0){
                $result[$v["pk"]-1] = $v["fieldName"];
             }
          }
          return $result;
       }
       
       /** Chama manipulador do evento OnOutError **/
       function doOutErro($msg){
          if (!empty($msg) && !empty($this->OnOutError)){
              $cmd = $this->OnOutError;
              $cmd($this,$msg);
          }
       }

       
       /** processa a chamada do script **/
       function Execute(){
           global $confirm_action_value;
           global $cancel_action_value;
           global $titulo_do_form;
           global $form_nome;
           
           // Compatibiliza codigo anterior
           if (!$this->deleteEnabled){
              $this->disableFunctions("delete");
           }

           $noFunc = $this->disabledFuncs;

           $this->ajax = $this->_request("ajax",0,"post",1,$safe);
           if ($this->ajax == 0){
              $this->ajax = $this->_request("ajax",0,"get",1,$safe);
           }

           $this->_validaClasse();
           $this->_buildAlias();

           $titulo_do_form = "Cadastro de ".$this->nomeCadastro;
           
           $result = true;
           $rs     = array();
           $reg    = array();
           $act = $this->_getAction();

           $this->lastAction = $act;
           $cancel_action_value  = $this->actionList["CANCEL"];

           // resultSet
           if ($act == $this->actionList["NEW"]){
              if ($noFunc["insert"]){
                 $this->doOutErro("incluso no permitida !");
                 return false;
              }
              
              //r: Exibir form adicionar novo
              $confirm_action_value = $this->actionList["INSERT"]; // seta acao do form
              $form_nome = $this->fomNames["INSERT"];
              $titulo_do_form = "Adicionando ".$this->nomeCadastro;
              $rs = $this->_emptyRecord();
              $this->_setRadioFields($rs);
              $reg = $rs;
              $r  = array();
              array_push($r,$rs);
              $this->_setResultSet($r);
              $result = true;
           }else if ($act == $this->actionList["SHOW"]){
              if ($noFunc["show"]){
                 $this->doOutErro("Exibio no permitida !");
                 return false;
              }

              // Exibir form para edio do registro
              $rs = $this->_loadFromDb(); // carreda do banco
              $reg = $rs[0];
              $this->_setRadioFields($reg);
              $this->doDetailLoad($reg);
              $rs[0] = $reg;
              $titulo_do_form = "Alterando ".$this->nomeCadastro;
              $confirm_action_value = $this->actionList["UPDATE"]; // seta acao do form
              $form_nome = $this->fomNames["UPDATE"];
              $result = true;
           }else if ($act == $this->actionList["SHOWDEL"] && !$noFunc["show"]){
              if ($noFunc["show"]){
                 $this->doOutErro("Exibio no permitida !");
                 return false;
              }else if (!$noFunc["delete"]){
                 $this->doOutErro("Excluso no permitida !");
                 return false;
              }

              // Exibir form para edio do registro
              $rs = $this->_loadFromDb(); // carreda do banco
              $reg = $rs[0];
              $this->_setRadioFields($reg);
              $this->doDetailLoad($reg);
              $rs[0] = $reg;
              $titulo_do_form = "Excluindo ".$this->nomeCadastro;
              $form_nome = $this->fomNames["DELETE"];
              $confirm_action_value = $this->actionList["DELPOST"]; // seta acao do form
              $result = true;
           }else if ($act == $this->actionList["INSERT"] || $act == $this->actionList["UPDATE"]){
              if ($act == $this->actionList["INSERT"]){
                  if ($noFunc["insert"]){
                     $this->doOutErro("Insero no permitida !");
                     return false;
                  }
                 $titulo_do_form = "Adicionando ".$this->nomeCadastro;
                 $confirm_action_value = $this->actionList["INSERT"];
                 $form_nome = $this->fomNames["INSERT"];
              }else{
                  if ($noFunc["update"]){
                     $this->doOutErro("Edio no permitida !");
                     return false;
                  }

                 $titulo_do_form = "Alterando ".$this->nomeCadastro;
                 $confirm_action_value = $this->actionList["UPDATE"];
                 $form_nome = $this->fomNames["UPDATE"];
              }

              //r: gravar novo
              // seta acao do form
              $rs = $this->_getPost(); // recupera post
              $rs["act:confirma"] = $act;
              $reg = $rs;
              
              // valida post
              $accept = true; $erroMsg = "";
              $validado = false;
              if (!empty($this->OnValidate)){
                 $cmd = $this->OnValidate;
                 $accept   = $cmd($this,$act,$rs,$erroMsg,$validado);
                 $validado = !$validado;
              }
              
              // grava registro, se gravou, redireciona
              if ($accept){
                 if ($this->_saveData($act,$rs,$validado)){
                    if ($this->ajax == 1){
                        if ($act == $this->actionList["INSERT"]){
                            die( $this->lastID );
                        }else{
                           die("ok");
                        }
                    }
                    if (!empty($this->insertRedir)){
                       header("Location: ".$this->insertRedir); die();
                    }else{
                       $rs = $this->_getPost(false);
                       $this->_setRadioFields($rs);
                       $reg = $rs;
                       $a = array(); array_push($a, $rs);
                       $this->_setResultSet($a);
                    }
                 }else{
                    // se nao gravou houve falha na aplocao, _saveData() ja notificou o programador
                    // mostra novamente o formulario ao usurio
                    $rs = $this->_getPost(false);
                    $this->_setRadioFields($rs);
                    $reg = $rs;
                    $a = array(); array_push($a, $rs);
                    $this->_setResultSet($a);
                 }
              }else{
                 // envia mensagem de erro ao usurio se houver alguma
                 $this->doOutErro( $erroMsg );
                 $rs = $this->_getPost(false);
                 $this->_setRadioFields($rs);
                 $reg = $rs;
                 $a = array(); array_push($a, $rs);
                 $this->_setResultSet($a);
              }
           }else if ($act == $this->actionList["DELPOST"]){
              if ($noFunc["delete"]){
                 $this->doOutErro("Excluso no permitida !");
                 return false;
              }

               // DELETE VIA POST - Quando um form com os dados  exibido para confirmao
               $confirm_action_value = $this->actionList["DELETE"]; // seta acao do form
               $form_nome = $this->fomNames["DELETE"];
               $titulo_do_form = "Excluindo ".$this->nomeCadastro;

               $rs = $this->_getPost(false); // recupera post
               $rs["act:confirma"] = $act;
               $this->_setRadioFields($rs);
               $reg = $rs;
               if ($this->_saveData($act,$rs,true)){
                  if ($this->ajax == 1){
                      die("ok");
                  }
                  if (!empty($this->insertRedir)){
                     header("Location: ".$this->deleteRedir); die();
                  }else{
                     $rs = $this->_getPost(false);
                     $this->_setRadioFields($rs);
                     $reg = $rs;
                     $a = array(); array_push($a, $rs);
                     $this->_setResultSet($a);
                  }

               }else{
                  // se nao gravou houve falha na aplicao, _saveData() ja notificou o programador
                  // mostra novamente o formulario ao usurio
                  $rs = $this->_getPost(false);
                  $this->_setRadioFields($rs);
                  $reg = $rs;
                  $a = array(); array_push($a, $rs);
                  $this->_setResultSet($a);
               }

           }else if ($act == $this->actionList["DELETE"] && $this->enabledDelGet){
              if ($noFunc["delete"]){
                 $this->doOutErro("Excluso no permitida !");
                 return false;
              }

              // DELETE VIA GET - Quando a instruo  passada direto via url
              $confirm_action_value = $this->actionList["DELETE"]; // seta acao do form
              $form_nome = $this->fomNames["DELETE"];
              $titulo_do_form = "Excluindo ".$this->nomeCadastro;

              $rs = array();  // nao tem record porque nao  postado
              $rs["act:confirma"] = $act;
              $reg = $rs;
              $this->_saveData($act,$rs,true);
              
              if ($this->ajax == 1){
                  die("ok");
              }

              if (!empty($this->insertRedir)){
                  header("Location: ".$this->deleteRedir); die();
              }else{
                 $this->_halt("insertRedir no especificado.");
              }
           }else if ($act == $this->actionList["CANCEL"]){
              if ($this->ajax == 1){
                  die("ok");
              }

              if (!empty($this->insertRedir)){
                  header("Location: ".$this->cancelRedir); die();
              }else{
                 $this->_halt("cancelRedir no especificado.");
              }
           }else{
              $this->_halt("$this->className.Execute() Erro: Ao invlida '$act'");
              $act = false;
           }
           
           $this->_makeLookUps($reg);
           if ($act != false){
              $this->doOnShow($act,$reg);
           }
       }

        // valida valor de campo conforme o tipo especificado
    	function _validaTipo($fieldName,$theValue, $theType){
    	    $result = false;
    		$m = "";
    		switch ($theType) {
    		case "exp" :
              $result = true;
    		  break;
    		case "string_safe" :
              $result = true;
    		case "text":
    		case "string":
    		case "date":
    		  $result = true;
    		  break;
            case "date_br":
              $m  = "d/m/a";  // formato de entrada
              $result = dataValida($theValue,$m);
              break;
            case "datetime_br" :
              $m  = "d/m/a h:i:s";    //r: formato de entrada
            case "timestamp_br" :
              $result = dataValida($theValue,$m);
              break;
    		case "long":
    		case "int":
    		case "integer":
    		  if (!empty($theValue)){
                 $old = $theValue;
                 $theValue = (int) $theValue;
                 $result = !empty($theValue);
              }else{
                $result = true;
              }
    		  break;
    		case "currency":
    		case "double":
    		case "real":
    		  if (!empty($theValue)){
                  $old = $theValue;
                  $theValue = (float) $theValue;
                  $result = !empty($theValue);
              }else{
                $result = true;
              }
    		  break;
    		case "real_br":
    		  if (!empty($theValue)){
                  $old = $theValue;
                  $theValue = str_replace(".","",$theValue);
                  $theValue = str_replace(",",".",$theValue);
                  $theValue = (float) $theValue;

                  $result = !empty($theValue);
              }else{
                 $result = true;
              }
    		  break;
    		case "defined":
              $result = true;
    		  break;
    		}
    	    return $result;
    	}

    }

    /*
        Funes de apoio
    */

    
    function  getKindFixedValue($kind,$kindStr){
       $kind = strtolower($kind);
       $ak = split(",",$kindStr);
       $result = "";
       if (is_array($ak)){
          foreach($ak as $v){
             $i = strpos($v,"["); $f = strpos($v,"]");
             if (strpos(strtolower($v),$kind) !== false && $i !== false){
                 if ($f !== false){
                    $result = substr($v,$i+1,$f-($i+1));
                 }else{
                    $result = substr($v,$i+1);
                 }
             }
          }
       }
       return $result;
    }


?>
