<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004 
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/o_files.php"); 
  /*{$NC-}*/
  /*{$CB+}
  uses("o_files");
  {$CB-}*/

  class uIniFile extends uFile {
	  var $a_sections;
	  var $a_dados;
      var $f_loaded = false;

	  function uIniFile(){
	      $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uIniFile";
	      $classPath = (func_num_args() > 1)?  "uIniFile.".func_get_arg(1):"uIniFile";

		  $this->uFile($name,$classPath); //r: inherited

		  $this->a_sections = array();
		  $this->a_dados    = array();
		  $this->f_loaded   = false;
	  }

      function PV_LineToKeyValue($linha) {
	     $key = ""; $val = "";
		 $i = strpos($linha,"=");
		 if ($i !== false){
		    $key = substr($linha,0,$i);
			$val = substr($linha,$i+1);
		 }else{
		    $key = $linha;
		 }
		 return array(0 => $key,1 => $val);
	  }

      function Active(){
        return $this->f_loaded;
	  }

	  function Load() {
		 if ($this->vOpen === true) {
		    $this->Close;
		 }
		 if (!file_exists($this->fileName)) {
			 //r: Criando um novo arquivo
			 $this->f_loaded = true;
			 $this->a_sections = array();
		     return true; 
		 }else{
			 $this->openMode = "rb";
			 $this->f_loaded = false;
			 $this->a_sections = array();
			 $curr_sec      = array();
			 $curr_sec_nome = "noSec";
			 if ($this->Open()) {
				while (!$this->Eof()) {
				  $buff = $this->ReadLn();
				  if ($buff !== false) {
					 $buff = trim($buff);
					 if (strlen($buff) > 0) {
						if ($buff{0} == "[") {
						   if (count($curr_sec) > 0) {
							  $this->a_sections[$curr_sec_nome] = $curr_sec;
							  $curr_sec = array();
						   }
						   $curr_sec_nome = substr($buff,1,strlen($buff)-2);
						}else{
						  $bfres = $this->PV_LineToKeyValue($buff);
						  $curr_sec[$bfres[0]] = $bfres[1]; 
						  unset($bfres);
						}
					 }
				  }
				}
				//r: Salva a ultima seo do arquivo
				if (count($curr_sec) > 0) {
				   $this->a_sections[$curr_sec_nome] = $curr_sec;
				   $curr_sec = array();
				}
				$this->Close();
				$this->f_loaded = true;
				return true;
			 }else{
			   return false;
			 }
		 }
	  }
      
	  function Save(){
		 if ($this->vOpen === true) {
		    $this->Close;
		 }
         $this->openMode = "w+b";
		 if ($this->Open()) {
            foreach($this->a_sections as $sec_name => $sec_data) {
			   $linha = "[$sec_name]";
			   $this->WriteLn($linha);
			   foreach($sec_data as $key => $value) {
			     $linha = $key."=".$value;
				 $this->WriteLn($linha);
			   }
			   $this->WriteLn("");
			}
			$this->Close();
		 }
	  }

      //r: Le a seo inteira Chaves e valores
	  function ReadSection($sec_name){
	    if (array_key_exists($sec_name,$this->a_sections)) {
		   return $this->a_sections[$sec_name];
		}else{
		   return false;
		}
	  }

      //r: Exclui uma seao do arquivo
	  function EraseSection($sec_name) {
	    if (array_key_exists($sec_name,$this->a_sections)) {
		   unset($this->a_sections[$sec_name]);
		   return true;
		}else{
		   return false;
		}
	  }

      //r: Exclui chave
      function DeleKey($sec_name,$key_name){
	    if (array_key_exists($sec_name,$this->a_sections)) {
		   $sec = $this->a_sections[$sec_name];
		   if (array_key_exists($key_name,$sec)){
		      unset($sec[$key_name]);
			  $this->a_sections[$sec_name] = $sec;
			  return true;
		   }else{
		     return false;
		   }
		}else{
		   return false;
		}
	  }


      //r: Retorna a lista de chaves da secao
      function ReadSectionKeys($sec_name){
	    if (array_key_exists($sec_name,$this->a_sections)) {
		   $sec = $this->a_sections[$sec_name];
		   $result = array(); $i = 0;
           foreach($sec as $key => $value){
             $result[$i] = $key;
			 $i += 1;
		   }
		   return  $result;
		}else{
		   return false;
		}
	  }

      //r: Retorna a lista de valores da secao
      function ReadSectionValues($sec_name){
	    if (array_key_exists($sec_name,$this->a_sections)) {
		   $sec = $this->a_sections[$sec_name];
		   $result = array(); $i = 0;
           foreach($sec as $key => $value){
             $result[$i] = $value;
			 $i += 1;
		   }
		   return  $result;
		}else{
		   return false;
		}
	  }

      function ReadValue($sec_name,$key_name,$default_value){
	    if (array_key_exists($sec_name,$this->a_sections)) {
		   $sec = $this->a_sections[$sec_name];
		   if (array_key_exists($key_name,$sec)){
		      return $sec[$key_name];
		   }else{
		     return $default_value;
		   }
		}else{
		   return $default_value;
		}
	  }

      function WriteValue($sec_name,$key_name,$value){
	    if (array_key_exists($sec_name,$this->a_sections)) {
		   $sec = $this->a_sections[$sec_name];
		   $sec[$key_name] = $value;
		   $this->a_sections[$sec_name] = $sec;
		}else{
		   $new_sec = array($key_name => $value);
		   $this->a_sections[$sec_name] = $new_sec;
		}
	  }


  } //r: class
?>