<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004 
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/o_files.php"); 
  /*{$NC-}*/
  /*{$CB+}
  uses("o_files");
  {$CB-}*/

  class uLDFile extends uFile {
	  var $firstFieldSetType;   //r: Layout definido pelo primeiro campo ?
      var $fieldDef;            //r: Definies dos campos
	  var $multiTypeRecords;    //r: Registros com layout diferentes ?
      var $useFFieldToIndex;    //r: Utilizar o contedo do primeiro campo como indice de tipo para registro
      var $lastLine;            //r: Ultima linha lida sem processamento

      //r: Eventos
      var $beforeRead;          //r: Antes de ler o registro - Ocorre antes de onRead.
	                            //r: formato: function($sender)
	  var $afterSetFField;      //r: Disparado apos a definio do primeiro campo quando $multiTypeRecords = true
	                            //r: (use para setar manualmente o indice de definies de campo quando for o caso)
	                            //r: formato: function(&$sender,$firstFieldVal,&$indexDef)
	  var $onCalcField;         //r: Disparado aps a completa leitura e processamento do registro lido do arquivo.
	                            //r: formato: function($sender,&$arecord,$idxdef)
	  var $onFieldLoad;         //r: Disparado aps onRead antes de setar o valor do campo (use para ajustar o valor do campo)
	                            //r: Formato function($sender,$fieldName,&$fieldValue,$idxDef)

	  function uLDFile(){
	      $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uLDFile";
	      $classPath = (func_num_args() > 1)?  "uLDFile.".func_get_arg(1):"uLDFile";

		  $this->uFile($name,$classPath); //r: inherited
	  
	      $this->multiTypeRecords  = false;
	      $this->firstFieldSetType = false;
	      $this->fieldDef          = array();
	      $this->useFFieldToIndex  = false;
	      $this->lastLine = "";

	      $this->beforeRead     = "";
	      $this->afterSetFField = "";
		  $this->onCalcField    = "";
		  $this->onFieldLoad    = "";
	  }


      //r: Limpa definies de campo
	  function ClearFieldDef($index = false){
	     if ($index === false) {
		    unset($this->fieldDef);
			$this->fieldDef = array();
		 }else{
		    unset($this->fieldDef[$index]);
		 }
	  }

      //r: Adiciona definio de campo
      function AddFieldDef($fName,$fStart,$fLen,$fValorDefault,$idxDef = 0) {
		 $tmp_def = array();
		 if (!array_key_exists($idxDef,$this->fieldDef)){
            $tmp_def[$fName] = array("inicio" => $fStart,"tamanho" => $fLen,"value" => $fValorDefault);
		 }else{
		    $tmp_def = $this->fieldDef[$idxDef];
            $tmp_def[$fName] = array("inicio" => $fStart,"tamanho" => $fLen,"value" => $fValorDefault);
		 }
	     $this->fieldDef[$idxDef] = $tmp_def;
	  }


      function _LD_LerMultiRecord($buff) {
		  $tmp = $this->fieldDef;
		  list($aindex,$fieldDef) = each($tmp);
          list($fldnome,$fldDef)  = each($fieldDef);
		  if (!empty($this->afterSetFField)) {
             $fval = substr($buff,0,$fldDef["tamanho"]);
		     $cmd = $this->afterSetFField . '($this,$fval,$aindex);';
		     eval($cmd);
		  }else if ($useFFieldToIndex === true) {
             $aindex = trim(substr($buff,0,$fldDef["tamanho"]));
		  }
		  return $this->_LD_LerSimples($buff,$aindex);
	  }

      function _LD_LerSimples($buff,$idxfd) {
	    $aresult  = array();
		$fnomes   = array(); $n = 0;
		$fieldDef = $this->fieldDef[$idxfd];
	    //r: inicializa todos os campos definidos
		foreach($fieldDef as $fldnome => $fldDef) {
		   $aresult[$fldnome] = $fldDef["value"];
		   $fnomes[$n] = $fldnome; $n += 1;
		}

		$n = 0;
		while ($n < count($fieldDef)) {
		  $fd = $fieldDef[$fnomes[$n]];
		  if (($fd["tamanho"] > 0) && (strlen($buff) >= ($fd["inicio"]+$fd["tamanho"]-1))) {
			  $s  = substr($buff,$fd["inicio"],$fd["tamanho"]);
			  
			  if (!empty($this->onFieldLoad)) {
				 $cmd = $this->onFieldLoad . '($this,"'.$fnomes[$n].'",$s,$idxfd);';
				 eval($cmd);
			  }
			  $aresult[$fnomes[$n]]  = $s;
		  }
		  $n += 1;
		}
        //r: onCalcField
		if (!empty($this->onCalcField)) {
		  $cmd = $this->onCalcField . '($this,$aresult,$idxfd);';
		  eval($cmd);
		}
		return $aresult;
	  }

      //r: L o prximo registro do arquivo
	  function ReadRecord(){
		 if ($this->vOpen === false) {
		    return false;
		 }else{              
			if (!empty($this->beforeRead)) {
			  $cmd = $this->beforeRead . '($this);';
			  eval($cmd);
			}
            $buff = $this->ReadLn();
            $this->lastLine = $buff;
			if ($this->multiTypeRecords === true) {
			   return $this->_LD_LerMultiRecord($buff);
			}else{
			   return $this->_LD_LerSimples($buff,0);
			}
		 }
	  }
	  
  } //r: Class
?>
