<?php
  /* ---------------------------------------------------------------------------
     uLib Versao 3.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
     Inicio: 15/09/2004
     Atualizado em: 31/05/2011


     15/06/2011 - Alexandre
                  Substituidos os metodos _SQLDateFormat() e _SQLTimeStampBR()
                  pela funo convertData() em lib_seg.php

     ---------------------------------------------------------------------------
     31/05/2011 - Alexandre
                  Corrigido o bug do metodo _SQLTimeStampBR()
	 ---------------------------------------------------------------------------
  */
  /*{$NC+}   nao compilar este bloco */
  uses("objects","lib_misc","lib_seg");
  /*{$NC-}*/
  /*{$CB+}  Compilar este bloco
  uses("objects","lib_misc","lib_seg");
  {$CB-}*/

  function getDeltaErro($rowsAffec,$errNum,$errStr,$encriptMode){
       $linha_zero = "strCount=1|rowsaffect=$rowsAffec|errNum=$errNum|errStr=$errStr";
       //r: codifica a linha do header
       $linha_zero = ($encriptMode == 1)? SoftEncode($linha_zero):$linha_zero;
       $linha_zero = ($encriptMode == 2)? hex_encode($linha_zero):$linha_zero;
       $linha_zero = ($encriptMode == 3)? str_to_hex($linha_zero):$linha_zero;
       return "\r\n<!--\r\n".$linha_zero."\r\n-->\r\n";
  }

  function encodeString($str,$encriptMode){
     if ($encriptMode == 1){
        return SoftEncode($str);
     }else if ($encriptMode == 2){
        return hex_encode($str);
     }else if ($encriptMode == 3){
        return str_to_hex($str);
     }else{
       return SoftEncode($str);
     }
  }

   function decodeString($str, $encriptMode){
      if ($encriptMode == 1){
         return  SoftEncode( $str, true );
      }else if ($encriptMode == 2){
         return hex_decode( $str );
      }else if ($encriptMode == 3){
         return  hex_to_str( $str );
      }else{
         return false;
      }
   }

   /* Prepara a SQL para execuo (substitui parmetros por valores)
      Nota o nome do paramepro na lista  composto de:
           tipo+nomeParam ou seja TNNNNNNN...
       onde T  o caracter de formato (N = Numrico e S = String) que define de
       o valor deve ou no estar entra aspas na SQL

       Formato do array $Params:
          $Params["nomeParametroIncluindoOTipo"] = ParamValor
   */
   function PrepareSQL($sql,$Params){
      foreach($Params as $k => $value){
         $type = substr($k,0,1);
         $name = ":" . substr($k,1);
         $valor = ($tipo=="N")?  $value:"'$value'";
         $sql = str_replace($name,$valor,$sql);
      }
      return $sql;
   }

  class uMySQLQuery extends uObject {
    /**
     * Conexo MySQL Identificador
     * @var int
     */
	 var $conexao;
    /**
     * Definicoes dos campos no banco de dados
     * @var array
     */
    var $db_fieldDef;
    /**
     * Descrio textual do ultimo erro ocorrido
     * @var string
     */
	 var $lastError;
    /**
     * Retornar datas no formato brasuileiro
     * @var boolean
     */
    var $date_br;
    /**
     * Apresentar os resultados da consulta em pginas.
     * A quantidade mxima de registro por pgina deve ser definida
     * na propriedade 'limit'.
     * @var boolean
     */
	 var $paginado;
    /**
     * Nmero da pgina que dever ser exibida (somente consulta paginada).
     * Define o nmero da pagina que deve ser retornada para a chamada atual.
     * Se o numero da pagina informado for superior ao nmero de pginas
     * disponveis, ser retornada a ultima pgina da pesquisa 'ecurrentPage'
     * ser atualizado com este valor (nmero da ultima pgina)
     * @var int
     */
	 var $currentPage;
    /**
     * Nmero mximo de registros retornados em um pgina (consulta paginada)
     * @var int
     */
	 var $limit;
    /**
     * SQL alternativa para avaliao de registros afetados/encontrados
     * @var string
     */
    var $CountSQL;
    /**
     * Evento. O evento OnLoadRec  disparado assim que cada registro retornado
     * por uma consulta  carregado no buffer.
     * Um manipulador poder ser definido para alterar, ou acrescentar informaes
     * no buffer do registro.
     * O buffer do registro  um array associativo que pode ser manipulado para
     * que novos campos sejam adicionadaos (campos calculados) ou o valor
     * dos campos existentes alterados.
     *
     * Sintaxe de acesso:
     *    $objQRY->fBuffer["nome_do_campo"] = "um valor qualquer"
     *
     * Interface: OnLoadRec(&$sender)
     * @var function
     */
	 var $OnLoadRec;
    /**
     * Campo privado, instruo SQL adicionada para a realizao da pesquisa.
     * @var string
     * @access private
     */
	 var $SQL;
    /**
     * Utima instruo SQL enviada ao banco. 'fSQLo' retorna a verso processada
     * da SQL da forma como foi enviada ao MySQL.
     * @var string
     * @access private
     */
	 var $fSQLo;
    /**
     * Registro inicial
     * @var int
     * @access private
     */
	 var $fRrecIni;             //r: Privado - Registro Inicial;
    /**
     * Total de pginas (modo paginado)
     * @var int
     * @access private
     */
	 var $fPageCount;
    /**
     * Total geral de registro (modo paginado)
     *
     * @var int
     * @access private
     */
	 var $fAllRecCount;
    /**
     * indica se uma consulta (select) esta aberta
     * @var boolean
     * @access private
     */
    var $fActive;
    /**
     * ResultSet original da pesquisa
     * @var resultset
     * @access private
     */
	 var $fRS;
    /**
     * Nmero de registros retornados.
     * @var int
     * @access private
     */
	 var $fRecCount;
    /**
     * Nmero do registro corrente
     * @var int
     * @access private
     */
	 var $fRecno;
    /**
     * Buffer para registro lido.
     * Array associativo contendo o ultimo registro lido (registro corrente)
     * @var array
     */
	 var $fBuffer;
    /**
     * Flag indicador de inicio e fim de arquivo (0 = bof, 2 = eof)
     * @var int
     * @access private
     */
    var $fSide;

    //r: display de numeros decimais
    /**
     * Indica se numeros reais devero ser formatados.
     * @var boolean
     */
    var $formatFloat;
    /**
     * Mascara padro para numeros reais defalt "#.##0,00"
     * @var string
     */
    var $floatMask;
    /**
     * lista de mascaras especficas para campos do tipo real. Permite
     * definir mascaras personalizadas para cada campo. Qualquer
     * campo que no possuir uma mascara na lista (no relacionado),
     * ser fornecido no formato padro (floatMask)
     * formato: ["nome_do_campo"] = "mascara_correspondente".
     * @var array
     */
    var $fMaskList;

    function uMySQLQuery() {
	     $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uMySQLQuery";
	     $classPath = (func_num_args() > 1)?  "uMySQLQuery.".func_get_arg(1):"uMySQLQuery";

		  $this->uObject($name,$classPath); //r: inherited

		  if ($this->onFree != "") {
		     $this->onFree     .= '($this);$this->uMySQLQueryDestroy';
		  }else{
	          $this->onFree     = '$this->uMySQLQueryDestroy';
		  }

		  $this->db_fieldDef     = array();
		  $this->cahe_fieldDef   = array();
		  $this->conexao         = -1;
		  $this->SQL             = "";
		  $this->lastError       = "";
		  $this->date_br         = false;
		  $this->fActive         = false;
		  $this->fRS             = false;
		  $this->fRecCount       = 0;
		  $this->fRecno          = 0;
		  $this->OnLoadRec       = "";

		  $this->fSQLo           = "";
		  $this->currentPage     = 0;
		  $this->paginado        = false;
		  $this->limit           = 0;
		  $this->fPageCount      = 0;
		  $this->fRecIni         = 0;
		  $this->fAllRecCount    = 0;

          $this->formatFloat     = false;
          $this->floatMask       = "#.##0,00"; //
          $this->fMaskList       = array();

	}

    function _HaveData(){
	  return ($this->fActive === true && $this->RecordCount() > 0);
	}

   /**
    * Retorna a instruo SQL definida para consulta.
    *
    * @return string
    */
   function SQL(){
	   return $this->SQL;
	}

   /**
    * Limpa (apaga) a instruo SQL atual.
    */
   function SQLClear(){
	   $this->SQL = "";
	   $this->fSQLo = "";
	}

   /**
    * Adiciona um linha de texto a instruo SQL
    *
    * @param string $text
    */
   Function SQLAdd($text){
	   if (empty($this->SQL)) {
	      $this->SQL = "$text \r\n";
	   }else{
	      $this->SQL .= "$text \r\n";
	   }
	}

   /**
    * Utima instruo SQL enviada ao banco. GetCommand() retorna a verso processada
    * da SQL da forma como foi enviada ao MySQL.
    * @return string
    */
   function GetCommand(){
	   return $this->fSQLo;
	}

   /**
    * Retorn true se uma consulta estiver aberta ou false em caso contrrio.
    *
    * @return boolean
    */
    function Active(){
	  return $this->fActive;
	}
   /**
    * Testa incio da lista (RecordSet). Retorna True se o ponteiro de leitura
    * estiver posicionado no inicio da lista.
    *
    * @return boolean
    */
    function Bof(){
	   return $this->fSide == 0;
	}

   /**
    * Testa fim da lista (RecordSet). Retorna True se o fim da lista foi
    * alcanado.
    *
    * @return boolean
    */
   function Eof(){
	   return $this->fSide == 2;
	}

   /**
    * @access private
    */
    function uMySQLQueryDestroy(){
       $this->Close();
	}

   /**
    * @access private
    */
    function _MySQErr($err){
	    $this->lastError = $err;
	}

   /**
    * Retorna uma cpia (array associativo) do registro corrente.
    *
    * @return array
    */
    function GetBuffer(){
	   return $this->GetARecord();
	}


   /**
    * @access private
    */
    function _LoadRec(){
	    $result = ($this->fBuffer = mysql_fetch_assoc($this->fRS));
        $this->_ProcessRecordData();

		if (!empty($this->OnLoadRec)){
		   $cmd = $this->OnLoadRec;
           $cmd($this);
		}
		return $result;
	}

   /**
    * @access private
    */
    function _FormatFloat($fieldName,$value){
       if (!$this->formatFloat || empty($this->floatMask)){
          return $value;
       }else{
          if (isset($this->fMaskList[$fieldName]) && !empty($this->fMaskList[$fieldName])){
             $mask = $this->fMaskList[$fieldName];
          }else{
             $mask = $this->floatMask;
          }

          $ms = strpos($mask,".");
          $ds = strpos($mask,",");

          if ($ms === false && $ds === false){
             //r: sem separadores - mascara invalida
             $result = (string) ((int) $value);
             $result = str_pad($result, strlen($mask), "0", STR_PAD_LEFT);
          }else if ($ms === false && $ds !== false){
             //r: com separador de decimal apenas
             list($m1,$m2) = split(",",$mask,2);
             if (empty($m2)){ $m2 = "0";}

             $result = number_format($value,strlen($m2),',','');
          }else if ($ms !== false && $ds !== false){
             //r: separadores de milhar e decimal
             list($m1,$m2,$m3) = split("[\.,]",$mask,3);
             if (empty($m3)){ $m3 = "0";}
             $result = number_format($value,strlen($m3),',','.');
          }
          return $result;
        }

    }


   /**
    * converte valores dos campos para regional brasil
    * @access private
    */
   function _ProcessRecordData(){
	  $filed_list = $this->GetFieldNames();
	  foreach($filed_list as $fieldname){
	     $fDef = $this->db_fieldDef[$fieldname];

		 if (!empty($this->fBuffer[$fieldname])){
             $data = $this->fBuffer[$fieldname];

             //r: converso de datas para o formato BR
             if ($this->date_br === true){
			    if ($fDef["type"] == "date"){
                   $this->fBuffer[$fieldname] = convertData($data,"a-m-d","d/m/a");
                }else if ($fDef["type"] == "datetime"){
                   $this->fBuffer[$fieldname] = convertData($data,"a-m-d h:i:s","d/m/a h:i:s");
			    }else if($fDef["type"] == "timestamp"){
                   $this->fBuffer[$fieldname] = convertData($data,"a-m-d h:i:s","d/m/a h:i:s");
			    }
			 }
			 //r: formata numeros reais
			 if ($this->formatFloat){
                if ($fDef["type"] == "real"){
                   $this->fBuffer[$fieldname] = $this->_FormatFloat($fieldname,$data);
                }
             }
		 }
	  }
	}

   /**
    * @access private
    */
   function _DecompSQL(){
	   $i = strpos($this->SQL, "FROM");
	   if ($i === false){$i = strpos($this->SQL, "from"); }
	   if ($i === false){
	      return "";
	   }else{
	      return substr($this->SQL,$i);
	   }
	}


   /**
    * Prepara SQL
    * @access private
    */
	function _SQLPrepare(){
	  $this->fSQLo = $this->SQL;
      if ($this->paginado !== false) {
	     $a_sql  =  $this->_DecompSQL();
		 $tmpSQL  = "SELECT COUNT(0) AS all_rec $a_sql";
         $tmp_result = mysql_query( $tmpSQL, $this->conexao );
		 if (($tmp_result !== false) && (mysql_num_rows($tmp_result) > 0)) {
             $row = mysql_fetch_assoc($tmp_result);
			 $this->fAllRecCount = $row["all_rec"];
             if ($this->limit > 0) {
				//r: Total de pagina
			    $this->fPageCount  = (int) ($this->fAllRecCount / $this->limit);
				if (($this->fAllRecCount % $this->limit) > 0) {
				   $this->fPageCount += 1;
				}if ($this->fAllRecCount > 0 & $this->fPageCount == 0){
                   $this->fPageCount += 1;
                }

				if ($this->currentPage > $this->fPageCount){
				   $this->currentPage = $this->fPageCount;
				}
				if ($this->currentPage < 1) {
				   $this->currentPage = 1;
				}
                //r: Registro inicial
                $this->fRecIni  = $this->limit * ($this->currentPage -1);
			    $this->fSQLo    = sprintf("%s LIMIT %d, %d", $this->SQL, $this->fRecIni, $this->limit);
			 }else{
			    $this->fRecIni = 0;
			 }
		 }else{
		    $this->fAllRecCount = 0;
		 }
	     if ($tmp_result !== false) {mysql_free_result($tmp_result);}
	  }
	}

   /**
    * Obtem informaes dos campos
    * @access private
    */
    function _getFieldInfo(){
	    $aresult = array();
		for ($i = 0; $i < mysql_num_fields($this->fRS); $i++) {
		  $campo = mysql_fetch_field($this->fRS,$i);
		  if ($campo !== false && $campo->name != "ZKU23SRS52_723876") {
		     $aresult[$campo->name] = array("table" => $campo->table,
				                            "max_length" => $campo->max_length,
				                            "not_null" => ($campo->not_null == 1),
				                            "primary_key" => ($campo->primary_key == 1),
				                            "unique_key" => ($campo->unique_key == 1),
				                            "multiple_key" => ($campo->multiple_key == 1),
				                            "numeric" => ($campo->numeric ==1),
				                            "blob" => ($campo->blob),
				                            "type" => $campo->type,
				                            "unsigned" => ($campo->unsigned == 1),
				                            "zerofill" => ($campo->zerofill == 1));

		  }
		}

		$this->db_fieldDef = $aresult;
	}

   /**
    * Fecha consulta ativa e libera os recursos
    */
    function Close() {
	   if ($this->fActive == true) {
	      mysql_free_result($this->fRS);
		   $this->fRS         = false;
		   $this->fActive     = false;
         $this->fRecCount   = 0;
		   $this->fRecno      = 0;
		   unset($this->db_fieldDef);
		   $this->db_fieldDef = array();
	   }
	}

    /**
     * Abre consulta.
     * @return boolean
     */
    function Open(){
	   if ($this->fActive){
	      $this->Close();
	   }
	   if (($this->conexao == -1) || (empty($this->SQL))) {
          $this->lastError = ($this->conexao == -1)? "Identificador de conexo no informado.":"SQL no definida.";
	      return false;
	   }else{
		  $this->_SQLPrepare();
          $this->fRS = mysql_query( $this->fSQLo, $this->conexao );
		  $this->fRecno    = 0;
          if ($this->fRS === false){
			 $this->_MySQErr(mysql_error());
			 $this->fActive   = false;
			 $this->fRecCount = 0;
		  }else{
		     $this->fActive = true;
             $this->fRecCount   = mysql_num_rows($this->fRS);
			 $this->_getFieldInfo();
			 $this->fSide = 0;
			 $this->_LoadRec();
		  }
	   }
	   return ($this->fRS !== false);
	}

   /**
    * Retorna um array multidimencional contendo o resultado da pesquisa.
    *
    * @return array
    */
   function ArrayResult(){
	  if ($this->_HaveData()){
   	  $ar = array();
	     $this->First();
	     while (!$this->Eof()){
		    array_push($ar, $this->fBuffer);
	       $this->Next();
	     }
	  }else{
	     $ar = array(1);
	  }
	  return $ar;
	}

   /**
    * Monta array para prenchimento de campo select (combobox)
    *
    * @param string $field_label Campo utilizado como opo a ser escolhida pelo usurio na combo
    * @param string $field_value Campo utilizado para valor da opo, retornado quando o usurio seleciona uma opo
    * @param string $selectedField Campo utilizado para determinar qual das opes estar selecionada inicialmente (opcional)
    * @param mix $selectedValue Valor de comparao com o qual $selectedField sera comparado para determinar qual a opo selecionada
    *
    * @return array
    */
   function getArraySelect($field_label,$field_value,$selectedField="",$selectedValue=""){
	  if ($this->_HaveData()){
   	  $ar = array();
	     $this->First();
	     while (!$this->Eof()){
           $op = array();
           $op["option"]  = $this->FieldValue($field_label);
           $op["value"]   = $this->FieldValue($field_value);
           if (empty($selectedField) || empty($selectedValue)){
              $op["selected"]= $this->FieldValue("selected");
           }else{
              if ($this->FieldValue($selectedField)==$selectedValue){
                 $op["selected"]= "selected";
              }else{
                 $op["selected"]= "";
              }
           }
		   array_push($ar, $op);
	       $this->Next();
	     }
	  }else{
	     $ar = array(1);
	  }
	  return $ar;
    }

   /**
    * Devolve o numero de registros retornado pela consulta.
    * Nota: Nas consultas paginadas RecordCount() retornara o nmero de
    * registros na pgina, para obter o nmero total de registros que
    * satisfazem os critrios da pesquisa, use 'PgRecordCount()'.
    *
    * @return int
    */
	function RecordCount(){
	   return $this->fRecCount;
	}

   /**
    * Devolve o ndice do registro corrente.
    * @return int
    */
   function RecNo(){
	   if ($this->fActive){
	      return $this->fRecno;
	   }else{
	      return false;
	   }
	}

   /**
    * Navegao
    * Possiciona o ponteiro de leitura no registro indicado.
    *
    * @param int $recnum
    * @return boolean
    * retorna true/false para sucesso/falha.
    */
   function GotoRecNo($recnum){
	   if ($this->_HaveData()){
          if ($recnum >= $this->fRecCount) {
	         $this->fSide = 2;
             $recnum = $this->fRecCount-1;
		  }else if ($recnum < 0) {
	         $this->fSide = 0;
		     $recnum = 0;
		  }else{
	         $this->fSide = 1;
		  }

		  mysql_data_seek($this->fRS, $recnum);
		  $this->_LoadRec();
		  $this->fRecno = $recnum;
       }else{
	      $this->fSide = 0;
	      return false;
	   }
      return true;
	}

   /**
    * Navegao
    * Move o ponteiro de leitura para o primeiro registro.
    */
	function First(){
	   $this->GotoRecNo(0);
	}

   /**
    * Navegao
    * Move o ponteiro de leitura para o ultimo registro.
    */
	function Last(){
	   $this->GotoRecNo($this->fRecCount-1);
	}

   /**
    * Navegao
    * Move o ponteiro de leitura para o prximo registro
    */
   function Next(){
	   $this->GotoRecNo($this->fRecno + 1);
	}

   /**
    * Navegao
    * Move o ponteiro de leitura para o registro anterior
    */
   function Prior(){
	   $this->GotoRecNo($this->fRecno - 1);
	}

   /**
    * Devolve o valor de um campo do registro corrente
    *
    * @param string $fieldname Nome do campo
    * @return mix
    */
   function FieldValue($fieldname){ //r:db
	   if ($this->_HaveData()){
		  if (array_key_exists($fieldname,$this->fBuffer)) {
		     return $this->fBuffer[$fieldname];
		  }else{
		     return "";
		  }
	   }else{
         return "";
	   }
	}

   /**
    * Idem a GetBuffer()
    * @return array
    */
   function GetARecord(){
	   if ($this->_HaveData()){
	     return $this->fBuffer;
	   }else{
         return false;
	   }
	}

   /**
    * Devolve uma lista com os nomes dos campos retornados pela pesquisa atual.
    *
    * @return array
    */
   function GetFieldNames(){
	   if ($this->_HaveData()){
         unset($this->fBuffer["ZKU23SRS52_723876"]);
	     return array_keys($this->fBuffer);
	   }else{
         return array();
	   }
	}

   /**
    * Retorna o nmero de campos retornados pela pesquisa atual.
    * @return int
    */
	function FieldCount() {
	   if ($this->_HaveData()){
	     return count($this->fBuffer);
	   }else{
         return false;
	   }
	}

   /**
    * Devolve um array contendo a descrio do campo solicitado.
    *
    * @param string $fieldname Nome do campo
    * @return array
    * <b><i>ndices do array:</i></b> <br><br>
    * <b>table</b> - a tabela a qual o objeto pertence.      <br>
    * <b>max_length</b> - o limite de tamanho da coluna.     <br>
    * <b>not_null</b> - 1 se a coluna no puder ser NULL.    <br>
    * <b>primary_key</b> - 1 se a coluna  a chave primria. <br>
    * <b>unique_key</b> - 1 se a coluna  a chave nica.     <br>
    * <b>multiple_key</b> - 1 se a coluna  uma chave no-nica. <br>
    * <b>numeric</b> - 1 se a coluna  numrica.             <br>
    * <b>blob</b> - 1 se a coluna  um BLOB.                 <br>
    * <b>type</b> - o tipo da coluna.                        <br>
    * <b>unsigned</b> - 1 se a coluna  sem sinal.           <br>
    * <b>zerofill</b> - 1 se a coluna  prenchida com zero.  <br><br>
    */
   function FieldDef($fieldname){
	   if ($this->_HaveData()){
		  if (array_key_exists($fieldname,$this->db_fieldDef)) {
		     return $this->db_fieldDef[$fieldname];
		  }else{
		     return array();
		  }
	   }else{
         return array();
	   }
	}

    /*
	   Metodos para modo paginado
	*/

	/**
    * Total geral de registros (todos os registros de todas as pginas)
    * retornados pela pesquisa.
    * @return int
    */
   function PgRecordCount(){
	  if ($this->paginado) {
	     return $this->fAllRecCount;
	  }else{
	     return $this->fRecCount;
	  }
	}

   /**
    * Total de paginas retornada pela pesquisa.
    * @return int
    */
   function PageCount(){
	   return $this->fPageCount;
	}

   /**
    * Retorna o nmero de ordem real do primeiro registro da pgina
    * corrente da consulta. O nmero de ordem do registro corresponde
    * a posiao sequencial do registro conforme a  ordem definida na
    * clausula ORDER BY (se houver).
    *
    * @return int
    */
	function PgStartRecord(){
	   return $this->fRecIni;
	}

	//r: Data 28/05/2008 - Envia um DeltaPackage para aplicaes desktop
	//r: ver o_mysqlquery.txt
	//r: encriptMode pode ser: 1 - SoftEncode, 2 Soft encode + Hex, 3 - S Hex
	function SendDelta($field_Sep,$rec_sep,$encriptMode = 2,$direct = true){
       if ($encriptMode < 2 || $encriptMode > 3){
          $encriptMode = 2;
       }

       if (empty($rec_sep) || $rec_sep == "!CRLF"){
          $rec_sep = "\n\t";
       }

       if (empty($field_Sep) || $field_Sep == "!TAB"){
          $field_Sep = "!".chr(9);
       }

       //r: Obtem a estrutura do resultset
       $aNomes = $this->GetFieldNames();
       $struc = array();
       foreach($aNomes as $k => $fnome){
          $fd = $this->db_fieldDef[$fnome];
          $linha  = "name=$fnome|type=$fd[type]|table=$fd[table]|blob=$fd[blob]|numeric=$fd[numeric]|";
          $linha .= "size=$fd[max_length]|unsign=$df[unsigned]|fill=$fd[zerofill]|pk=$fd[primary_key]|";
          $linha .= "uk=$fd[unique_key]|mk=$fd[multiple_key]|notNull=$fd[not_null]";
          // r: codificao
          $struc[] = encodeString($linha,$encriptMode);
       }

       //r: monta linha de header
       $sc = count($struc)+1;
       $fc = count($aNomes);
       $rc = $this->RecordCount();
       $err = $this->lastError;
       $errNum = (empty($err))? 0:1;
       $linha_zero = "strCount=$sc|fieldCount=$fc|recordCount=$rc|rowsaffect=$rc|errNum=$errNum|errStr=$err";
       //r: codifica a linha do header
       $linha_zero = encodeString($linha_zero,$encriptMode);

       //r: prepara pacote de retorno
       //r: Header e struct
       $buff = $linha_zero . $rec_sep;
       $i = 0; $j = count($struc)-1;
       foreach($struc as $k => $v){
          $buff .= $v;
          if ($i < $j){
             $buff .= $rec_sep;
          }
          $i += 1;
       }

       //r: Colocar a quebra de linha somente se houver pelomenos 1 registro a retornar
       if ($rc > 0){
          $buff .= $rec_sep;
       }

       //r: Dados
       while (!$this->Eof()){
          $linha = "";
          $i = 0;  $j = count($this->fBuffer)-1;
          //r: monta linha do resultset
          foreach($this->fBuffer as $k => $fv){
             //r: criptografa valor de cada campo
             $fv = encodeString($fv,$encriptMode);
             $linha .= $fv;
             if ($i < $j){
                $linha .= $field_Sep;
             }
             $i += 1;
          }
          $this->Next();
          //r: adiciona o novo registro (linha)
          if (!empty($linha)){
             $buff .= $linha;
             if (!$this->Eof()){
                $buff .= $rec_sep;
             }
          }
       }

       if ($direct){
          echo "\r\n<!--\r\n",$buff,"\r\n-->\r\n";
       }else{
          return "\r\n<!--\r\n$buff\r\n-->\r\n";
       }
    }

  } //r: Classe uMySQLQuery

  /**
   * Controle de navegao.
   * Fornece os links poara navegao para consultas paginadas.
   *
   */
  class uDbNavigator extends uObject {
    /**
     * Objeto de pesquisa ao qual o navegador se ligar
     * @var uMySQLQuery
     */
	 var $query;
    /**
     * Determina se a navegao utilizar links remotos.
     * Quando ativo o navegador poder apontar seus links para outro script
     * definido na propriedade 'url' (por exemplo quando utilizando ajax).
     *
     * @var boolean default false
     *
     */
	 var $remoteLink;
    /**
     * Nome do parametro (campo na url) que informar o nmero da pfina.
     * @var string Default 'pgn'
     */
	 var $paramName;
    /**
     * Designer.  Nome de classe css para links (opcional).
     * Define o valor do atributo class para os links numerados da barra
     * de navegao, permitindo a adequao ao padro visual definido pelo
     * designer.
     * @var string
     */
    var $lnkClass;
    /**
     * Numero mximo de links numerados a serem inseridos na barra de navegao
     * @var int Default 20
     */
    var $linkBarPages; //r: Nmero mximo de pginas a relacionar na barra de links (tipo google)
    /**
     * Url alternativo para links quando o script alvo no  o script atual
     * (por exemplo se as consultas estiverem sendo geradas via ajax)
     * @var string
     */
    var $url;          //r: URL alternativa para chamadas redirecionadas  (adicionado em 13/03)
    var $queryString;  //r: Query string opcional para chamadas redirecionadas (adicionado em 13/03)
    var $navBarTag;    //r: Tags opcionais para barra de navegao numerada
    var $navBarTagSelClass; //r: Classe (css) a ser adicionada a pagina selecionada na barra de navegao

	 //r: Private
	 var $extraQS;
    var $aimages;    //r: Array contedo lista de imagens para links (opcional)
    function uDbNavigator() {
	     $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uDbNavigator";
	     $classPath = (func_num_args() > 1)?  "uDbNavigator.".func_get_arg(1):"uDbNavigator";

		  $this->uObject($name,$classPath); //r: inherited
		  $this->query = false;
		  $this->paramName = "pgn";
		  $this->lnkClass  = "";
		  $this->extraQS   = "";
		  $this->url       = "";        //r: usrl do requisitante (remoto)
		  $this->queryString  = "";     //r: query string do requisitante (remoto)
		  $this->linkBarPages = 20;
		  $this->remoteLink   = false;  //r: trabalhar com link remoto

        $this->navBarTag        = "";  // nome da tag sem os demarcadores '<>' (p.ex: 'li')
        $this->navBarTagSelClass = "";  // Nome da classe css para pagina selecionada

		  $this->aimages["first"] = array("enabled" => "","disabled"=>"");
		  $this->aimages["last"]  = array("enabled" => "","disabled"=>"");
		  $this->aimages["prior"] = array("enabled" => "","disabled"=>"");
		  $this->aimages["next"]  = array("enabled" => "","disabled"=>"");

	}

    function _GetLink($pgNum){
	   $result = (!$this->remoteLink)? $_SERVER["PHP_SELF"] : $this->url;
	   $pName  = $this->paramName;

	   $newParams = array();
	   array_push($newParams, "$pName=$pgNum");

      $QSTR = (!$this->remoteLink)? $_SERVER['QUERY_STRING'] : $this->queryString;
	   if (!empty($QSTR)) {
		  $params = explode("&", $QSTR);
		  foreach ($params as $param) {
			if (stristr($param, $pName) == false) {
			  array_push($newParams, $param);
			}
		  }
	   }
	   if (count($newParams) != 0) {
		  $result .= "?" . htmlentities(implode("&", $newParams));
	   }

	   if (!empty($this->extraQS)){
         $result .= (strpos($result,"?") !== false)? "&":"?";
		   $result .= $this->extraQS;
	   }
	   return $result;
	}

    function _GetLnkClass(){
	   return (empty($this->lnkClass))? "":' class="'.$this->lnkClass.'"';
	}

    //r: Adicionar parmetros extras na URL
    function AddQueryStringParam($s){
	   $this->extraQS = $s;
	}

    //r: adiciona um par de imagens para link de navegao, ex: $obj->AddLnkImage("first",array("seta1_enabled.jpj","seta1_disabled.jpg"));
	//r: $lnk = ("first","prior","next","last")
	function AddLnkImage($lnk,$aLista){
	   if (array_key_exists($lnk,$this->aimages)){
	      $this->aimages[$lnk]["enabled"]  = $aLista[0];
	      $this->aimages[$lnk]["disabled"] = $aLista[1];
	   }
	}

    function LnkFirst(){
	   if ($this->query->currentPage > 1) {
	      return $this->_GetLink(1);
	   }else{
	      return "#";
	   }
	}

    function HrefFirst(){
	   $r = $this->LnkFirst();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}
    function LnkLast(){
	   if ($this->query->currentPage < $this->query->PageCount()) {
	       return $this->_GetLink($this->query->PageCount());
	   }else{
	      return "#";
	   }
	}
    function HrefLast(){
	   $r = $this->LnkLast();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function LnkPrior(){
	   if ($this->query->currentPage > 1) {
	      return $this->_GetLink($this->query->currentPage - 1);
	   }else{
   	      return "#";
	   }
	}
    function HrefPrior(){
	   $r = $this->LnkPrior();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function LnkNext(){
	   if ($this->query->currentPage < $this->query->PageCount()) {
	      return $this->_GetLink($this->query->currentPage + 1);
	   }else{
   	      return "#";
	   }
	}
    function HrefNext(){
	   $r = $this->LnkNext();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function LnkToPage($npage){
	   if (($npage > 0) && ($npage <= $this->query->PageCount() )) {
	      return $this->_GetLink($npage);
	   }else{
   	      return "#";
	   }
	}
    function HrefToPage($npage){
	   $r = $this->LnkToPage($npage);
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function getLinkBarTag($start,$selected=false){
        if (empty($this->navBarTag)){
            return "";
        }else{
            $tg   = $this->navBarTag; $css = "";
            if ($selected && !empty($this->navBarTagSelClass)){
                $css  = ' class="'.$this->navBarTagSelClass.'"';
            }
            if ($start){
               return " <$tg"."$css>";
            }else{
               return "</$tg> ";
            }
        }
    }

    function GetNavArray(){
	   $result = array();
       $result["lnk_first"]   = "";  //r: Primeira pgina
	   $result["lnk_first_f"] = "";  //r: Fecha tag
	   $result["lnk_prior"]   = "";  //r: Pagina anterior
	   $result["lnk_prior_f"] = "";  //r: Fecha tag
	   $result["lnk_next"]    = "";  //r: Proxima Pagina
	   $result["lnk_next_f"]  = "";  //r: Fecha tag
	   $result["lnk_last"]    = "";  //r: Ultima Pagina
	   $result["lnk_last_f"]  = "";  //r: Fecha tag

	   $result["current_page"] = $this->query->currentPage;    //r: Pagina corrente
	   $result["page_count"]   = $this->query->PageCount();    //r: Total de pginas possiveis
	   $result["start_rec"]    = $this->query->PgStartRecord(); //r: nmero real do registro inicial da pagina
	   $result["last_rec"]     = $this->query->PgStartRecord() + (($this->query->RecordCount() > 0)? $this->query->RecordCount()-1:0);
	   $result["record_count"] = $this->query->PgRecordCount(); //r: Total geral de registros (todas as paginas)
	   $result["page_records"] = ($this->query->paginado)? $this->query->limit:"Todos";

       if ($this->query->RecordCount() > 0){
	      $result["start_rec"]    += 1;
	      $result["last_rec"]     += 1;
       }

	   //r: Monta os links
	   $aux = $this->HrefFirst();
	   if (!empty($aux)){ $result["lnk_first"] = $aux; $result["lnk_first_f"] = "</a>";}
       $aux = $this->HrefLast();
	   if (!empty($aux)){ $result["lnk_last"] = $aux; $result["lnk_last_f"] = "</a>";}
       $aux = $this->HrefPrior();
	   if (!empty($aux)){ $result["lnk_prior"] = $aux; $result["lnk_prior_f"] = "</a>";}
       $aux = $this->HrefNext();
	   if (!empty($aux)){ $result["lnk_next"] = $aux; $result["lnk_next_f"] = "</a>";}

       //r: Relaciona as imagens correspondetes
       $result["img_first"] = empty($result["lnk_first"])? $this->aimages["first"]["disabled"]:$this->aimages["first"]["enabled"];
	   $result["img_last"]  = empty($result["lnk_last"])?  $this->aimages["last"]["disabled"]:$this->aimages["last"]["enabled"];
	   $result["img_prior"] = empty($result["lnk_prior"])? $this->aimages["prior"]["disabled"]:$this->aimages["prior"]["enabled"];
	   $result["img_next"]  = empty($result["lnk_next"])?  $this->aimages["next"]["disabled"]:$this->aimages["next"]["enabled"];

      //r: Monta link bar
      $this->linkBarPages = ($this->linkBarPages >= 3)? $this->linkBarPages:20;

      $cr  = $result["current_page"];
      if ($result["page_count"] > $this->linkBarPages){
          if ($result["current_page"] == $result["page_count"]){
             $pg = $cr - $this->linkBarPages;
             $pgf = $cr;
          }else{
              if ($this->linkBarPages > 2){
                  $meio = (int) ($this->linkBarPages / 2);
              }else{
                 $meio = 1;
              }

              $pg  = ($cr > $meio)?  ($cr-$meio):1;
              $pgf = $pg + $this->linkBarPages;

              if ($pgf > $result["page_count"]){
                 $pgf = $result["page_count"];
              }
          }
      }else if ($result["page_count"] == 1){
         $pg = 1; $pgf = 1;
      }else if ($result["page_count"] < 1){
         $pg = 1; $pgf = 0;
      }else{
         $pg = 1; $pgf = $result["page_count"];
      }

      $x1 = $pgf - $pg;
      if ($x1 < ($this->linkBarPages+1)){
         $pg = $pgf - $this->linkBarPages;
         if ($pg < 1){ $pg= 1; }
      }

      if ($pg > 1){
         $b = $this->getLinkBarTag(true,true);
         $f = $this->getLinkBarTag(false);
         $link_bar = "$b...$f ";
      }else{
         $link_bar = "";
      }

      while ($pg <= $pgf){
        if ($pg != $cr){
           $b = $this->getLinkBarTag(true);
           $f = $this->getLinkBarTag(false);
           $lnk = $this->LnkToPage($pg);
           if ($lnk != "#"){
              $link_bar .= $b.' <a href="'.$lnk.'">'."$pg</a> $f";
           }
        }else{
           $b = $this->getLinkBarTag(true,true);
           $f = $this->getLinkBarTag(false);
           $link_bar .= "$b [$pg] $f";
        }
        $pg++;
      }
      if ($pgf < $result["page_count"]){
         $b = $this->getLinkBarTag(true,true);
         $f = $this->getLinkBarTag(false);
         $link_bar .= "$b...$f";
      }

      $result["link_bar"] = $link_bar;

      return $result;
	}


  } //r: classe uDbNavigate
?>
