<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2009 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 27/11/2009
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/objects.php"); 
  /*{$NC-}*/
  /*{$CB+}
  uses("objects");
  {$CB-}*/
  
  
  /*
    FieldType
    ---------

    exp		      Expresso - qualquer expresso SQL vlida

    text,
    string		   Campos TEXT,CHAR,VARCHAR

    long,
    int,
    integer		   Campos INT

    currency,
    double,
    real		     Campos DECIMAL/DOUBLE

    date		     Campos DATE/TIME/TIMESTAMP
  */

  class uPostgreSql extends uObject {
	 var $conexao;              //r: identificador de conexo
	 var $lastID;               //r: ID do ultimo registro inserido (campo autoinc) 
	 var $lastError;            //r: Descrio do ultimo erro ocorrido
	 var $table;                //r: nome da tabela
	 var $command;              //r: Comando a ser executado ("INSERT","UPDATE","DELETE")
     var $where;                //r: Restries da clausula Where
	 var $fFieldDef;            //r: Definicoes dos campos no banco de dados
	 var $sqlCheck;             //r: Ultima SQL executada (para depuracao)
     var $preSQL;               //r: SQL de consulta para retorno de linhas afetadas
	 var $NoUpdateFields;       //r: Lista dos campos relacionados que no entram no update (chaves primrias)
	 var $OnEmptyDate;          //r: Evento OnEmptyDate(obj,FieldName,FieldValue)  disparado sempre que uma data  gravada vazia,zerada ou NUL
	 
	 //r: Private
	 var $CallOnEmptyDate;            //r: Flag interno (boolean) define se o evento OnEmptyDate deve ser chamado apos um processo
	 
    function uPostgreSql() {
		 $cn = "uPostgreSql";
	     $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-$cn";
	     $classPath = (func_num_args() > 1)?  "$cn.".func_get_arg(1):$cn;

		 $this->uObject($name,$classPath); //r: inherited

		 $this->conexao   = -1;
		 $this->command   = "";
		 $this->lastError = "";
		 $this->where     = "";
         $this->table     = "";
         $this->fFieldDef = array();
		 $this->sqlCheck  = "";
		 $this->lastID    = 0;
		 $this->preSQL    = "";
		 $this->NoUpdateFields = array();
		 $this->OnEmptyDate = "";
		  
		 $this->CallOnEmptyDate = "N";
    }

    function Renew(){
		  $this->command   = "";
		  $this->lastError = "";
		  $this->where     = "";
          $this->table     = "";
          $this->fFieldDef = array();
		  $this->sqlCheck  = "";
		  $this->lastID    = 0;
		  $this->preSQL    = "";
		  $this->NoUpdateFields = array();
	}

    function Clear(){
	     unset($this->fFieldDef);
	     $this->fFieldDef = array();
	}

    //r: METODO - Executa um SQL genrico ou script
    function ExecSQL($SQL){
	   $r = pg_query($SQL, $this->conexao);
       if (!$r){
          $this->lastError = pg_last_error($this->conexao);
       }
       return !($r===false);
    }

    function _DisabledField($fieldName){
	   if (count($this->NoUpdateFields) < 1){
	      return false;
	   }else{
	     reset($this->NoUpdateFields);
	     $result = false;
	     foreach($this->NoUpdateFields as $k => $v){
		    if ($fieldName == $v) {
			   $result = true;
			}
		 }
		 return $result;
	   }
	}

   function _IsZeroDate($v){
      $vi = str_replace(Array("NULL"," ","/","-","0","'"),"",$v);
      if (empty($vi)){
         return true;
      }else{
         return false;
      }
   }
   
   //r: Checa constraints de montagem da sql prevenindo gravaes de valores nao aceitaveis
   function _checkConstraint($fnome,$fv){
      if ($this->CallOnEmptyDate == "S"){
         if (!empty($this->OnEmptyDate)){
            $cmd = $this->OnEmptyDate . '($this,$fnome,$fv);';
            eval($cmd);
         }
         $this->CallOnEmptyDate = "N";
      }
   }
   
   function _ValidFieldType($tipo){
	   $result = false;
	   switch ($tipo) {
		   case "exp" :
		   case "text" :
		   case "string" :
		   case "long" :
		   case "int" :
		   case "integer" :
		   case "real" :
		   case "double" :
		   case "date" :
			    $result = true;
		        break;
	   }
       return $result;
	}
  
	function _GetSQLValStr($theValue, $theType, $theDefinedValue = "", $theNotDefinedValue = "") 
	{
		$theValue = (!get_magic_quotes_gpc()) ? addslashes($theValue) : $theValue;
		
		switch ($theType) {
		case "exp" :
		  $theValue = ($theValue != "") ? $theValue : "NULL";
		  break;
		case "text":
		case "string":
		case "date":
		  $theValue = ($theValue != "") ? "'" . $theValue . "'" : "NULL";
		  break;    
		case "long":
		case "int":
		case "integer":
		  $theValue = ($theValue != "") ? intval($theValue) : "NULL";
		  break;
		case "currency":
		case "double":
		case "real":
		  $theValue = ($theValue != "") ? doubleval($theValue) : "NULL";
		  break;
		case "date_":
        $dvzn = $this->_IsZeroDate( $theValue );
        if (!empty($this->OnEmptyDate)){
           if ( $dvzn ){
              $this->CallOnEmptyDate = "S";
           }
        }
        //r: esta com um bug aqui por isso o bloco foi desativado
		  $theValue = ($dvzn === true) ? "'" . $theValue . "'" : "NULL";
		  break;
		case "defined":
		  $theValue = ($theValue != "") ? $theDefinedValue : $theNotDefinedValue;
		  break;
		}
	    return $theValue;
	}

    function _GerRowsAfec(){
	   $result = 0;
	   $SQL = "SELECT COUNT(0) AS nrows FROM $this->table";
	   if (!empty($this->where)){
	      $SQL .= " WHERE $this->where";
	   }
      $this->preSQL = $SQL;
      $rs = pg_query($SQL,$this->conexao);
	   if (($rs !== false) && ($rec = pg_fetch_assoc($rs))) {
	      $result = $rec["nrows"];
	   }
	   pg_free_result($rs);
	   return $result;
	}

    //r: Reduz tamanho das tabelas liberando espao dos registros excluidos
    function _PackTable() {
	    $tmp_tab  = "tmp_" . $this->table;
		$orig_tab = $this->table;
		$old_tab  = $this->table . "_old";
        $result = 0;   //r: Nenhum erro processo ok

		$SQL_1 = "CREATE TABLE $tmp_tab SELECT * FROM $orig_tab";
		$SQL_2 = "RENAME TABLE $orig_tab TO $old_tab, $tmp_tab TO $orig_tab";
		$SQL_3 = "DROP TABLE $old_tab";

		//r: 1 - Cria nova tabela
		$r = pg_query($SQL_1, $this->conexao);
		if (!$r){
		   $result = 1;   //r: Create Error
		}else{
		   //r: Renomeia tabelas
           $r = pg_query($SQL_2, $this->conexao);
		   if (!$r){
		      $result = 2;   //r: Rename Error
		   }else{
		      $r = pg_query($SQL_3, $this->conexao);
			  if (!$r){
		         $result = 3;   //r: DROP Error
			  }
		   }
		}
        if ($result > 0){ $this->lastError = pg_last_error($this->conexao); }
		return $result;
	}

    function AddFieldVal($field_name,$field_type,$value){
       $field_type = strtolower($field_type);
	   if ($this->_ValidFieldType($field_type)){
          $this->fFieldDef[$field_name] = array("valor" => $value, "tipo" => $field_type);
	      return true;
	   }else{
		  $this->lastError = "Tipo de campo invlido '$field_type'";
	      return false;
	   }
	} 

    function SetFieldValue($field_name,$value){
	  if (array_key_exists($field_name,$this->fFieldDef)){
	     $tmp = $this->fFieldDef[$field_name];
		 $tmp["valor"] = $value;
		 $this->fFieldDef[$field_name] = $tmp;
	     return true;
	  }else{
	    return false;
	  }
	}

    function Execute(){
	   if (empty($this->table)){
	      $this->lastError = "Nome da tabela no informado !";
		  return false;
	   }else{
		   $this->command = strtoupper($this->command);
		   $result = true;
		   switch ($this->command){
			 case "INSERT"  :
               $flds = ""; $fval = "";
			      foreach($this->fFieldDef as $fnome => $finfo){
                   $flds = (empty($flds))?  $fnome: "$flds,$fnome";
				       $fv   = $this->_GetSQLValStr($finfo["valor"],$finfo["tipo"]);
				       $this->_checkConstraint($fnome,$fv);
                   $fval = (empty($fval))?  $fv: "$fval,$fv";
			      }
				   $SQL  = "INSERT INTO $this->table ($flds) VALUES ($fval)";
				   $this->sqlCheck = $SQL;
			     $r = pg_query($SQL, $this->conexao);
				  if ($r === false){
					 $this->lastError = pg_last_error($this->conexao);
				    $result = false;
				  }else{
					 $this->lastID = pg_insert_id($this->conexao);
					 $result = true;
				  }
				  break;
			case "UPDATE"  :
				  $ra = $this->_GerRowsAfec();
				  $SQL  = "UPDATE $this->table SET ";
			     $flds = "";
			     foreach($this->fFieldDef as $fnome => $finfo){
				 	 if (!$this->_DisabledField($fnome)) {
					    $fv  = $this->_GetSQLValStr($finfo["valor"],$finfo["tipo"]);
					    $this->_checkConstraint($fnome,$fv);
				        $flds = empty($flds)? "":"$flds,";
					    $flds .= "$fnome = $fv";
					 }
				  }
				  $SQL .= $flds . " ";
				  if (!empty($this->where)){
				     $SQL .= "WHERE $this->where";
				  }
				  $this->sqlCheck = $SQL;
			     $r = pg_query($SQL, $this->conexao);
				  if ($r === false){
					 $this->lastError = pg_last_error($this->conexao);
				    $result = false;
				  }else{
					 $result = $ra;
				  }
				  break;
			case "DELETE"  :
				  $ra = $this->_GerRowsAfec();
				  $SQL  = "DELETE FROM $this->table";
			     if (!empty($this->where)){
					 $SQL  .= " WHERE $this->where";
				  }
				  $this->sqlCheck = $SQL;
			     $r = pg_query($SQL, $this->conexao);
				  if ($r === false){
					 $this->lastError = pg_last_error($this->conexao);
				    $result = false;
				  }else{
					$result = $ra;
				  }
				  break;
			case "PACK" :
				  $result = $this->_PackTable();
				  break;
			case "EMPTY" :
				  $ra = $this->_GerRowsAfec();
				  $SQL  = "TRUNCATE $this->table";
				  $this->sqlCheck = $SQL;
			     $r = mysql_query($SQL, $this->conexao);
				  if ($r === false){
					 $this->lastError = pg_last_error($this->conexao);
				    $result = false;
				  }else{
					 $result = $ra;
				  }
				  break;
			 default :
			     $this->lastError = "Comando no suportado '$this->command'";
			     $result = false;
		   }
	      return $result;
	   }
	}

  } //r: Classe
?>
