<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004 

	  Analizador XML
	      L dados de arquivos XML de estrutura simples
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/objects.php"); 
  /*{$NC-}*/
  /*{$CB+}
  uses("objects");
  {$CB-}*/


  //r: require_once($lib_path."/lib_misc.php"); 

  class uXMLRecord {
        var $tag;
        function uXMLRecord($a_values){$this->tag = $a_values;}
  }


  class uXMLReader extends uObject {
	  var $a_dados;
      var $position;
	  var $FieldNames;

      /*
	    Oparmetro $reg_nome indica o nome da tag correspondente ao registro a ser lido.
		a classe s finciona para tabelas simples (1 nivel)
	  */
	  function uXMLReader($fileName,$reg_nome){
	      $name      = (func_num_args() > 2)?  func_get_arg(2):"nonamed-uXMLReader";
	      $classPath = (func_num_args() > 3)?  "uXMLReader.".func_get_arg(3):"uXMLReader";

		  $this->uObject($name,$classPath); //r: inherited

		  $this->a_dados    = array();
		  $this->FieldNames = array();
		  $this->position = -1;
		  $this->_Open($fileName,$reg_nome);
		  if (count($this->a_dados) > 0){ $this->position = 0; }
	  }


      function _AddFieldName($fname){
	     if (!in_array($fname,$this->FieldNames)){
		    $this->FieldNames[] = $fname;
		 }
	  }

	  function _Open($filename,$reg_nome) {
		//r: l o arquivo XML
		$data = implode("", file($filename));
		$parser = xml_parser_create();
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parse_into_struct($parser, $data, $values, $tags);
		xml_parser_free( $parser );
		//r: percorre a estrutura identificando o registros desejados ($rec_id)
		$rec = array(); $ropen = false; $rnivel = -1;
		foreach ($values as $key=>$val) {
			if ($val["tag"] == $reg_nome && $val["type"] == "open") {
				$ropen = true;
				$rnivel = $val["level"]+1; 
			}else if ($val["tag"] == "$reg_nome" && $val["type"] == "close"){
                $ropen = false;
				$rnivel = -1;
				array_push($this->a_dados,$rec);
				$rec = array();
			}else if ($ropen && $val["type"] == "complete" && $rnivel === $val["level"]){
				$this->_AddFieldName($val["tag"]);
				if (array_key_exists("value",$val)){
                   $rec[$val["tag"]] = @$val["value"];
				}
			}
		}

        if ( count($this->a_dados) > 0){ 
			$this->position = 0;
			$this->EBOF  = 1;
		}
	  }

      function FieldValue($fieldName){
	     if ($this->position != -1){
			if ( array_key_exists($fieldName,$this->a_dados[$this->position]) ){
   		       return $this->a_dados[$this->position][$fieldName];
			}else{
			   return "";
			}
		 }else{ 
		   return "";
		 }
	  }

      function FieldCount(){
	     return count($this->FieldNames);	   
	  }

	  function First(){
	      if (count($this->a_dados) > 0){
		     $this->position = 0;
			 $this->EBOF     = 1;
		  }
	  }

	  function Next(){
	      if (count($this->a_dados) > 0){
		     if ($this->position < count($this->a_dados)){
				 $this->position += 1;
			 }
		  }
	  }

	  function Prior(){
	      if (count($this->a_dados) > 0){
		     if ($this->position > 0){
				 $this->position -= 1;
			 }
		  }
	  }

	  function Last(){
	      if (count($this->a_dados) > 0){
			 $this->position = count($this->a_dados) - 1;
		  }
	  }

	  Function Bof(){
	      if (count($this->a_dados) > 0){
			 return ($this->position == 0);
		  }else{
		     return true;
		  }
	  }

	  Function Eof(){
	      if (count($this->a_dados) > 0){
			 return ($this->position >= count($this->a_dados));
		  }else{
		     return true;
		  }
	  }

      function RecNo(){
	     return $this->position;
	  }

      Function RecordCount(){
	     return count($this->a_dados);
	  }

	  function GoTo($recNo){
	     if ($recNo >= 0 && $recNo < count($this->a_dados)){ $this->position = $recNo; }
	  }
  }
?>